'' Common Module for PSLCheckAccessKeys.bas
'' (c) 2009-2019 by wanfu (Last modified on 2019.09.20

Option Explicit

Public Const Version = "2019.08.30"
Public Const Build = "190830"
Public Const ToUpdateCheckVersion = "2019.05.20"
Public Const MacroLoc = Left$(MacroDir,InStrRev(MacroDir,"\") - 1)
Public Const CheckRegKey = "HKCU\Software\VB and VBA Program Settings\AccessKey\"
Public Const CheckFilePath = MacroLoc & "\Data\PSLCheckAccessKeys.dat"
Public Const JoinStr = vbFormFeed  'vbBack
Public Const SubJoinStr = vbVerticalTab  'Chr$(1)
Public Const LngJoinStr = "|"
Public Const SubLngJoinStr = Chr$(1)
Public Const NullValue = "Null"
Public Const ConvertStrHexRange = "\x30-\x39,\x41-\x46;\x30-\x39,\x41-\x46;\x30-\x37"
			'0=ʮת,1= Unicode ת,2=ڰ˽ת
Public Const CheckStrHexRange = "\x00-\x07,\x0E-\x1F;" & _
								"\x00-\x40,\x5B-\x60,\x7B-\xBF;" & _
								"\x00-\x60,\x7B-\xBF;" & _
								"\x00-\x40,\x5B-\xBF;" & _
								"\x41-\x5A,\x61-\x7A;" & _
								"\x30-\x39,\x41-\x5A,\x61-\x7A;" & _
								"\x30-\x39,\x41-\x46"
			'0=ַ,1=ȫΪֺͷ,2=ȫΪдӢ,3=ȫΪСдӢ,4=СдӢ,5=ݼַΧ,6=ʮַ
Public Const DefaultObject = "Microsoft.XMLHTTP;Msxml2.XMLHTTP"
Public Const AppName = "PSLCheckAccessKeys"
Public Const DefaultWaitTimes = 2    '2

'
Public Type LANG_SET
	Name		As String	'
	PslCode		As String	'PSL Դ
	UseCode		As String	'Դ/ʹõĴ
End Type

'
Public Type CHECK_SET
	Name				As String		'
	AccKeyExcludeChar	As String		'Ҫųķǿݼַ
	CheckBracket		As String		'ҪĿݼǰҺ
	KeepCharPair		As String		'ҪĿݼǰ
	ShowAsiaKey			As Integer		'ʾԷʽĿݼ
	CheckEndChar		As String		'ҪĽ
	NotTrnEndChar		As String		'ҪĽ
	AutoTrnEndChar		As String		'ҪԶĽ
	CheckShortChar		As String		'Ҫļַ
	CheckShortKey		As String		'Ҫļ־
	KeepShortKey		As String		'Ҫļַ
	PreRepStr			As String		'ǰҪ滻ַ
	AppRepStr			As String		'Ҫ滻ַ
	AccKeyChar			As String		'ҪĿݼ־
	AccKeyWithFirstChar	As Integer		'Ƿִ׸ǿհַΪݼַ
	LineSplitMode		As Integer		'ִģʽ
	PreInsertSplitChar	As String		'ǰʽַ
	AppInsertSplitChar	As String		'ʽַ
	ReplaceSplitChar	As String		'滻ʽַ
	LangPairList()		As LANG_SET		'
End Type

'鷽
Public Type CHECK_PROJECT_SET
	Name				As String		'鷽
	PreSpaceInSource	As Integer		'ԭʼִеǰÿո
	PreSpaceInTarget	As Integer		'鷭ִеǰÿո
	PreSpaceInBoth		As Integer		'ԭʼͷִжڵǰÿո
	EndSpaceInSource	As Integer		'ԭʼִеĺÿո
	EndSpaceInTarget	As Integer		'鷭ִеĺÿո
	EndSpaceInBoth		As Integer		'ԭʼͷִжڵĺÿո
	AcckeyInSource		As Integer		'ԭʼִеĿݼ
	AcckeyInTarget		As Integer		'鷭ִеĿݼ
	AcckeyInBoth		As Integer		'ԭʼͷִжڵĿݼ
	EndStrInSource		As Integer		'ԭʼִеĽ
	EndStrInTarget		As Integer		'鷭ִеĽ
	EndStrInBoth		As Integer		'ԭʼͷִжڵĽ
	ShortcutInSource	As Integer		'ԭʼִеļ
	ShortcutInTarget	As Integer		'鷭ִеļ
	ShortcutInBoth		As Integer		'ԭʼͷִжڵļ
	DelSpace			As Integer		'ɾݼֹǰĿո
	EnableStrSplit		As Integer		'ִֹ
	TranEndStr			As Integer		'Զ
	UseAcckeyInShortcut	As Integer		'ʹýеַΪݼ
	ShowOriginalTran	As Integer		'Ϣʱͬʱԭʼִ
	ApplyCheckResult	As Integer		'޸ķִ
	SpaceForEnAndAsia	As Integer		'Ӣĺ֮ĿոҪһո
End Type

'
Public Type STRING_INFO_SUB
	sString		As String	'ִ
	Loction		As Integer	'ִڸִĿʼλ
	Length		As Integer	'ִַ
	IFR			As String	'ַ
	Key			As String	'ַ
End Type

Public Type STRING_INFO
	Length					As Integer			'ַַ
	LineNum					As Integer			'ַ
	AccKeyNum				As Integer			'ַݼ
	ShortcutNum				As Integer			'ַ
	PreSpace				As STRING_INFO_SUB	'ַǰÿո
	EndSpace				As STRING_INFO_SUB	'ַÿո
	AccKey					As STRING_INFO_SUB	'ַݼ
	Shortcut				As STRING_INFO_SUB	'ַ
	EndString				As STRING_INFO_SUB	'ַֹ
	LastString				As String			'ǰִ(ǰÿո)
	PreRepStr				As String			'滻ַ
	AppRepStr				As String			'滻ַ
	SpaceForEndString		As Integer			'ֹеĶո񣬲пո, < 0 ɾ
	SpaceForShortcut		As Integer			'еĶոһո, < 0 ɾ
	SpaceForAccKey			As Integer			'ݼеĶո񣬲пո, < 0 ɾ
	PreSpaceForEnAndAsia	As Integer			'Ӣĺ֮ǰոҪһո, < 0 ɾ> 0 
	EndSpaceForEnAndAsia	As Integer			'Ӣĺ֮ĺոҪһո, < 0 ɾ> 0 
	SpaceForVariable		As Integer			'% еĿո񣬲пո, < 0 ɾ
End Type

Public Type CHECK_STRING_VALUE
	AscRange			As String
	Range				As String
End Type

'༭߶
Public Type TOOLS_PROPERTIE
	sName				As String	'
	FilePath			As String	'ļ·(ļ)
	Argument			As String	'в
End Type

Public Type UI_FILE
	FilePath			As String	'ļȫ·
	AppName				As String	'
	Version				As String	'汾
	LangName			As String	'
	LangID				As String	'ID
	Encoding			As String	'ַ
End Type

Public Type INIFILE_DATA
	Title				As String	'
	Item()				As String	'Ŀ
	Value()				As String	'ִֵ
End Type

Private Type CODEPAGE_DATA
	sName				As String	'
	CharSet				As String	'ַ
End Type

'궨
Private Type POINTAPI
	x As Long
	y As Long
End Type

'ļƼļж
Public Type FILE_LIST
	sName					As String	'ı
	FilePath				As String	'ļ·(ļ)
End Type

'ıҶλ
Public Enum SendMsgValue
	'ıҶλ
	EM_GETSEL = &HB0				'0,			ȡλãַʾ
	EM_SETSEL = &HB1				',յ		ñ༭ؼıѡݷΧùλãյΪֵַ
									'				ָ0յ-1ʱıȫѡУ˷ձ༭ؼ
									'				ָ-2յ-1ʱȫľѡıδ
	EM_GETLINECOUNT = &HBA			'0,0			ȡ༭ؼ
	EM_LINEINDEX = &HBB				'к,0			ȡָ(:-1,0 ʾ)ַıеλãַʾ
	EM_LINELENGTH = &HC1			'ƫֵ,0		ȡָλ(:-1,0 ʾУıȣַʾ
	EM_LINEFROMCHAR = &HC9			'ƫֵ,0		ȡָλ(:-1,0 ʾλ)ڵк
	EM_GETLINE = &HC4				'к,ByVal	ȡ༭ؼĳһеݣԤȸո
	EM_SCROLLCARET = &HB7			'0,0 			ѿɼΧ괦
	EM_UNDO = &HC7					'0,0 			ǰһα༭ظͱϢؼڳͻָл
	EM_REPLACESEL = &HC2			'1(0),ַ	ַָ滻༭ؼеĵǰѡ
									'				wParamΪ1򱾴β0ַֹôֵʽҲôַʽ
									'				SendMessage Text1.hwnd, EM_REPLACESEL, 0, Text2.Text 'Ǵֵʽ
	EM_GETMODIFY = &HB8				'0,0			жϱ༭ؼǷѷ仯TRUE(1)ؼıѱ޸ģFALSE(0)δ
	EN_CHANGE = &H300 				'				༭ؼݷı䡣EN_UPDATEͬϢڱ༭ʾıˢºŷ
	EN_UPDATE = &H400				'				ؼ׼ʾı˵ʱ͸ϢEN_CHANGE֪ͨϢƣֻڸıʾ֮ǰ
	EM_GETLIMITTEXT = &H425			'0,0			ȡһ༭ؼı󳤶
	EM_LIMITTEXT = &HC5				'ֵ,0		ñ༭ؼеı
	EM_GETFIRSTVISIBLEINE = &HCE	'0,0			ıؼдڿɼλõıڵк
	EM_GETHANDLE = &HBD				'0,0			ȡı

	'ڶԻ
	WM_SETFONT = &H30				',True	ıʱʹϢȡؼҪõ
	WM_GETFONT = &H31				'0,0 			ȡǰؼı
	WM_FONTCHANGE = &H1D 			'0,0			ϵͳԴ仯ʱʹϢж
	WM_SETREDRAW = &HB 				'Boolean,0		ôǷػFalse ֹػTrue ػ
	WM_SETFOCUS = &H7				'ؼ,0,0	ý

	'WM_HSCROLL= &H114				'ؼ,,λ	 SB_BOTTOM ָˮƽλ
	WM_VSCROLL = &H115				'ؼ,,λ	 SB_BOTTOM ָĴֱλ
	'SB_TOP = &H06					'λ, ôֱ
	'SB_LEFT = &H06					'λ, ˮƽұ
	SB_BOTTOM = &H07				'λ, ôֱײ
	'SB_RIGHT = &H07				'λ, ˮƽұ

	'ť¼
	BM_CLICK = &HF5					'ؼ,0,0		ģť
End Enum

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	ByRef Destination As Any, _
	ByRef Source As Any, _
	ByVal Length As Long)

'ıҶλ
Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" ( _
	ByVal hwnd As Long, _
	ByVal wMsg As Long, _
	ByVal wParam As Long, _
	ByRef lParam As Any) As Long
Public Declare Function SendMessageLNG Lib "user32.dll" Alias "SendMessage" ( _
	ByVal hwnd As Long, _
	ByVal wMsg As Long, _
	ByVal wParam As Long, _
	ByVal lParam As Long) As Long
Public Declare Function GetFocus Lib "USER32.dll" () As Long	'ڷؽؼľ

'ڷؿؼIDľ
Public Declare Function GetDlgItem Lib "user32.dll" ( _
	ByVal hDlg As Long, _
	ByVal nIDDlgItem As Long) As Long

'ChooseFont ͵ flags 
Private Enum CF_VALUE
	CF_APPLY = &H200
	CF_ANSIONLY = &H400
	CF_TTONLY = &H40000
	CF_ENABLEHOOK = &H8
	CF_ENABLETEMPLATE = &H10
	CF_ENABLETEMPLATEHANDLE = &H20
	CF_FIXEDPITCHONLY = &H4000
	CF_NOVECTORFONTS = &H800
	CF_NOOEMFONTS = CF_NOVECTORFONTS
	CF_NOFACESEL = &H80000
	CF_NOSCRIPTSEL = CF_NOFACESEL
	CF_NOSTYLESEL = &H100000
	CF_NOSIZESEL = &H200000
	CF_NOSIMULATIONS = &H1000
	CF_NOVERTFONTS = &H1000000
	CF_SCALABLEONLY = &H20000
	CF_SCRIPTSONLY = CF_ANSIONLY
	CF_SELECTSCRIPT = &H400000
	CF_SHOWHELP = &H4
	CF_USESTYLE = &H80
	CF_WYSIWYG = &H8000			'must also have CF_SCREENFONTS CF_PRINTERFONTS
	CF_FORCEFONTEXIST = &H10000
	CF_INACTIVEFONTS = &H2000000
	CF_INITTOLOGFONTSTRUCT = &H40&
	CF_SCREENFONTS = &H1		'ʾĻ
	CF_PRINTERFONTS = &H2		'ʾӡ
	CF_BOTH = (CF_SCREENFONTS Or CF_PRINTERFONTS)	'߶ʾ
	CF_EFFECTS = &H100&			'Ч
	CF_LIMITSIZE = &H2000&		'С
End Enum

'
Public Type LOG_FONT
	lfHeight As Long			'С
	lfWidth As Long				'
	lfEscapement As Long		'ʾǶ
	lfOrientation As Long		'Ƕ
	lfWeight As Long			'Ƿ
	lfItalic As Byte			'Ƿб
	lfUnderline As Byte			'Ƿ»
	lfStrikeOut As Byte			'Ƿɾ
	lfCharSet As Byte			'ַ
	lfOutPrecision As Byte		'
	lfClipPrecision As Byte		'ü
	lfQuality As Byte			'߼豸ʵ֮ľ
	lfPitchAndFamily As Byte	'弯
	'lfFaceName As String * LF_FACESIZE	'(壬ʱ)
	lfFaceName(31) As Byte		'
	lfColor As Long				'ɫ
End Type

'Ի
Private Type CHOOSE_FONT
	lStructSize As Long			' size of CHOOSEFONT structure in byte
	hwndOwner As Long			' caller's window handle
	hDC As Long					' printer DC/IC or NULL
	lpLogFont As Long			' LogFont ṹַ
	iPointSize As Long			' 10 * size in points of selected font
	flags As CF_VALUE			' enum type flags
	rgbColors As Long			' returned text color
	lCustData As Long			' data passed to hook fn
	lpfnHook As Long			' ptr. to hook function
	lpTemplateName As String	' custom template name
	hInstance As Long			' instance handle of.EXE that contains cust. dlg. template
	lpszStyle As String			' return the style field here must be LF_FACESIZE or bigger
	nFontType As Integer		' same value reported to the EnumFonts call back with the extra FONTTYPE_ bits added
	MISSING_ALIGNMENT As Integer
	nSizeMin As Long			' minimum pt size allowed
	nSizeMax As Long			' max pt size allowed if CF_LIMITSIZE is used
End Type

Private Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As CHOOSE_FONT) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOG_FONT) As Long
Private Declare Function GetObjectAPI Lib "gdi32.dll" Alias "GetObjectA" ( _
	ByVal hObject As Long, _
	ByVal nCount As Long, _
	ByVal lpObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" ( _
	ByVal hDC As Long, _
	ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long

'RedrawWindow  fuRedraw 
Private Enum RDW
	RDW_INVALIDATE = &H1		'ãΣػ
	RDW_INTERNALPAINT = &H2		'ʹڲЧҲͶһWM_PAINTϢ
	RDW_ERASE = &H4				'ػǰػıҲָRDW_INVALIDATE
	RDW_VALIDATE = &H8			'ػ
	RDW_NOINTERNALPAINT = &H10	'ֹڲɻɵκδWM_PAINTϢЧԻWM_PAINTϢ
	RDW_NOERASE = &H20			'ֹɾػı
	RDW_NOCHILDREN = &H40		'ػųӴڣǰǴػ
	RDW_ALLCHILDREN = &H80		'ػӴڣǰǴػ
	RDW_UPDATENOW = &H100		'ָػ
	RDW_ERASENOW = &H200		'ɾָػ
	RDW_FRAME = &H400			'ǿͻػУԷǿͻи¡ҲָRDW_INVALIDATE
	RDW_NOFRAME = &H800			'ֹǿͻػػһ֣ҲָRDW_VALIDATE
End Enum

'ػԻ
Private Declare Function RedrawWindow Lib "user32.dll" ( _
	ByVal hwnd As Long, _
	ByVal lprcUpdate As Long, _
	ByVal hrgnUpdate As Long, _
	ByVal fuRedraw As Long) As Long

'ҳ
Private Enum KnownCodePage
	CP_UNICODELITTLE = 1200
	CP_UNICODEBIG = 1201
	CP_UTF_32LE = 12000  	'Unicode UTF-32, little endian byte order; available only to managed applications
	CP_UTF_32BE = 12001		'Unicode UTF-32, big endian byte order; available only to managed applications
	CP_UTF7 = 65000
	CP_UTF8 = 65001
	CP_UTF32LE = 65005  'Unicode (UTF-32 LE)
	CP_UTF32BE = 65006	'Unicode (UTF-32 Big-Endian)
End Enum

'ҳת
Private Declare Function MultiByteToWideChar Lib "kernel32.dll" ( _
	ByVal CodePage As Long, _
	ByVal dwFlags As Long, _
	ByRef lpMultiByteStr As Any, _
	ByVal cchMultiByte As Long, _
	ByVal lpWideCharStr As Long, _
	ByVal cchWideChar As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32.dll" ( _
	ByVal CodePage As Long, _
	ByVal dwFlags As Long, _
	ByVal lpWideCharStr As Long, _
	ByVal cchWideChar As Long, _
	ByRef lpMultiByteStr As Any, _
	ByVal cchMultiByte As Long, _
	ByVal lpDefaultChar As Long, _
	ByVal lpUsedDefaultChar As Long) As Long
'ȡĬϴҳ
Private Declare Function GetACP Lib "kernel32.dll" () As Long

'ȡڱؼеıַ
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLength" (ByVal hwnd As Long) As Long
'ȡڱؼеı
Private Declare Function GetWindowText Lib "user32.dll" Alias "GetWindowText" (ByVal hwnd As Long, _
	ByVal lpString As String, _
	ByVal cch As Long) As Long
'ôڱؼеı
'ܸıӦóеĿؼıݣҪ SengMessage һ WM_SETTEX Ϣ
Private Declare Function SetWindowText Lib "user32.dll" Alias "SetWindowText" (ByVal hwnd As Long, _
	ByVal lpString As String) As Long

' VK ֵ壬 GetAsyncKeyState 
Public Enum VK
	'VK_LBUTTON = &H01	'
	'VK_RBUTTON = &H02	'Ҽ
	'VK_MBUTTON = &H04	'м
	'VK_END = &H23		' End 
	'VK_HOME = &H24		' Home 
	'VK_LEFT = &H25		'
	'VK_UP = &H26		'ϼ
	'VK_RIGHT = &H27	'Ҽ
	'VK_DOWN = &H28		'¼
	VK_ESCAPE = &H1B	'Esc 
End Enum

'ȡ갴״̬
Private Declare Function GetAsyncKeyState Lib "user32.dll" (ByVal vKey As Long) As Integer
'GetAsyncKeyState صָ˲ʱӲж״ֵֵַ̬
'0 ǰδڰ״̬ϴεGetAsyncKeyStateļҲδ
'1 ǰδڰ״̬ڴ֮ǰϴεGetAsyncKeyState󣩼
'-3276816&H8000ǰڰ״̬ڴ֮ǰϴεGetAsyncKeyState󣩼δ
'-3276716&H8001ǰڰ״̬ڴ֮ǰϴεGetAsyncKeyState󣩼Ҳ
Private Declare Function EnableWindow Lib "user32" Alias "EnableWindow" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
'أʾɹʾʧܡGetLastError
'hwndڻؼ
'fEnable Longֹ


Public trn As PslTransList,OSLanguage As String
Public UIFileList() As UI_FILE,UIDataList() As INIFILE_DATA,LangFile As String
Public LFList() As LOG_FONT,LFListBak() As LOG_FONT
Public CheckHexStr() As CHECK_STRING_VALUE,CheckSkipStr() As String
Public PslLangList() As LANG_SET,UpdateSet() As String,UpdateSetBak() As String
Public StopMsg As String,StopTitle As String

Public StringSrc As STRING_INFO,StringTrn As STRING_INFO

Public DefaultCheckList() As String,DefaultProjectList() As String
Public cWriteLoc As String,cSelected() As String,cSelectedBak() As String
Public CheckList() As CHECK_SET,CheckListBak() As CHECK_SET
Public ProjectList() As CHECK_PROJECT_SET,ProjectListBak() As CHECK_PROJECT_SET
Public CheckCountList() As Integer

Public AllStrList() As String,UseStrList() As String
Public Tools() As TOOLS_PROPERTIE,ToolsBak() As TOOLS_PROPERTIE
Public FileDataList() As String,CodeList() As CODEPAGE_DATA,RegExp As Object


'ȫ˳
Public Sub ExitMacro(ByVal Mode As Long)
	Dim i As Long
	On Error Resume Next
	If Dir(trn.Project.Location & "\~temp.txt") <> "" Then Kill trn.Project.Location & "\~temp.txt"
	'ȡרõûԵ
	For i = 1 To PSL.ActiveProject.TransLists.Count
		Set trn = PSL.ActiveProject.TransLists(i)
		If trn.IsOpen = True Then
			If trn.Property(19980) = "CheckAccessKeys" Then trn.Property(19980) = ""
		End If
	Next i
	If Mode > 0 Then Exit All
End Sub


'뵥ַ
Public Function CheckString(TransString As PslTransString,ByVal StrTypes As String,SetList() As Integer,MsgList() As String) As Long
	Dim srcString As String,trnString As String
	Dim LineMsg As String,AcckeyMsg As String
	Dim Stemp As Boolean
	'ϢִʼȡбԴͷִ
	With TransString
		'ִʹ
		If SetList(6) = 0 And SetList(13) = 0 Then
			If InStr("Menu|Dialog|StringTable|AcceleratorTable|Version",.ResType) Then
				If InStr(StrTypes,.ResType) = 0 Then GoTo Skip
			Else
				If SetList(12) = 0 Then GoTo Skip
			End If
		End If
		'δ롢ֻΪյִ
		If SetList(5) < 2 Or SetList(5) > 4 Then
			If .State(pslStateTranslated) = False Then GoTo Skip
		End If
		If .State(pslStateLocked) = True Then GoTo Skip
		If .State(pslStateReadOnly) = True Then GoTo Skip
		If Trim(.SourceText) = "" Then GoTo Skip
		If Trim(.Text) = "" Then GoTo Skip
		'Ѽ޴Ҽڷڵִ
		If (SetList(5) < 2 Or SetList(5) > 4) And SetList(22) + SetList(23) = 0 Then
			ReDim TempList(3) As String
			If SetList(18) = 0 Then
				TempList(0) = .Property(MsgList(14))
			Else
				TempList(0) = Version
			End If
			If SetList(19) = 0 Then
				TempList(1) = .Property(MsgList(15))
			Else
				TempList(1) = cSelected(2)
			End If
			If SetList(20) = 0 Then
				TempList(2) = .Property(MsgList(16))
			Else
				TempList(2) = CStr(.DateTranslated)
			End If
			If SetList(21) = 0 Then
				TempList(3) = .Property(MsgList(17))
			Else
				TempList(3) = "0"
			End If
			If TempList(3) = MsgList(19) And StrComp(TempList(3),CStr(.DateTranslated)) >= 0 Then
				If TempList(0) = Version And TempList(1) = cSelected(2) Then GoTo Skip
			End If
		End If

		'ɾ
		If SetList(23) = 1 Then .Properties.RemoveAll

		'תת
		Stemp = False
		trnString = .Text
		srcString = Convert(.SourceText)
		If srcString <> .SourceText Then
			trnString = Convert(trnString)
			Stemp = True
		End If

		'ʼִ
		trnString = CheckHanding(SetList(2),SetList(5),srcString,trnString)
		If SetList(25) = 1 Then trnString = ReplaceStr(SetList(2),trnString,2,1)
		If Stemp = True Then trnString = ReConvert(trnString)

		'Ϣ
		If trnString <> .Text Then
			If SetList(5) < 2 Or SetList(5) > 4 Then
				'
				StringSrc.LineNum = LineCount(.SourceText)
				StringTrn.LineNum = LineCount(trnString)
				'Ϣ
				LineMsg = LineErrMassage(StringSrc.LineNum,StringTrn.LineNum,CheckCountList(5))
				AcckeyMsg = AccKeyErrMassage(StringSrc.AccKeyNum,StringTrn.AccKeyNum,CheckCountList(6))
			End If
			.OutputError CheckMassage(SetList(2),SetList(5)) & AcckeyMsg & LineMsg
			'滻ִ
			If ProjectList(SetList(5)).ShowOriginalTran = 1 Then .OutputError(Replace(MsgList(22),"%s",.Text))
			If ProjectList(SetList(5)).ApplyCheckResult = 1 Then .Text = trnString
			trnString = ""
		ElseIf trnString <> srcString Then
			.OutputError MsgList(19)
		Else
			.OutputError MsgList(31)
		End If

		'ĺԭĲһµִ״̬,Է鿴
		If SetList(24) = 0 Then
			If trnString = "" Or StringSrc.LineNum <> StringTrn.LineNum Or StringSrc.AccKeyNum <> StringTrn.AccKeyNum Then
				.State(pslStateReview) = True
			Else
				.State(pslStateReview) = False
			End If
		End If

		'ִԶԺͼ
		If SetList(23) = 0 Then
			.Property(MsgList(14)) = Version
			.Property(MsgList(15)) = cSelected(2)
			.Property(MsgList(16)) = Format(Now,MsgList(21))
			Select Case SetList(5)
			Case 0
				If trnString = "" Or StringSrc.LineNum <> StringTrn.LineNum Or StringSrc.AccKeyNum <> StringTrn.AccKeyNum Then
					.Property(MsgList(17)) = MsgList(18)
				Else
					.Property(MsgList(17)) = MsgList(19)
				End If
			Case 1
				If trnString = "" Then
					.Property(MsgList(17)) = MsgList(20)
				ElseIf StringSrc.LineNum <> StringTrn.LineNum Or StringSrc.AccKeyNum <> StringTrn.AccKeyNum Then
					.Property(MsgList(17)) = MsgList(18)
				Else
					.Property(MsgList(17)) = MsgList(19)
				End If
			End Select
		End If
		Skip:
	End With
End Function


'ɾļУɾļ
Private Function DelDir(ByVal DirPath As String) As Boolean
	Dim File As String
	DirPath = Trim$(DirPath)
	If DirPath = "" Then Exit Function
	If Right$(DirPath,1) <> "\" Then DirPath = DirPath & "\"
	File = Dir$(DirPath & "*.*")
	On Error GoTo errHandle
	Do While File <> ""
		Kill DirPath & File
		File = Dir$()
	Loop
	If Dir$(DirPath & "*.*") = "" Then
		RmDir DirPath
		DelDir = True
	End If
	errHandle:
End Function


'ɾļУļ
Public Function DelDirs(ByVal DirPath As String) As Boolean
	Dim i As Long,j As Long,File As String
	DirPath = Trim$(DirPath)
	If DirPath = "" Then Exit Function
	If Right$(DirPath,1) <> "\" Then DirPath = DirPath & "\"
	If Dir$(DirPath & "*.*",vbDirectory) = "" Then Exit Function
	On Error Resume Next
	ReDim PathList(0) As String
	PathList(0) = DirPath
	Do
		DirPath = PathList(i)
		File = Dir$(DirPath & "*.*",vbDirectory)
		While File <> ""
			If File <> "." And File <> ".." Then
				If GetAttr(DirPath & File) And vbDirectory Then
					j = j + 1
					ReDim Preserve PathList(j) As String
					PathList(j) = DirPath & File & "\"
				Else
					Kill DirPath & File
				End If
			End If
			File = Dir$()
		Wend
		RmDir PathList(j)
		i = i + 1
	Loop Until i = j + 1
	For i = j To 0 Step -1
		If Dir$(PathList(i) & "*.*") = "" Then RmDir PathList(i)
	Next i
	If Dir$(PathList(0) & "*.*",vbDirectory) = "" Then DelDirs = True
End Function


'ִСдַ滻 (δ滻ַĴСд)
Public Function strReplace(ByVal s As String,ByVal Find As String,ByVal repwith As String,Optional ByVal Index As Long = 1,Optional ByVal Count As Long = -1) As String
	Dim n As Long,fL As Long
	strReplace = s
	If s = "" Then Exit Function
	If Find = "" Then Exit Function
	If Index < 1 Then Exit Function
	If Count < -1 Then Exit Function
	s = LCase$(s)
	Find = LCase$(Find)
	Index = InStr(Index,s,Find)
	If Index = 0 Then Exit Function
	fL = Len(Find)
	Do While Index > 0
		If Count = -1 Then
			strReplace = Replace$(strReplace,Mid$(strReplace,Index,fL),repwith)
		Else
			strReplace = Left(strReplace,Index - 1) & Replace(strReplace,Mid$(strReplace,Index,fL),repwith,Index,1)
			n = n + 1
			If n = Count Then Exit Do
		End If
		Index = InStr(Index + fL,LCase$(strReplace),Find)
	Loop
End Function


'õĴҳUTF-8:65001GB2312:936GB1803054936UTF-765000
Private Function MultiByteToUTF16(UTF8() As Byte, ByVal CodePage As Long) As String
	On Error GoTo errHandle
	Dim bufSize As Long,lRet As Long
	'bufSize = MultiByteToWideChar(CodePage, 0&, VarPtr(UTF8(0)), UBound(UTF8) + 1, 0, 0)
	bufSize = MultiByteToWideChar(CodePage, 0&, UTF8(0), UBound(UTF8) + 1, 0, 0)
	'If CodePage = CP_UTF8 Then bufSize = (UBound(UTF8) + 1) * 2 Else bufSize = UBound(UTF8) + 1
	MultiByteToUTF16 = Space(bufSize)
	'lRet = MultiByteToWideChar(CodePage, 0&, VarPtr(UTF8(0)), UBound(UTF8) + 1, StrPtr(MultiByteToUTF16), bufSize)
	lRet = MultiByteToWideChar(CodePage, 0&, UTF8(0), UBound(UTF8) + 1, StrPtr(MultiByteToUTF16), bufSize)
	If lRet > 0 Then MultiByteToUTF16 = Left$(MultiByteToUTF16, lRet)
	Exit Function
	errHandle:
	MultiByteToUTF16 = ""
End Function


'תַΪֽ
Private Function UTF16ToMultiByte(ByVal UTF16 As String, ByVal CodePage As Long) As Byte()
	Dim bufSize As Long,lRet As Long
	On Error GoTo errHandle
	ReDim arr(0) As Byte
	bufSize = WideCharToMultiByte(CodePage, 0&, StrPtr(UTF16), Len(UTF16), arr(0), 0, 0, 0)
	'If CodePage = CP_UTF8 Then bufSize = 2 * LenB(UTF16) - 1 Else bufSize = LenB(UTF16)
	If bufSize < 1 Then bufSize = 1
	ReDim arr(bufSize - 1) As Byte
	lRet = WideCharToMultiByte(CodePage, 0&, StrPtr(UTF16), Len(UTF16), arr(0), bufSize, 0, 0)
	If lRet > 0 Then
		ReDim Preserve arr(lRet - 1) As Byte
	End If
	UTF16ToMultiByte = arr
	Exit Function
	errHandle:
	ReDim arr(0) As Byte
	UTF16ToMultiByte = arr
End Function


'ִǷַָ(ıͨȽ)
'Mode = 0 ִǷַָҳַָλ
'Mode = 1 ִǷַָֻ
'Mode = 2 ִǷַָ
'Mode = 3 ִǷֻСдַָʱ IgnoreCase Ч
'Mode = 4 ִǷַͬStrNum Ϊַ
'StrRange  ִ鷶Χ ( [Min - Max|Min - Max] ʾΧ)
Private Function CheckStr(ByVal textStr As String,ByVal StrRange As String,Optional ByVal StrNum As Long, _
				Optional ByVal Mode As Long,Optional ByVal IgnoreCase As Boolean) As Long
	Dim i As Long,Temp As String
	If StrRange = "" Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	Select Case Mode
	Case 0
		If IgnoreCase = True Then
			textStr = LCase$(textStr)
			StrRange = LCase$(StrRange)
		End If
		StrRange = Replace$(StrRange,"]|[","")
		If (textStr Like "*" & StrRange & "*") = False Then Exit Function
		For i = 1 To Len(textStr)
			If (Mid$(textStr,i,1) Like StrRange) = True Then
				CheckStr = i
				Exit For
			End If
		Next i
	Case 1
		If IgnoreCase = True Then
			textStr = LCase$(textStr)
			StrRange = LCase$(StrRange)
		End If
		If (textStr Like "*[!" & Replace$(Replace$(StrRange,"]|[",""),"[","") & "*") = False Then
			CheckStr = True
		End If
	Case 2
		If IgnoreCase = True Then
			textStr = LCase$(textStr)
			StrRange = LCase$(StrRange)
		End If
		If (textStr Like "*[" & Replace$(Replace$(StrRange,"]|[",""),"[","") & "*") = True Then
			CheckStr = True
		End If
	Case 3
		If InStr(textStr," ") Then Exit Function
		If Len(textStr) < 2 Then Exit Function
		If LCase$(textStr) = textStr Then Exit Function
		If UCase$(textStr) = textStr Then Exit Function
		If (textStr Like "*[!" & Replace$(Replace$(StrRange,"]|[",""),"[","") & "*") = True Then Exit Function
		textStr = Mid$(textStr,2)
		If LCase$(textStr) = textStr Then Exit Function
		CheckStr = True
	Case 4
		If StrNum < 2 Then Exit Function
		If Len(textStr) < StrNum Then Exit Function
		If InStr(textStr," ") Then Exit Function
		If IsNumeric(textStr) = True Then Exit Function
		If IsDate(textStr) = True Then Exit Function
		If InStr(textStr,"...") Then Exit Function
		If InStr(textStr,"://www.") Then Exit Function
		If IgnoreCase = True Then
			textStr = LCase$(textStr)
			StrRange = LCase$(StrRange)
		End If
		If (textStr Like "*" & Replace$(StrRange,"]|[","") & "*") = False Then Exit Function
		For i = 1 To Len(textStr)
			Temp = Mid$(textStr,i,1)
			If IsNumeric(Temp) = False Then
				If Temp <> "." Then
					If InStr(textStr,String$(StrNum,Temp)) Then
						CheckStr = True
						Exit For
					End If
				End If
			End If
		Next i
	End Select
End Function


'ִǷַָ(ʽȽ)
'Mode = 0 ִǷַָҳַָλ
'Mode = 1 ִǷַָֻ
'Mode = 2 ִǷַָ
'Mode = 3 ִǷֻСдַָʱ IgnoreCase Ч
'Mode = 4 ִǷַͬStrNum Ϊظַ
'Mode = 5 ִǷִָƥִܳ (ʺַϲѯ)
'Patrn  Ϊʽģ
Private Function CheckStrRegExp(ByVal textStr As String,ByVal Patrn As String,Optional ByVal StrNum As Long, _
				Optional ByVal Mode As Long,Optional ByVal IgnoreCase As Boolean) As Long
	Dim n As Long,Matches As Object
	If Patrn = "" Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	With RegExp
		Select Case Mode
		Case 0
			.Global = True
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count > 0 Then CheckStrRegExp = Matches(0).FirstIndex + 1
		Case 1
			.Global = True
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count = Len(textStr) Then CheckStrRegExp = True
		Case 2
			.Global = False
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			If .Test(textStr) Then CheckStrRegExp = True
		Case 3
			If InStr(textStr," ") Then Exit Function
			n = Len(textStr)
			If n < 2 Then Exit Function
			If LCase$(textStr) = textStr Then Exit Function
			If UCase$(textStr) = textStr Then Exit Function
			.Global = True
			.IgnoreCase = False
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count <> n Then Exit Function
			textStr = Mid$(textStr,2)
			If LCase$(textStr) = textStr Then Exit Function
			CheckStrRegExp = True
		Case 4
			If StrNum < 2 Then Exit Function
			If Len(textStr) < StrNum Then Exit Function
			If InStr(textStr," ") Then Exit Function
			If InStr(textStr,"...") Then Exit Function
			If InStr(textStr,"://www.") Then Exit Function
			.Global = False
			.IgnoreCase = IgnoreCase
			.Pattern = "(" & Patrn & ")\1{" & CStr$(StrNum - 1) & ",}"
			If .Test(textStr) Then CheckStrRegExp = True
		Case 5
			.Global = True
			.IgnoreCase = IgnoreCase
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count = 0 Then Exit Function
			For n = 0 To Matches.Count - 1
				CheckStrRegExp = CheckStrRegExp + Matches(n).Length
			Next n
			CheckStrRegExp = IIf(CheckStrRegExp = Len(textStr),True,False)
		End Select
	End With
End Function


'滻ضַ
'fType = 0 滻ʹõһ滻ַ
'fType = 1 ԭ滻ʹõһ滻ַ
'fType = 2 滻ʹõڶ滻ַãڷ
'fType = 3 ԭ滻ʹõڶ滻ַãڷ
'Record = 0 ¼滻ַ
'Record = 1 ¼滻ַ
Public Function ReplaceStr(ByVal CheckID As Integer,ByVal trnStr As String,ByVal fType As Long,ByVal Record As Long) As String
	Dim i As Long,Temp As String,PreStr As String,AppStr As String
	Dim TempList() As String,TempArray() As String
	ReplaceStr = trnStr
	If Trim(ReplaceStr) = "" Then Exit Function
	'ȡѡõĲ
	If fType < 2 Then
		Temp = CheckList(CheckID).PreRepStr
	Else
		Temp = CheckList(CheckID).AppRepStr
	End If
	If Temp = "" Then Exit Function
	TempList = ReSplit(Temp,",",-1)
	For i = 0 To UBound(TempList)
		If InStr(TempList(i),"|") Then
			TempArray = ReSplit(TempList(i),"|")
			If fType = 0 Or fType = 2 Then
				PreStr = TempArray(0)
				AppStr = TempArray(1)
			Else
				PreStr = TempArray(1)
				AppStr = TempArray(0)
			End If
			If PreStr <> "" And InStr(ReplaceStr,PreStr) Then
				ReplaceStr = Replace(ReplaceStr,PreStr,AppStr)
				If Record = 1 Then
					If fType < 2 Then
						If StringSrc.PreRepStr = "" Then
							StringSrc.PreRepStr = PreStr
						ElseIf InStr(StringSrc.PreRepStr,PreStr) = 0 Then
							StringSrc.PreRepStr = StringSrc.PreRepStr & JoinStr & PreStr
						End If
						If StringSrc.AppRepStr = "" Then
							StringSrc.AppRepStr = AppStr
						ElseIf InStr(StringSrc.AppRepStr,AppStr) = 0 Then
							StringSrc.AppRepStr = StringSrc.AppRepStr & JoinStr & AppStr
						End If
					Else
						If StringTrn.PreRepStr = "" Then
							StringTrn.PreRepStr = PreStr
						ElseIf InStr(StringTrn.PreRepStr,PreStr) = 0 Then
							StringTrn.PreRepStr = StringTrn.PreRepStr & JoinStr & PreStr
						End If
						If StringTrn.AppRepStr = "" Then
							StringTrn.AppRepStr = AppStr
						ElseIf InStr(StringTrn.AppRepStr,AppStr) = 0 Then
							StringTrn.AppRepStr = StringTrn.AppRepStr & JoinStr & AppStr
						End If
					End If
				End If
			End If
		End If
	Next i
End Function


'ݼֹͼ
Public Function CheckHanding(ByVal CheckID As Integer,ByVal ProjectID As Integer,ByVal srcStr As String,ByVal trnStr As String) As String
	Dim i As Long,j As Long,m As Long,n As Long,k As Long,l As Long
	Dim lTemp As String,rTemp As String,Stemp As Boolean
	Dim TempList() As String,srcStrList() As String,trnStrList() As String
	CheckHanding = trnStr
	If Trim(srcStr) = "" Or Trim(trnStr) = "" Then Exit Function
	With CheckList(CheckID)
		'ųִеķǿݼ
		If .AccKeyExcludeChar <> "" Then
			TempList = ReSplit(.AccKeyExcludeChar,",",-1)
			For i = 0 To UBound(TempList)
				srcStr = Replace(srcStr,TempList(i),"*a" & i & "!N!" & i & "d*")
				trnStr = Replace(trnStr,TempList(i),"*a" & i & "!N!" & i & "d*")
			Next i
		End If
		'˲ǿݼĿݼ
		If .KeepCharPair <> "" Then
			TempList = ReSplit(.KeepCharPair,",",-1)
			j = UBound(TempList)
			If j > 0 Then
				For i = 0 To j
					lTemp = Left(TempList(i),1)
					rTemp = Mid(TempList(i),2)
					srcStr = Replace(srcStr,lTemp & "&" & rTemp,lTemp & "*!N!" & i & "!M!" & i & "!N!*" & rTemp)
					trnStr = Replace(trnStr,lTemp & "&" & rTemp,lTemp & "*!N!" & i & "!M!" & i & "!N!*" & rTemp)
				Next i
			End If
		End If
		'滻ִ
		If ProjectList(ProjectID).EnableStrSplit = 1 Then
			j = 0: k = 0: l = 0
			If .PreInsertSplitChar <> "" Then j = UBound(ReSplit(.PreInsertSplitChar,",",-1)) + 1
			If .AppInsertSplitChar <> "" Then k = UBound(ReSplit(.AppInsertSplitChar,",",-1)) + 1
			If .ReplaceSplitChar <> "" Then l = UBound(ReSplit(.ReplaceSplitChar,",",-1)) + 1
			TempList = ReSplit(.PreInsertSplitChar & "," & .AppInsertSplitChar & "," & .ReplaceSplitChar,",",-1)
			If CheckArray(TempList) = True Then
				For i = 0 To UBound(TempList)
					If TempList(i) <> "" Then
						m = UBound(ReSplit(srcStr,TempList(i),-1))
						n = UBound(ReSplit(trnStr,TempList(i),-1))
						Stemp = False
						If .LineSplitMode = 0 Then
							If m > 0 And n > 0 Then Stemp = True
						Else
							If m > 0 And n = m Then Stemp = True
						End If
						If Stemp = True Then
							If InStr(LCase(Convert(.AccKeyChar)),LCase(TempList(i))) Then
								srcStr = Insert(srcStr,TempList(i),"*c!N!g*",1)
								trnStr = Insert(trnStr,TempList(i),"*c!N!g*",1)
							ElseIf i < j And j <> 0 Then
								srcStr = Replace(srcStr,TempList(i),"*c!N!g*" & TempList(i))
								trnStr = Replace(trnStr,TempList(i),"*c!N!g*" & TempList(i))
							ElseIf i >= j And i < j + k + 1 And k <> 0 Then
								srcStr = Replace(srcStr,TempList(i),TempList(i) & "*c!N!g*")
								trnStr = Replace(trnStr,TempList(i),TempList(i) & "*c!N!g*")
							ElseIf i >= j + k And i < j + k + l + 2 And l <> 0 Then
								srcStr = Replace(srcStr,TempList(i),"*c!N!g*")
								trnStr = Replace(trnStr,TempList(i),"*c!N!g*")
							End If
						End If
					End If
				Next i
			End If
			srcStrList = ReSplit(srcStr,"*c!N!g*",-1)
			trnStrList = ReSplit(trnStr,"*c!N!g*",-1)
			'ִ
			Stemp = False
			m = UBound(srcStrList)
			n = UBound(trnStrList)
			If m > 0 And n > 0 Then
				If .LineSplitMode = 0 Then
					Stemp = True
				ElseIf m = n Then
					Stemp = True
				End If
			End If
			If Stemp = True Then
				trnStr = ReplaceStrSplit(CheckID,ProjectID,CheckHanding,srcStrList,trnStrList)
			Else
				trnStr = StringReplace(CheckID,ProjectID,srcStr,trnStr)
			End If
		Else
			trnStr = StringReplace(CheckID,ProjectID,srcStr,trnStr)
		End If
		'ݼ
		If StringSrc.AccKey.IFR <> "" Then
			StringSrc.AccKeyNum = UBound(ReSplit(srcStr,StringSrc.AccKey.IFR,-1))
		End If
		If StringTrn.AccKey.IFR <> "" Then
			StringTrn.AccKeyNum = UBound(ReSplit(trnStr,StringTrn.AccKey.IFR,-1))
		End If
		'ԭǿݼĿݼ
		If .KeepCharPair <> "" Then
			TempList = ReSplit(.KeepCharPair,",",-1)
			j = UBound(TempList)
			If j > 0 Then
				For i = 0 To j
					lTemp = Left(TempList(i),1)
					rTemp = Mid(TempList(i),2)
					srcStr = Replace(srcStr,lTemp & "*!N!" & i & "!M!" & i & "!N!*" & rTemp,lTemp & "&" & rTemp)
					trnStr = Replace(trnStr,lTemp & "*!N!" & i & "!M!" & i & "!N!*" & rTemp,lTemp & "&" & rTemp)
				Next i
			End If
		End If
		'ԭִбųķǿݼ
		If .AccKeyExcludeChar <> "" Then
			TempList = ReSplit(.AccKeyExcludeChar,",",-1)
			For i = 0 To UBound(TempList)
				srcStr = Replace(srcStr,"*a" & i & "!N!" & i & "d*",TempList(i))
				trnStr = Replace(trnStr,"*a" & i & "!N!" & i & "d*",TempList(i))
			Next i
		End	If
		'ؽ
		CheckHanding = trnStr
	End With
End Function


'ڿݼضַԴ˲ִ
Private Function Insert(ByVal SplitString As String,ByVal SplitStr As String,ByVal InsStr As String,ByVal Leng As Long) As String
	Dim i As Long,j As Long
	Insert = SplitString
	If UBound(ReSplit(SplitString,SplitStr)) < 2 Then Exit Function
	i = InStr(Insert,SplitStr)
	Do While i > Leng
		j = InStr(i + 1,Insert,SplitStr)
		If j > i Then
			SplitString = Mid(Insert,i - Leng,j - i)
			If SplitString <> "" Then
				Insert = Replace(Insert,SplitString,SplitString & InsStr)
			End If
		End If
		i = InStr(i + 1,Insert,SplitStr)
	Loop
	'PSL.Output "Insert = " & Insert       '
End Function


'ȡеÿִ滻
Private Function ReplaceStrSplit(ByVal CheckID As Integer,ByVal ProjectID As Integer,ByVal trnStr As String,srcStrList() As String,trnStrList() As String) As String
	Dim i As Long,j As Integer
	ReplaceStrSplit = trnStr
	i = UBound(srcStrList)
	j = UBound(trnStrList)
	If i > j Then
		ReDim Preserve trnStrList(i) As String
	ElseIf i < j Then
		ReDim Preserve srcStrList(j) As String
	End If
	j = 1
	For i = 0 To UBound(srcStrList)
		trnStr = StringReplace(CheckID,ProjectID,srcStrList(i),trnStrList(i))
		If trnStr <> trnStrList(i) Then
			If j = 1 Then
				ReplaceStrSplit = Replace(ReplaceStrSplit,trnStrList(i),trnStr,j,1)
			Else
				ReplaceStrSplit = Left(ReplaceStrSplit,j - 1) & Replace(ReplaceStrSplit,trnStrList(i),trnStr,j,1)
			End If
		End If
		j = j + Len(trnStr)
	Next i
End Function


'лȡִĸֶβ滻ַ
Private Function StringReplace(ByVal CheckID As Integer,ByVal ProjectID As Integer,ByVal srcStr As String,ByVal trnStr As String) As String
	Dim i As Long,j As Long,k As Long,Temp As String
	Dim TempList() As String,TempArry() As String,TempArr() As String
	'ַʼ
	With StringSrc
		.AccKey.IFR = ""
		.AccKey.Key = ""
		.AccKey.Length = 0
		.AccKey.Loction = 0
		.AccKey.sString = ""
		.EndString.Length = 0
		.EndString.Loction = 0
		.EndString.sString = ""
		.PreSpace.Length = 0
		.PreSpace.Loction = 0
		.PreSpace.sString = ""
		.EndSpace.Length = 0
		.EndSpace.Loction = 0
		.EndSpace.sString = ""
		.Shortcut.IFR = ""
		.Shortcut.Key = ""
		.Shortcut.Length = 0
		.Shortcut.Loction = 0
		.Shortcut.sString = ""
		.PreRepStr = ""
		.AppRepStr = ""
		.SpaceForEndString = 0
		.SpaceForShortcut = 0
		.SpaceForAccKey = 0
		.PreSpaceForEnAndAsia = 0
		.EndSpaceForEnAndAsia = 0
		.SpaceForVariable = 0
	End With
	With StringTrn
		.AccKey.IFR = ""
		.AccKey.Key = ""
		.AccKey.Length = 0
		.AccKey.Loction = 0
		.AccKey.sString = ""
		.EndString.Length = 0
		.EndString.Loction = 0
		.EndString.sString = ""
		.PreSpace.Length = 0
		.PreSpace.Loction = 0
		.PreSpace.sString = ""
		.EndSpace.Length = 0
		.EndSpace.Loction = 0
		.EndSpace.sString = ""
		.Shortcut.IFR = ""
		.Shortcut.Key = ""
		.Shortcut.Length = 0
		.Shortcut.Loction = 0
		.Shortcut.sString = ""
		.PreRepStr = ""
		.AppRepStr = ""
		.SpaceForEndString = 0
		.SpaceForShortcut = 0
		.SpaceForAccKey = 0
		.PreSpaceForEnAndAsia = 0
		.EndSpaceForEnAndAsia = 0
		.SpaceForVariable = 0
	End With
	StringReplace = trnStr
	If Trim(srcStr) = "" Or Trim(trnStr) = "" Then Exit Function
	'Դͷ
	StringSrc.LastString = srcStr
	StringTrn.LastString = trnStr
	'ȡԴͷĳ
	StringSrc.Length = Len(srcStr)
	StringTrn.Length = Len(trnStr)
	With CheckList(CheckID)
		'ȡԴͷǰÿո
		GetSubStrInfoRegExp(StringSrc.PreSpace,srcStr,"^\x20+",0,-1)
		GetSubStrInfoRegExp(StringTrn.PreSpace,trnStr,"^\x20+",0,-1)
		'ȡԴͷβո
		GetSubStrInfoRegExp(StringSrc.EndSpace,srcStr,"\x20+$",0,-1)
		GetSubStrInfoRegExp(StringTrn.EndSpace,trnStr,"\x20+$",0,-1)
		'ȥβո
		If StringSrc.EndSpace.Loction > 0 Then
			StringSrc.LastString = RTrim(StringSrc.LastString)
		End If
		If StringTrn.EndSpace.Loction > 0 Then
			StringTrn.LastString = RTrim(StringTrn.LastString)
		End If
		'ȡԴͷļ(ǰո)ȡλִļ
		If .CheckShortChar <> "" Then
			TempList = ReSplit(.CheckShortChar,",")
			TempArry = ReSplit(.CheckShortKey & "," & .KeepShortKey,",")
			'ȡԴļ
			For i = 0 To UBound(TempList)
				If CheckStrRegExp(StringSrc.LastString,TempList(i),0,2) = True Then
					Temp = "\x20*" & TempList(i) & ".*$"
					If GetSubStrInfoRegExp(StringSrc.Shortcut,StringSrc.LastString,Temp,0,-1,False,True) = True Then
						Temp = Convert(TempList(i))
						If StringSrc.Shortcut.sString = Temp & "+" Then
							'ȥ
							StringSrc.LastString = Left(StringSrc.LastString,StringSrc.Shortcut.Loction - 1)
							StringSrc.Shortcut.IFR = Temp
						Else
							For j = 0 To UBound(TempArry)
								TempArr = ReSplit(LCase(Replace(StringSrc.Shortcut.sString,Temp,"")),"+")
								For k = 0 To UBound(TempArr)
									If CheckLike(Trim(TempArr(k)),LCase(TempArry(j))) Then
										'ȥ
										StringSrc.LastString = Left(StringSrc.LastString,StringSrc.Shortcut.Loction - 1)
										StringSrc.Shortcut.IFR = Temp
										Exit For
									End If
								Next k
								If StringSrc.Shortcut.IFR <> "" Then Exit For
							Next j
						End If
						If StringSrc.Shortcut.IFR <> "" Then Exit For
					End If
				End If
			Next i
			If StringSrc.Shortcut.IFR = "" Then
				StringSrc.Shortcut.Length = 0
				StringSrc.Shortcut.Loction = 0
				StringSrc.Shortcut.sString = ""
			End If
			'ȡļ
			For i = 0 To UBound(TempList)
				If CheckStrRegExp(StringTrn.LastString,TempList(i),0,2) = True Then
					Temp = "\x20*" & TempList(i) & ".*$"
					If GetSubStrInfoRegExp(StringTrn.Shortcut,StringTrn.LastString,Temp,0,-1,False,True) = True Then
						Temp = Convert(TempList(i))
						If StringTrn.Shortcut.sString = Temp & "+" Then
							'ȥ
							StringTrn.LastString = Left(StringTrn.LastString,StringTrn.Shortcut.Loction - 1)
							StringTrn.Shortcut.IFR = Temp
						Else
							For j = 0 To UBound(TempArry)
								TempArr = ReSplit(LCase(Replace(StringTrn.Shortcut.sString,Temp,"")),"+")
								For k = 0 To UBound(TempArr)
									If CheckLike(Trim(TempArr(k)),LCase(TempArry(j))) Then
										'ȥ
										StringTrn.LastString = Left(StringTrn.LastString,StringTrn.Shortcut.Loction - 1)
										StringTrn.Shortcut.IFR = Temp
										Exit For
									End If
								Next k
								If StringTrn.Shortcut.IFR <> "" Then Exit For
							Next j
						End If
						If StringTrn.Shortcut.IFR <> "" Then Exit For
					End If
				End If
			Next i
			If StringTrn.Shortcut.IFR = "" Then
				StringTrn.Shortcut.Length = 0
				StringTrn.Shortcut.Loction = 0
				StringTrn.Shortcut.sString = ""
			ElseIf .KeepShortKey <> "" Then
				'ļ
				Temp = LCase(StringTrn.Shortcut.sString)
				TempList = ReSplit(.KeepShortKey,",",-1)
				For i = 0 To UBound(TempList)
					If CheckLike(Temp,"*" & LCase(TempList(i)) & "*") Then
						StringSrc.Shortcut.sString = StringTrn.Shortcut.sString
						Exit For
					End If
				Next i
			End If
		End If
		'ȡԴͷֹ(ǰո)λڿݼ
		If .CheckEndChar <> "" Then
			TempList = ReSplit(.CheckEndChar," ")
			For i = 0 To UBound(TempList)
				Temp = "\x20*" & TempList(i) & "\x20*$"
				If GetSubStrInfoRegExp(StringSrc.EndString,StringSrc.LastString,Temp,-1,-1,True,True) = True Then
					Exit For
				End If
			Next i
			For i = 0 To UBound(TempList)
				Temp = "\x20*" & TempList(i) & "\x20*$"
				If GetSubStrInfoRegExp(StringTrn.EndString,StringTrn.LastString,Temp,-1,-1,True,True) = True Then
					Exit For
				End If
			Next i
			'ǷΪֹ
			If .NotTrnEndChar <> "" Then
				If StringSrc.EndString.Loction > 1 Then
					Temp = RTrim(LCase(StringSrc.LastString))
					TempList = ReSplit(.NotTrnEndChar,",")
					For i = 0 To UBound(TempList)
						If CheckLike(Temp,"*" & LCase(TempList(i))) Then
							StringSrc.EndString.Length = 0
							StringSrc.EndString.Loction = 0
							StringSrc.EndString.sString = ""
							Exit For
						End If
					Next i
				End If
				If StringTrn.EndString.Loction > 1 Then
					Temp = RTrim(LCase(StringTrn.LastString))
					TempList = ReSplit(.NotTrnEndChar,",")
					For i = 0 To UBound(TempList)
						If CheckLike(Temp,"*" & LCase(TempList(i))) Then
							StringTrn.EndString.length = 0
							StringTrn.EndString.Loction = 0
							StringTrn.EndString.sString = ""
							Exit For
						End If
					Next i
				End If
			End If
			'ȥִеֹ
			If StringSrc.EndString.Loction > 0 Then
				If StringSrc.Length > 1 Then
					StringSrc.LastString = Left(StringSrc.LastString,StringSrc.EndString.Loction - 1)
				Else
					StringSrc.LastString = ""
				End If
			End If
			If StringTrn.EndString.Loction > 0 Then
				If StringTrn.Length > 1 Then
					StringTrn.LastString = Left(StringTrn.LastString,StringTrn.EndString.Loction - 1)
				Else
					StringTrn.LastString = ""
				End If
			End If
		End If
		'ȡݼλüַ(ǰźͿո)λִκλ
		If .AccKeyChar <> "" Then
			TempList = ReSplit(.AccKeyChar,",")
			TempArry = ReSplit(.CheckBracket,",")
			'ȡԴĿݼλüַ
			For i = 0 To UBound(TempList)
				If CheckStrRegExp(srcStr,TempList(i),0,2) = True Then
					For j = 0 To UBound(TempArry)
						Temp = "\x20*" & Left(TempArry(j),6) & "\x20*" & TempList(i) & "([^\x20])\x20*" & Mid(TempArry(j),7) & "\x20*"
						If GetSubStrInfoRegExp(StringSrc.AccKey,srcStr,Temp,-1,-1,True,True) = True Then
							Temp = TempList(i) & "([^\x20])"
							StringSrc.AccKey.Key = GetSubStringRegExp(StringSrc.AccKey.sString,Temp,0,0,False,True)
							StringSrc.AccKey.IFR = Convert(TempList(i))
							StringSrc.LastString = Left(StringSrc.LastString,StringSrc.AccKey.Loction - 1)
							Exit For
						End If
					Next j
					If StringSrc.AccKey.IFR <> "" Then Exit For
				End If
			Next i
			'ȡĿݼλüַ
			For i = 0 To UBound(TempList)
				If CheckStrRegExp(trnStr,TempList(i),0,2) = True Then
					For j = 0 To UBound(TempArry)
						Temp = "\x20*" & Left(TempArry(j),6) & "\x20*" & TempList(i) & "([^\x20])\x20*" & Mid(TempArry(j),7) & "\x20*"
						If GetSubStrInfoRegExp(StringTrn.AccKey,trnStr,Temp,-1,-1,True,True) = True Then
							Temp = TempList(i) & "([^\x20])"
							StringTrn.AccKey.Key = GetSubStringRegExp(StringTrn.AccKey.sString,Temp,0,0,False,True)
							StringTrn.AccKey.IFR = Convert(TempList(i))
							StringTrn.LastString = Left(StringTrn.LastString,StringTrn.AccKey.Loction - 1)
							Exit For
						End If
					Next j
					If StringTrn.AccKey.IFR <> "" Then Exit For
				End If
			Next i
			'ûҵŵĿݼʱֻҿݼ־
			If StringSrc.AccKey.IFR = "" Then
				For i = 0 To UBound(TempList)
					Temp = TempList(i) & "([^\x20])\x20*"
					If GetSubStrInfoRegExp(StringSrc.AccKey,srcStr,Temp,-1,-1,True,True) = True Then
						StringSrc.AccKey.Key = GetSubStringRegExp(StringSrc.AccKey.sString,Temp,0,0,False,True)
						StringSrc.AccKey.IFR = Convert(TempList(i))
						StringSrc.LastString = Left(StringSrc.LastString,StringSrc.AccKey.Loction - 1) & _
										Mid(StringSrc.LastString,StringSrc.AccKey.Loction + StringSrc.AccKey.Length - 1)
						Exit For
					End If
				Next i
			End If
			If StringTrn.AccKey.IFR = "" Then
				For i = 0 To UBound(TempList)
					Temp = TempList(i) & "([^\x20])\x20*"
					If GetSubStrInfoRegExp(StringTrn.AccKey,trnStr,Temp,-1,-1,True,True) = True Then
						StringTrn.AccKey.Key = GetSubStringRegExp(StringTrn.AccKey.sString,Temp,0,0,False,True)
						StringTrn.AccKey.IFR = Convert(TempList(i))
						StringTrn.LastString = Left(StringTrn.LastString,StringTrn.AccKey.Loction - 1) & _
										Mid(StringTrn.LastString,StringTrn.AccKey.Loction + StringTrn.AccKey.Length - 1)
						Exit For
					End If
				Next i
			End If
		End If
		'ȥֹеĿݼ
		If .AccKeyChar <> "" Then
			TempList = ReSplit(.AccKeyChar,",")
			For i = 0 To UBound(TempList)
				TempList(i) = Convert(TempList(i))
				StringSrc.Shortcut.sString = Replace(StringSrc.Shortcut.sString,TempList(i),"")
				StringSrc.Shortcut.sString = Replace(StringSrc.Shortcut.sString,TempList(i),"")
				StringSrc.EndString.sString = Replace(StringSrc.EndString.sString,TempList(i),"")
				StringSrc.EndString.sString = Replace(StringSrc.EndString.sString,TempList(i),"")
			Next i
		End If
		'ȥִǰÿո
		StringSrc.LastString = LTrim(StringSrc.LastString)
		StringTrn.LastString = LTrim(StringTrn.LastString)
	End With

	'PSL.OutputWnd(0).Clear
	'PSL.Output "------------------------------ "
	'PSL.Output "srcStr = " & srcStr
	'PSL.Output "trnStr = " & trnStr
	'PSL.Output "PreSpaceSrc = " & StringSrc.PreSpace.sString
	'PSL.Output "PreSpaceTrn = " & StringTrn.PreSpace.sString
	'PSL.Output "AcckeySrc = " & StringSrc.AccKey.sString
	'PSL.Output "AcckeyTrn = " & StringTrn.AccKey.sString
	'PSL.Output "AcckeySrcKey = " & StringSrc.AccKey.Key
	'PSL.Output "AcckeyTrnKey = " & StringTrn.AccKey.Key
	'PSL.Output "AcckeySrcIFR = " & StringSrc.AccKey.IFR
	'PSL.Output "AcckeyTrnIFR = " & StringTrn.AccKey.IFR
	'PSL.Output "EndStringSrc = " & StringSrc.EndString.sString
	'PSL.Output "EndStringTrn = " & StringTrn.EndString.sString
	'PSL.Output "ShortcutSrc = " & StringSrc.Shortcut.sString
	'PSL.Output "ShortcutTrn = " & StringTrn.Shortcut.sString
	'PSL.Output "LastStringSrc = " & StringSrc.LastString
	'PSL.Output "LastStringTrn = " & StringTrn.LastString

	'ÿݼʽ
	If StringSrc.AccKey.Length > 0 Then
		If CheckList(CheckID).ShowAsiaKey = 0 Then
			If StringTrn.AccKey.Length = 0 Then
				'ȲǷпݼַ
				i = CheckStrRegExp(StringTrn.LastString,StringSrc.AccKey.Key,0,0,True)
				If i > 0 Then
					StringTrn.LastString = strReplace(StringTrn.LastString,StringSrc.AccKey.Key, _
											StringSrc.AccKey.IFR & Mid(StringTrn.LastString,i,1),i,1)
				Else
					'ݼʹý
					j = 0
					If ProjectList(ProjectID).UseAcckeyInShortcut = 1 Then
						If StringTrn.EndString.Length > 0 Then
							i = CheckStrRegExp(StringTrn.EndString.sString,StringSrc.AccKey.Key,0,0,True)
							If i > 0 Then
								StringTrn.LastString = strReplace(StringTrn.EndString.sString,StringSrc.AccKey.Key, _
													StringSrc.AccKey.IFR & Mid(StringTrn.EndString.sString,i,1),i,1)
								j = j + 1
							End If
						End If
						'ݼʹüеַ
						If j = 0 Then
							If StringTrn.Shortcut.Length > 0 Then
								i = CheckStrRegExp(StringTrn.Shortcut.sString,StringSrc.AccKey.Key,0,0,True)
								If i > 0 Then
									StringTrn.LastString = strReplace(StringTrn.Shortcut.sString,StringSrc.AccKey.Key, _
														StringSrc.AccKey.IFR & Mid(StringTrn.Shortcut.sString,i,1),i,1)
									j = j + 1
								End If
							End If
						End If
					End If
					'ݼʹ׸ַ
					If j = 0 Then
						If CheckList(CheckID).AccKeyWithFirstChar = 1 Then
							i = CheckStrRegExp(StringTrn.LastString,CheckSkipStr(5),0,0,True)
							If i > 0 Then
								StringTrn.LastString = strReplace(StringTrn.LastString,Mid(StringTrn.LastString,i,1), _
													StringSrc.AccKey.IFR & Mid(StringTrn.LastString,i,1),i,1)
							End If
						End If
					End If
				End If
			End If
		Else
			StringSrc.AccKey.sString = "(" & StringSrc.AccKey.IFR & UCase(StringSrc.AccKey.Key) & ")"
		End If
	End If

	'Ӧ÷鷽
	With ProjectList(ProjectID)
		'ִѡ
		If StrToLong(cSelected(14)) = 0 Then
			If StrToLong(cSelected(15)) = 0 Then
				.AcckeyInSource = 0
				.AcckeyInTarget = 0
				.AcckeyInBoth = 0
			End If
			If StrToLong(cSelected(16)) = 0 Then
				.EndStrInSource = 0
				.EndStrInTarget = 0
				.EndStrInBoth = 0
				.TranEndStr = 0
			End If
			If StrToLong(cSelected(17)) = 0 Then
				.ShortcutInSource = 0
				.ShortcutInTarget = 0
				.ShortcutInBoth = 0
			End If
		End If

		'Ӧ÷鷽
		If StringSrc.PreSpace.Length > 0 And StringTrn.PreSpace.Length > 0 Then
			If .PreSpaceInBoth = 0 Then
				StringSrc.PreSpace.sString = StringTrn.PreSpace.sString
			ElseIf .PreSpaceInBoth = 2 Then
				StringSrc.PreSpace.sString = ""
			End If
		ElseIf StringSrc.PreSpace.Length > 0 Then
			If .PreSpaceInSource = 0 Then StringSrc.PreSpace.sString = StringTrn.PreSpace.sString
		ElseIf StringTrn.PreSpace.Length > 0 Then
			If .PreSpaceInTarget = 0 Then StringSrc.PreSpace.sString = StringTrn.PreSpace.sString
		End If

		If StringSrc.EndSpace.Length > 0 And StringTrn.EndSpace.Length > 0 Then
			If .EndSpaceInBoth = 0 Then
				StringSrc.EndSpace.sString = StringTrn.EndSpace.sString
			ElseIf .EndSpaceInBoth = 2 Then
				StringSrc.EndSpace.sString = ""
			End If
		ElseIf StringSrc.EndSpace.Length > 0 Then
			If .EndSpaceInSource = 0 Then StringSrc.EndSpace.sString = StringTrn.EndSpace.sString
		ElseIf StringTrn.EndSpace.Length > 0 Then
			If .EndSpaceInTarget = 0 Then StringSrc.EndSpace.sString = StringTrn.EndSpace.sString
		End If

		If StringSrc.AccKey.Length > 0 And StringTrn.AccKey.Length > 0 Then
			If .AcckeyInBoth = 0 Then
				StringSrc.AccKey.sString = StringTrn.AccKey.sString
				StringSrc.AccKey.IFR = StringTrn.AccKey.IFR
				StringSrc.AccKey.Key = StringTrn.AccKey.Key
			ElseIf .AcckeyInBoth = 2 Then
				StringSrc.AccKey.sString = ""
				StringSrc.AccKey.IFR = ""
				StringSrc.AccKey.Key = ""
			End If
		ElseIf StringSrc.AccKey.Length > 0 Then
			If .AcckeyInSource = 0 Then
				StringSrc.AccKey.sString = StringTrn.AccKey.sString
				StringSrc.AccKey.IFR = StringTrn.AccKey.IFR
				StringSrc.AccKey.Key = StringTrn.AccKey.Key
			End If
		ElseIf StringTrn.AccKey.Length > 0 Then
			If .AcckeyInTarget = 0 Then
				StringSrc.AccKey.sString = StringTrn.AccKey.sString
				StringSrc.AccKey.IFR = StringTrn.AccKey.IFR
				StringSrc.AccKey.Key = StringTrn.AccKey.Key
			End If
		End If

		If StringSrc.EndString.Length > 0 And StringTrn.EndString.Length > 0 Then
			If .EndStrInBoth = 0 Then
				StringSrc.EndString.sString = StringTrn.EndString.sString
			ElseIf .EndStrInBoth = 2 Then
				StringSrc.EndString.sString = ""
			End If
		ElseIf StringSrc.EndString.Length > 0 Then
			If .EndStrInSource = 0 Then StringSrc.EndString.sString = StringTrn.EndString.sString
		ElseIf StringTrn.EndString.Length > 0 Then
			If .EndStrInTarget = 0 Then StringSrc.EndString.sString = StringTrn.EndString.sString
		End If

		If StringSrc.Shortcut.Length > 0 And StringTrn.Shortcut.Length > 0 Then
			If .ShortcutInBoth = 0 Then
				StringSrc.Shortcut.sString = StringTrn.Shortcut.sString
			ElseIf .ShortcutInBoth = 2 Then
				StringSrc.Shortcut.sString = ""
			End If
		ElseIf StringSrc.Shortcut.Length > 0 Then
			If .ShortcutInSource = 0 Then StringSrc.Shortcut.sString = StringTrn.Shortcut.sString
		ElseIf StringTrn.Shortcut.Length > 0 Then
			If .ShortcutInTarget = 0 Then StringSrc.Shortcut.sString = StringTrn.Shortcut.sString
		End If

		'Զֹ
		If .TranEndStr = 1 Then
			If CheckList(CheckID).AutoTrnEndChar <> "" Then
				TempList = ReSplit(CheckList(CheckID).AutoTrnEndChar," ")
				For i = 0 To UBound(TempList)
					If InStr(TempList(i),"|") Then
						TempArry = ReSplit(TempList(i),"|")
						If Trim(StringSrc.EndString.sString) = TempArry(0) Then
							StringSrc.EndString.sString = Replace(TempArry(1),TempArry(0),TempArry(1))
							Exit For
						End If
					End If
				Next i
			End If
		End If

		'ɾո
		If .DelSpace = 1 Then
			StringSrc.EndString.sString = RemoveSpace(StringSrc.SpaceForEndString,Trim(StringSrc.EndString.sString),0)
			StringSrc.Shortcut.sString = RemoveSpace(StringSrc.SpaceForShortcut,Trim(StringSrc.Shortcut.sString),1)
			StringSrc.AccKey.sString = RemoveSpace(StringSrc.SpaceForAccKey,Trim(StringSrc.AccKey.sString),0)
			'ɾַڵĶո
			StringTrn.LastString = RemoveSpace(StringTrn.SpaceForVariable,StringTrn.LastString,2)
		End If
		'ɾӢĺַ֮Ŀո
		If .SpaceForEnAndAsia = 1 Then
			StringTrn.LastString = RemoveSpace(StringTrn.PreSpaceForEnAndAsia,StringTrn.LastString,3)
			StringTrn.LastString = RemoveSpace(StringTrn.EndSpaceForEnAndAsia,StringTrn.LastString,4)
		End If
	End With

	'֯滻ַ
	With StringSrc
		If CheckList(CheckID).ShowAsiaKey = 0 Then
			StringReplace = .PreSpace.sString & StringTrn.LastString & .EndString.sString & .Shortcut.sString & .EndSpace.sString
		Else
			StringReplace = .PreSpace.sString & StringTrn.LastString & .AccKey.sString & .EndString.sString & .Shortcut.sString & StringSrc.EndSpace.sString
		End If
	End With
End Function


' ޸Ϣ
Public Function CheckMassage(ByVal CheckID As Integer,ByVal ProjectID As Integer) As String
	Dim i As Long,j As Long,m As Long,a As Long,d As Long
	Dim ModifiedMsg() As String,AddedMsg() As String,MovedMsg() As String
	Dim DeledMsg() As String,ReplacedMsg() As String,Massage() As String
	Dim MsgList() As String

	If getMsgList(UIDataList,MsgList,"CheckMassage",1) = False Then Exit Function
	If ProjectID = 0 Then
		For i = 21 To 25
			MsgList(i) = MsgList(i + 8)
		Next i
	End If
	'ʼ
	ReDim ModifiedMsg(m),AddedMsg(a),MovedMsg(0),DeledMsg(d),ReplacedMsg(0),Massage(0)

	'ݼֵ
	If StringSrc.AccKey.Key <> StringTrn.AccKey.Key Then
		If StringSrc.AccKey.Key <> "" And StringTrn.AccKey.Key <> "" Then
			If LCase(StringSrc.AccKey.Key) = LCase(StringTrn.AccKey.Key) Then
				ModifiedMsg(m) = MsgList(1)
				m = m + 1
			Else
				ModifiedMsg(m) = MsgList(0)
				m = m + 1
			End If
		ElseIf StringSrc.AccKey.Key <> "" Then
			AddedMsg(a) = MsgList(0)
			a = a + 1
		ElseIf StringTrn.AccKey.Key <> "" Then
			DeledMsg(d) = MsgList(0)
			d = d + 1
		End If
	End If

	'ֹ
	If StringSrc.EndString.sString <> StringTrn.EndString.sString Then
		If StringSrc.EndString.sString <> "" And StringTrn.EndString.sString <> "" Then
			ReDim Preserve ModifiedMsg(m)
			ModifiedMsg(m) = MsgList(2)
			m = m + 1
		ElseIf StringSrc.EndString.sString <> "" Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(2)
			a = a + 1
		ElseIf StringTrn.EndString.sString <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(2)
			d = d + 1
		End If
	End If

	'
	If StringSrc.Shortcut.sString <> StringTrn.Shortcut.sString Then
		If StringSrc.Shortcut.sString <> "" And StringTrn.Shortcut.sString <> "" Then
			ReDim Preserve ModifiedMsg(m)
			ModifiedMsg(m) = MsgList(3)
			m = m + 1
		ElseIf StringSrc.Shortcut.sString <> "" Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(3)
			a = a + 1
		ElseIf StringTrn.Shortcut.sString <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(3)
			d = d + 1
		End If
	End If

	'ǰÿո
	If StringSrc.PreSpace.sString <> StringTrn.PreSpace.sString Then
		If StringSrc.PreSpace.sString <> "" And StringTrn.PreSpace.sString <> "" Then
			ReDim Preserve ModifiedMsg(m)
			ModifiedMsg(m) = MsgList(4)
			m = m + 1
		ElseIf StringSrc.PreSpace.sString <> "" Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(4)
			a = a + 1
		ElseIf StringTrn.PreSpace.sString <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(4)
			d = d + 1
		End If
	End If

	'ÿո
	If StringSrc.EndSpace.sString <> StringTrn.EndSpace.sString Then
		If StringSrc.EndSpace.sString <> "" And StringTrn.EndSpace.sString <> "" Then
			ReDim Preserve ModifiedMsg(m)
			ModifiedMsg(m) = MsgList(5)
			m = m + 1
		ElseIf StringSrc.EndSpace.sString <> "" Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(5)
			a = a + 1
		ElseIf StringTrn.EndSpace.sString <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(5)
			d = d + 1
		End If
	End If

	'ݼֹǰмĿո
	If ProjectList(ProjectID).DelSpace = 1 Then
		If StringTrn.Shortcut.Length > 0 Then
			i = StringTrn.Shortcut.Length - Len(LTrim(StringTrn.Shortcut.sString))
			j = StringTrn.Shortcut.Length - Len(RTrim(StringTrn.Shortcut.sString))
			If i <> 0 And j <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(6)
				d = d + 1
			ElseIf i <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(7)
				d = d + 1
			ElseIf j <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(8)
				d = d + 1
			End If
			If StringSrc.SpaceForShortcut < 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(34)
				d = d + 1
			End If
		End If
		If StringTrn.EndString.Length > 0 Then
			i = StringTrn.EndString.Length - Len(LTrim(StringTrn.EndString.sString))
			j = StringTrn.EndString.Length - Len(RTrim(StringTrn.EndString.sString))
			If i <> 0 And j <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(9)
				d = d + 1
			ElseIf i <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(10)
				d = d + 1
			ElseIf j <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(11)
				d = d + 1
			End If
			If StringSrc.SpaceForEndString < 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(35)
				d = d + 1
			End If
		End If
		If StringTrn.AccKey.Length > 0 Then
			i = StringTrn.AccKey.Length - Len(LTrim(StringTrn.AccKey.sString))
			j = StringTrn.AccKey.Length - Len(RTrim(StringTrn.AccKey.sString))
			If i <> 0 And j <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(12)
				d = d + 1
			ElseIf i <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(13)
				d = d + 1
			ElseIf j <> 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(14)
				d = d + 1
			End If
			If StringSrc.SpaceForAccKey < 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(36)
				d = d + 1
			End If
		End If
		'ַڵĿո
		If StringTrn.SpaceForVariable < 0 Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(37)
			d = d + 1
		End If
	End If

	'ַַ֮Ŀո
	If ProjectList(ProjectID).SpaceForEnAndAsia = 1 Then
		If StringTrn.PreSpaceForEnAndAsia > 0 Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(38)
			a = a + 1
		End If
		If StringTrn.PreSpaceForEnAndAsia < 0 Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(38)
			d = d + 1
		End If
		If StringTrn.EndSpaceForEnAndAsia > 0 Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(38)
			a = a + 1
		End If
		If StringTrn.EndSpaceForEnAndAsia < 0 Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(38)
			d = d + 1
		End If
	End If

	'ݼǰַƶ
	If CheckList(CheckID).ShowAsiaKey = 1 Then
		If StringSrc.AccKey.sString <> "" Then
			If StringSrc.AccKey.Loction > 0 And StringTrn.AccKey.Loction > 0 Then
				If StringTrn.Shortcut.Loction > 0 Then
					If StringTrn.AccKey.Loction > StringTrn.Shortcut.Loction Then
						If StringTrn.EndString.Loction > 0 Then
							MovedMsg(0) = MsgList(15)
						Else
							MovedMsg(0) = MsgList(16)
						End If
					ElseIf StringTrn.EndString.Loction > 0 Then
						If StringTrn.AccKey.Loction > StringTrn.EndString.Loction Then
							MovedMsg(0) = MsgList(17)
						ElseIf StringTrn.AccKey.Loction + StringTrn.AccKey.Length <	StringTrn.EndString.Loction - 1 Then
							MovedMsg(0) = MsgList(18)
						End If
					ElseIf StringTrn.AccKey.Loction + StringTrn.AccKey.Length < StringTrn.Shortcut.Loction - 1 Then
						MovedMsg(0) = MsgList(19)
					End If
				ElseIf StringTrn.EndString.Loction > 0 Then
					If StringTrn.AccKey.Loction > StringTrn.EndString.Loction Then
						MovedMsg(0) = MsgList(17)
					ElseIf StringTrn.AccKey.Loction + StringTrn.AccKey.Length <	StringTrn.EndString.Loction - 1 Then
						MovedMsg(0) = MsgList(18)
					End If
				ElseIf StringTrn.AccKey.Loction + StringTrn.AccKey.Length < StringTrn.Length Then
					MovedMsg(0) = MsgList(20)
				End If
			End If
		End If
	End If

	'滻ַ
	With StringTrn
		If .PreRepStr <> "" And .AppRepStr <> "" Then
			ReDim Preserve ReplacedMsg(1) As String
			ReplacedMsg(0) = Replace(.PreRepStr,JoinStr,MsgList(26))
			ReplacedMsg(1) = Replace(.AppRepStr,JoinStr,MsgList(26))
		ElseIf .PreRepStr <> "" And .AppRepStr = "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = Replace(.PreRepStr,JoinStr,MsgList(26))
		End If
	End With

	'֯Ϣ
	i = 0
	If CheckArray(ModifiedMsg) = True Then
		Massage(i) = Replace(MsgList(21),"%s",Join(ClearTextArray(ModifiedMsg,1),MsgList(26)))
		CheckCountList(0) = CheckCountList(0) + 1
		i = i + 1
	End If
	If CheckArray(AddedMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(MsgList(22),"%s",Join(ClearTextArray(AddedMsg,1),MsgList(26)))
		CheckCountList(1) = CheckCountList(1) + 1
		i = i + 1
	End If
	If CheckArray(MovedMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(MsgList(23),"%s",Join(ClearTextArray(MovedMsg,1),MsgList(26)))
		CheckCountList(2) = CheckCountList(2) + 1
		i = i + 1
	End If
	If CheckArray(DeledMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(MsgList(24),"%s",Join(ClearTextArray(DeledMsg,1),MsgList(26)))
		CheckCountList(3) = CheckCountList(3) + 1
		i = i + 1
	End If
	If CheckArray(ReplacedMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(Replace(MsgList(25),"%s",ReplacedMsg(0)),"%d",ReplacedMsg(1))
		CheckCountList(4) = CheckCountList(4) + 1
	End If
	If CheckArray(Massage) = True Then CheckMassage = Join(Massage,MsgList(27)) & MsgList(28)
End Function


'Ϣ
Public Function LineErrMassage(ByVal srcLineNum As Integer,ByVal trnLineNum As Integer,LineNumErrCount As Integer) As String
	If srcLineNum = trnLineNum Then Exit Function
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"LineErrMassage",1) = False Then Exit Function
	If srcLineNum > trnLineNum Then
		LineErrMassage = Replace(MsgList(0),"%s",CStr(srcLineNum - trnLineNum))
		LineNumErrCount = LineNumErrCount + 1
	ElseIf srcLineNum < trnLineNum Then
		LineErrMassage = Replace(MsgList(1),"%s",CStr(trnLineNum - srcLineNum))
		LineNumErrCount = LineNumErrCount + 1
	End If
End Function


'ݼϢ
Public Function AccKeyErrMassage(ByVal srcAccKeyNum As Integer,ByVal trnAccKeyNum As Integer,accKeyNumErrCount As Integer) As String
	If srcAccKeyNum = trnAccKeyNum Then Exit Function
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"AccKeyErrMassage",1) = False Then Exit Function
	If srcAccKeyNum > trnAccKeyNum Then
		AccKeyErrMassage = Replace(MsgList(0),"%s",CStr(srcAccKeyNum - trnAccKeyNum))
		accKeyNumErrCount = accKeyNumErrCount + 1
	ElseIf srcAccKeyNum < trnAccKeyNum Then
		AccKeyErrMassage = Replace(MsgList(1),"%s",CStr(trnAccKeyNum - srcAccKeyNum))
		accKeyNumErrCount = accKeyNumErrCount + 1
	End If
End Function


'Ϣ
Public Function CountMassage(CheckCount() As Integer,ByVal ErrorCount As Long,ByVal ProjectID As Long) As String
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"CountMassage",1) = False Then Exit Function
	Select Case ProjectID
	Case 0
		If ErrorCount = 0 Then
			CountMassage = MsgList(0)
		Else
			CountMassage = MsgList(1) & MsgList(2) & MsgList(3)
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(CheckCountList(0)))
			CountMassage = Replace(CountMassage,"%a",CStr(CheckCountList(1)))
			CountMassage = Replace(CountMassage,"%v",CStr(CheckCountList(2)))
			CountMassage = Replace(CountMassage,"%d",CStr(CheckCountList(3)))
			CountMassage = Replace(CountMassage,"%r",CStr(CheckCountList(4)))
			CountMassage = Replace(CountMassage,"%ln",CStr(CheckCountList(5)))
			CountMassage = Replace(CountMassage,"%kn",CStr(CheckCountList(6)))
		End If
	Case 1, Is > 3
		If ErrorCount = 0 Then
			CountMassage = MsgList(10)
		Else
			CountMassage = MsgList(11) & MsgList(4) & MsgList(3)
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(CheckCountList(0)))
			CountMassage = Replace(CountMassage,"%a",CStr(CheckCountList(1)))
			CountMassage = Replace(CountMassage,"%v",CStr(CheckCountList(2)))
			CountMassage = Replace(CountMassage,"%d",CStr(CheckCountList(3)))
			CountMassage = Replace(CountMassage,"%r",CStr(CheckCountList(4)))
			CountMassage = Replace(CountMassage,"%ln",CStr(CheckCountList(5)))
			CountMassage = Replace(CountMassage,"%kn",CStr(CheckCountList(6)))
		End If
	Case 2
		If ErrorCount = 0 Then
			CountMassage = MsgList(5)
		Else
			CountMassage = MsgList(6) & MsgList(7)
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(CheckCountList(0)))
			CountMassage = Replace(CountMassage,"%a",CStr(CheckCountList(1)))
			CountMassage = Replace(CountMassage,"%w",CStr(CheckCountList(3)))
		End If
	Case 3
		If ErrorCount = 0 Then
			CountMassage = MsgList(8)
		Else
			CountMassage = MsgList(9) & MsgList(7)
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(CheckCountList(0)))
			CountMassage = Replace(CountMassage,"%a",CStr(CheckCountList(1)))
			CountMassage = Replace(CountMassage,"%w",CStr(CheckCountList(3)))
		End If
	End Select
End Function


'Ϣ
Public Sub sysErrorMassage(sysError As ErrObject,ByVal fType As Long,Optional ByVal Mode As Boolean)
	Dim TempArray() As String,MsgList() As String
	Dim ErrorNumber As Long,ErrorSource As String,ErrorDescription As String
	Dim TitleMsg As String,ContinueMsg As String,Msg As String

	ErrorNumber = sysError.Number
	ErrorSource = sysError.Source
	ErrorDescription = sysError.Description

	TitleMsg = "Error"
	Select Case fType
	Case 0
		ContinueMsg = vbCrLf & vbCrLf & "The program cannot continue and will exit."
	Case 1
		ContinueMsg = vbCrLf & vbCrLf & "Do you want to continue?"
	Case 2
		ContinueMsg = vbCrLf & vbCrLf & "The program will continue to run."
	End Select

	If CheckINIArray(UIDataList) = True Then
		If getMsgList(UIDataList,MsgList,"sysErrorMassage",3) = False Then
			If getMsgList(UIDataList,MsgList,"Main",3) = False Then
				Msg = "The following file is missing [Main|sysErrorMassage] section." & vbCrLf & "%s"
				Msg = Replace$(Msg,"%s",LangFile)
			Else
				TitleMsg = MsgList(26)
				If fType <> 0 Then ContinueMsg = MsgList(24) Else ContinueMsg = MsgList(25)
				Msg = Replace(Replace(MsgList(23),"%s","sysErrorMassage"),"%d",LangFile)
			End If
		Else
			TitleMsg = MsgList(0)
			Select Case fType
			Case 0
				ContinueMsg = MsgList(12)
			Case 1
				ContinueMsg = MsgList(13)
			Case 2
				ContinueMsg = MsgList(14)
			End Select

			Select Case ErrorSource
			Case ""
				If ErrorNumber = 10051 And PSL.Version >= 1500 Then
					Msg = Replace$(MsgList(15),"%s",ErrorSource)
				Else
					Msg = Replace$(Replace$(MsgList(1),"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
				End If
			Case "NotSection"
				TempArray = ReSplit(ErrorDescription,JoinStr,-1)
				Msg = Replace$(Replace$(MsgList(3),"%s",TempArray(1)),"%d",TempArray(0))
			Case "NotValue"
				TempArray = ReSplit(ErrorDescription,JoinStr,-1)
				Msg = Replace$(Replace$(MsgList(4),"%s",TempArray(1)),"%d",TempArray(0))
			Case "NotReadFile"
				TempArray = ReSplit(ErrorDescription,JoinStr,-1)
				Msg = Replace$(MsgList(5),"%s",TempArray(1))
			Case "NotWriteFile"
				TempArray = ReSplit(ErrorDescription,JoinStr,-1)
				Msg = Replace$(MsgList(6),"%s",TempArray(1))
			Case "NotUnWriteFile"
				TempArray = ReSplit(ErrorDescription,JoinStr,-1)
				Msg = Replace$(MsgList(7),"%s",TempArray(1))
			Case "NotOpenFile"
				TempArray = ReSplit(ErrorDescription,JoinStr,-1)
				Msg = Replace$(MsgList(8),"%s",TempArray(1))
			Case "NotINIFile"
				Msg = Replace$(MsgList(9),"%s",ErrorDescription)
			Case "NotExitFile"
				Msg = Replace$(MsgList(10),"%s",ErrorDescription)
			Case "NotVersion"
				TempArray = ReSplit(ErrorDescription,JoinStr,-1)
				Msg = Replace$(MsgList(11),"%s",TempArray(0))
				Msg = Replace$(Replace$(Msg,"%d",TempArray(1)),"%v",TempArray(2))
			Case Else
				Msg = Replace$(MsgList(2),"%s",ErrorSource)
				Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
			End Select
		End If
	Else
		Select Case ErrorSource
		Case ""
			If ErrorNumber = 10051 And PSL.Version >= 1500 Then
				Msg = "Unable to open the file. Please verify the file path and file name" & _
						"contains characters in Asian languages. " & vbCrLf & _
						"Note: Passolo 2015 Version of the macro engine does not recognize" & _
						"the file path and file name contains Asian language characters."
			Else
				Msg = "An Error occurred in the program design." & vbCrLf & "Error Code: %d, Content: %v" & _
						vbCrLf & "Please restart the Passolo try and please report to the software developer."
				Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
			End If
		Case "NotSection"
			TempArray = ReSplit(ErrorDescription,JoinStr,-1)
			Msg = "The following file is missing [%s] section." & vbCrLf & "%d"
			Msg = Replace$(Replace$(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotValue"
			TempArray = ReSplit(ErrorDescription,JoinStr,-1)
			Msg = "The following file is missing [%s] Value." & vbCrLf & "%d"
			Msg = Replace$(Replace$(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotReadFile"
			Msg = Replace$(ErrorDescription,JoinStr,vbCrLf)
		Case "NotWriteFile"
			Msg = Replace$(ErrorDescription,JoinStr,vbCrLf)
		Case "NotUnWriteFile"
			Msg = Replace$(ErrorDescription,JoinStr,vbCrLf)
		Case "NotOpenFile"
			Msg = Replace$(ErrorDescription,JoinStr,vbCrLf)
		Case "NotINIFile"
			Msg = "The following contents of the file is not correct." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",ErrorDescription)
		Case "NotExitFile"
			Msg = "The following file does not exist! Please check and try again." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",ErrorDescription)
		Case "NotVersion"
			TempArray = ReSplit(ErrorDescription,JoinStr,-1)
			Msg = "The following file version is %d, requires version at least %v." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",TempArray(0))
			Msg = Replace$(Replace$(Msg,"%d",TempArray(1)),"%v",TempArray(2))
		Case Else
			Msg = "Your system is missing %s server." & vbCrLf & "Error Code: %d, Content: %v"
			Msg = Replace$(Msg,"%s",ErrorSource)
			Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
		End Select
	End If

	If Msg = "" Then Exit Sub
	If Mode = False Then
		Select Case fType
		Case 0
			MsgBox Msg & ContinueMsg,vbOkOnly+vbInformation,TitleMsg
			Call ExitMacro(1)
		Case 1
			If MsgBox(Msg & ContinueMsg,vbYesNo+vbInformation,TitleMsg) = vbNo Then
				Call ExitMacro(1)
			End If
		Case Else
			MsgBox Msg & ContinueMsg,vbOkOnly+vbInformation,TitleMsg
		End Select
	Else
		Select Case fType
		Case 0
			PSL.Output(TitleMsg & ": "  & Msg)
			Exit All
		Case 1
			PSL.Output(TitleMsg & ": "  & Msg)
			Exit All 'Err.Raise(1,"ExitSub")
		Case Else
			PSL.Output(TitleMsg & ": "  & Msg)
		End Select
	End If
End Sub


'ִת
'Mode = 0  PSL 汾ĺ治ֱͬתַȫ򲿷չַ
'Mode = 1 תַչַ
'Mode = 2 תַͲϵͳʾչַ
'Mode = 3 תַ
Public Function ReConvert(ByVal ConverString As String,Optional ByVal Mode As Integer) As String
	ReConvert = ConverString
	If ReConvert = "" Then Exit Function
	If InStr(ReConvert,"\") Then ReConvert = Replace$(ReConvert,"\","\\")
	If InStr(ReConvert,vbCrLf) Then ReConvert = Replace$(ReConvert,vbCrLf,"\r\n")
	If InStr(ReConvert,vbNewLine) Then ReConvert = Replace$(ReConvert,vbNewLine,"\r\n")
	If InStr(ReConvert,vbCr) Then ReConvert = Replace$(ReConvert,vbCr,"\r")
	If InStr(ReConvert,vbLf) Then ReConvert = Replace$(ReConvert,vbLf,"\n")
	If InStr(ReConvert,vbBack) Then ReConvert = Replace$(ReConvert,vbBack,"\b")
	If InStr(ReConvert,vbFormFeed) Then ReConvert = Replace$(ReConvert,vbFormFeed,"\f")
	If InStr(ReConvert,vbVerticalTab) Then ReConvert = Replace$(ReConvert,vbVerticalTab,"\v")
	If InStr(ReConvert,vbTab) Then ReConvert = Replace$(ReConvert,vbTab,"\t")
	If InStr(ReConvert,vbNullChar) Then ReConvert = Replace$(ReConvert,vbNullChar,"\0")
	ReConvert = ReConvertBRegExp(ReConvert,Mode)
End Function


'תչַΪʮת
'Mode = 0  PSL 汾ĺ治ֱͬתַȫ򲿷չַ
'Mode = 1 תַչַ
'Mode = 2 תַͲϵͳʾչַ
'Mode = 3 תַ
Private Function ReConvertB(ByVal ConverString As String,Optional ByVal Mode As Integer) As String
	Dim i As Long,Dec As Long,Temp As String
	ReConvertB = ConverString
	If Mode = 0 Then
		Mode = IIf(Int(PSL.Version / 100) < 15,1,2)
	End If
	Select Case Mode
	Case 1
		For i = 1 To Len(ConverString)
			Temp = Mid$(ConverString,i,1)
			If InStr(ReConvertB,Temp) Then
				Dec = AscW(Temp)
				Select Case Dec
				Case 0 To 31,127 To 255
					ReConvertB = Replace$(ReConvertB,Temp,"\x" & Right$("0" & Hex$(Dec),2))
				End Select
			End If
		Next i
	Case 2
		For i = 1 To Len(ConverString)
			Temp = Mid$(ConverString,i,1)
			If InStr(ReConvertB,Temp) Then
				Dec = AscW(Temp)
				Select Case Dec
				Case 0 To 31,127,129,141,143,144,157,173
					ReConvertB = Replace$(ReConvertB,Temp,"\x" & Right$("0" & Hex$(Dec),2))
				End Select
			End If
		Next i
	Case 3
		For i = 1 To Len(ConverString)
			Temp = Mid$(ConverString,i,1)
			If InStr(ReConvertB,Temp) Then
				Dec = AscW(Temp)
				Select Case Dec
				Case 0 To 31,127
					ReConvertB = Replace$(ReConvertB,Temp,"\x" & Right$("0" & Hex$(Dec),2))
				End Select
			End If
		Next i
	End Select
End Function


'תչַΪʮת
'Mode = 0  PSL 汾ĺ治ֱͬתַȫ򲿷չַ
'Mode = 1 תַչַ
'Mode = 2 תַͲϵͳʾչַ
'Mode = 3 תַ
Private Function ReConvertBRegExp(ByVal ConverString As String,Optional ByVal Mode As Integer) As String
	Dim i As Long,Matches As Object
	ReConvertBRegExp = ConverString
	If Mode = 0 Then
		Mode = IIf(Int(PSL.Version / 100) < 15,1,2)
	End If
	With RegExp
		.Global = True
		.IgnoreCase = True
		Select Case Mode
		Case 1
			.Pattern = "[\x01-\x1F\x7F-\xFF]"
		Case 2
			.Pattern = "[\x01-\x1F\x7F\x81\x8D\x8F\x90\x9D\xAD]"
		Case 3
			.Pattern = "[\x01-\x1F\x7F]"
		End Select
		Set Matches = .Execute(ConverString)
		If Matches.Count > 0 Then
			For i = 0 To Matches.Count - 1
				ConverString = Right$("0" & Hex$(AscW(Matches(i).Value)),2)
				ReConvertBRegExp = Replace$(ReConvertBRegExp,Matches(i).Value,"\x" & ConverString)
			Next i
		End If
	End With
End Function


'ִת
Public Function Convert(ByVal ConverString As String) As String
	Convert = ConverString
	If Convert = "" Then Exit Function
	If InStr(Convert,"\") = 0 Then Exit Function
	If InStr(Convert,"\\") Then Convert = Replace$(Convert,"\\","*a!N!d*")
	If InStr(Convert,"\r\n") Then Convert = Replace$(Convert,"\r\n",vbCrLf)
	If InStr(Convert,"\r\n") Then Convert = Replace$(Convert,"\r\n",vbNewLine)
	If InStr(Convert,"\r") Then Convert = Replace$(Convert,"\r",vbCr)
	If InStr(Convert,"\r") Then Convert = Replace$(Convert,"\r",vbNewLine)
	If InStr(Convert,"\n") Then Convert = Replace$(Convert,"\n",vbLf)
	If InStr(Convert,"\b") Then Convert = Replace$(Convert,"\b",vbBack)
	If InStr(Convert,"\f") Then Convert = Replace$(Convert,"\f",vbFormFeed)
	If InStr(Convert,"\v") Then Convert = Replace$(Convert,"\v",vbVerticalTab)
	If InStr(Convert,"\t") Then Convert = Replace$(Convert,"\t",vbTab)
	If InStr(Convert,"\'") Then Convert = Replace$(Convert,"\'","'")
	If InStr(Convert,"\""") Then Convert = Replace$(Convert,"\""","""")
	If InStr(Convert,"\?") Then Convert = Replace$(Convert,"\?","?")
	If InStr(Convert,"\") Then Convert = ConvertBRegExp(Convert)
	If InStr(Convert,"\0") Then Convert = Replace$(Convert,"\0",vbNullChar)
	If InStr(Convert,"*a!N!d*") Then Convert = Replace$(Convert,"*a!N!d*","\")
End Function


'ת˽ƻʮת
Private Function ConvertB(ByVal ConverString As String) As String
	Dim i As Long,j As Long,EscStr As String
	ConvertB = ConverString
	i = InStr(ConvertB,"\")
	Do While i > 0
		EscStr = Mid$(ConvertB,i,2)
		Select Case EscStr
		Case "\x", "\X"
			ConverString = Mid$(ConvertB,i + 2,2)
			If CheckStr(UCase$(ConverString),"[0-9A-Fa-f]",0,1) = True Then
				j = Val("&H" & ConverString)
				ConvertB = Replace$(ConvertB,EscStr & ConverString,Val2Bytes(j,2))
			End If
		Case "\u", "\U"
			ConverString = Mid$(ConvertB,i + 2,4)
			If CheckStr(UCase$(ConverString),"[0-9A-Fa-f]",0,1) = True Then
				j = Val("&H" & ConverString)
				ConvertB = Replace$(ConvertB,EscStr & ConverString,Val2Bytes(j,2))
			End If
		Case Is <> ""
			EscStr = "\"
			For j = 3 To 1 Step -1
				ConverString = Mid$(ConvertB,i + 1,j)
				If CheckStr(ConverString,"[0-7]",0,1) = True Then
					j = Val("&O" & ConverString)
					If j > 256 Then
						ConverString = Left$(ConverString,2)
						j = Val("&O" & ConverString)
					End If
					ConvertB = Replace$(ConvertB,EscStr & ConverString,Val2Bytes(j,2))
					Exit For
				End If
			Next j
		End Select
		i = InStr(i + 1,ConvertB,"\")
	Loop
End Function


'ת˽ƻʮת
Private Function ConvertBRegExp(ByVal ConverString As String) As String
	Dim i As Long,j As Long,CodeVal As Long,Matches As Object
	ConvertBRegExp = ConverString
	With RegExp
		.Global = True
		.IgnoreCase = True
		For i = 0 To UBound(CheckHexStr)
			.Pattern = CheckHexStr(i).Range
			Set Matches = .Execute(ConverString)
			If Matches.Count > 0 Then
				For j = 0 To Matches.Count - 1
					If i = 0 Then
						If Matches(j).Length = 4 Then
							CodeVal = Val("&H" & Mid$(Matches(j).Value,3))
							ConvertBRegExp = Replace$(ConvertBRegExp,Matches(j).Value,Val2Bytes(CodeVal,2))
						End If
					ElseIf i = 1 Then
						If Matches(j).Length = 6 Then
							CodeVal = Val("&H" & Mid$(Matches(j).Value,3))
							ConvertBRegExp = Replace$(ConvertBRegExp,Matches(j).Value,Val2Bytes(CodeVal,2))
						End If
					ElseIf Matches(j).Length > 1 And Matches(j).Length < 5 Then
						CodeVal = Val("&O" & Replace$(Matches(j).Value,"\",""))
						If CodeVal > 256 Then
							Matches(j).Value = Left$(Matches(j).Value,3)
							CodeVal = Val("&O" & Replace$(Matches(j).Value,"\",""))
						End If
						ConvertBRegExp = Replace$(ConvertBRegExp,Matches(j).Value,Val2Bytes(CodeVal,2))
					End If
				Next j
			End If
		Next i
	End With
End Function


'תֵΪֽ(ڳȵĸλض)
Private Function Val2Bytes(ByVal Value As Long,ByVal Length As Integer,Optional ByVal ByteOrder As Boolean) As Byte()
	On Error GoTo errHandle
	ReDim Bytes(Length - 1) As Byte
	CopyMemory Bytes(0), Value, Length
	If ByteOrder = False Then
		Val2Bytes = Bytes
	Else
		Val2Bytes = ReverseValByte(Bytes,0,-1)
	End If
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	Val2Bytes = Bytes
End Function


'תֽ飬ֵֽĸֽں͵ֽڻ
Private Function ReverseValByte(Bytes() As Byte,ByVal StartPos As Long,ByVal endPos As Long) As Byte()
	Dim i As Long,Temp() As Byte
	If StartPos < 0 Then StartPos = LBound(Bytes)
	If endPos < 0 Then endPos = UBound(Bytes)
	Temp = Bytes
	For i = StartPos To endPos
		Temp(i) = Bytes(endPos - i)
	Next i
	ReverseValByte = Temp
End Function


'תַΪֵ
Public Function StrToLong(ByVal mStr As String,Optional ByVal DefaultValue As Long) As Long
	On Error GoTo errHandle
	StrToLong = CLng(mStr)
	Exit Function
	errHandle:
	StrToLong = DefaultValue
End Function


'ȡʷ¼
'Separator Ϊʱ÷ʽȡ
'Separator Ϊʱ׷ӷʽȡ Separator Чֵظ
Private Function GetHistory(DataList() As String,ByVal ItemName As String,ByVal ValueName As String,Optional ByVal Separator As String) As Boolean
	Dim i As Long,n As Long,TempArray() As String,Dic As Object
	On Error GoTo ExitFunction
	TempArray = GetAllSettings(AppName,ItemName)
	If Separator <> "" Then
		Set Dic = CreateObject("Scripting.Dictionary")
		For i = 0 To UBound(DataList)
			If InStr(DataList(i),Separator) Then
				If Not Dic.Exists(ReSplit(DataList(i),Separator,2)(1)) Then
					Dic.Add(ReSplit(DataList(i),Separator,2)(1),"")
				End If
			End If
		Next i
		n = UBound(DataList) + 1
		ReDim Preserve DataList(n + UBound(TempArray)) As String
		For i = LBound(TempArray) To UBound(TempArray)
			If InStr(TempArray(i,0),ValueName) Then
				If InStr(TempArray(i,1),Separator) Then
					If Not Dic.Exists(ReSplit(TempArray(i,1),Separator,2)(1)) Then
						DataList(n) = TempArray(i,1)
						n = n + 1
					End If
				End If
			End If
		Next i
		Set Dic = Nothing
	Else
		ReDim DataList(UBound(TempArray)) As String
		For i = LBound(TempArray) To UBound(TempArray)
			If InStr(TempArray(i,0),ValueName) Then
				If TempArray(i,1) <> "" Then
					DataList(n) = TempArray(i,1)
					n = n + 1
				End If
			End If
		Next i
	End If
	If n > 0 Then
		n = n - 1
		GetHistory = True
	End If
	ReDim Preserve DataList(n) As String
	Exit Function
	ExitFunction:
	If Separator = "" Then
		ReDim DataList(0) As String
	Else
		ReDim Preserve DataList(UBound(DataList)) As String
	End If
End Function


'ʷ¼
'Mode = False д 10 ¼дм¼ɾ DataList ûеļ¼
Private Function WriteHistory(DataList() As String,ByVal ItemName As String,ByVal ValueName As String,Optional ByVal Mode As Boolean) As Boolean
	Dim i As Long,n As Long,TempArray() As String
	On Error Resume Next
	For i = LBound(DataList) To UBound(DataList)
		If DataList(i) <> "" Then
			SaveSetting(AppName,ItemName,ValueName & CStr$(n),DataList(i))
			n = n + 1
			If Mode = False Then
				If n = 10 Then
					WriteHistory = True
					Exit Function
				End If
			End If
		End If
	Next i
	If n > 0 Then WriteHistory = True
	TempArray = GetAllSettings(AppName,ItemName)
	For i = 0 To UBound(TempArray)
		If InStr(TempArray(i,0),ValueName & CStr$(n)) Then
			DeleteSetting(AppName,ItemName,TempArray(i,0))
			n = n + 1
		End If
	Next i
	If n < i Then Exit Function
	If WriteHistory = True Then Exit Function
	Dim WshShell As Object
	Set WshShell = CreateObject("WScript.Shell")
	WshShell.RegDelete "HKCU\Software\VB and VBA Program Settings\" & AppName & "\" & ItemName & "\"
	Set WshShell = Nothing
End Function


'ȡִ
Public Function GetCheckSet(ByVal SelSet As String,ByVal Path As String) As Long
	Dim i As Long,j As Long,k As Long,m As Long,n As Long,x As Long
	Dim Temp As String,TempList() As String,DataList() As INIFILE_DATA
	Dim CheckVersion As String,Dic As Object

	If SelSet <> "" Then
		Select Case SelSet
		Case DefaultCheckList(0)
			SelSet = "en2zh"
		Case DefaultCheckList(1)
			SelSet = "zh2en"
		End Select
	End If

	If Path = CheckRegKey Then GoTo GetFromRegistry
	If Path = "" Then Path = CheckFilePath
	If Dir(Path) = "" Then GoTo GetFromRegistry
	Set Dic = CreateObject("Scripting.Dictionary")
	If Path <> CheckFilePath Then
		ReDim FileDataList(0)
		FileDataList(0) = Path & JoinStr
		If EditFile(Path,FileDataList,False) = False Then
			GetCheckSet = -1
			Exit Function
		End If
		Temp = ReSplit(FileDataList(0),JoinStr)(1)
		If SelSet = "Sets" Then
			If CheckCheckSet(CheckList) = True Then
				x = UBound(CheckList) + 1: n = x
				ReDim Preserve CheckList(x) As CHECK_SET
				For i = 0 To x - 1
					If Not Dic.Exists(CheckList(i).Name) Then Dic.Add(CheckList(i).Name,0)
				Next i
			End If
		Else
			If CheckArray(getSetNameList(ProjectList)) = True Then
				k = UBound(ProjectList) + 1
				ReDim Preserve ProjectList(k) As CHECK_PROJECT_SET
				For i = 0 To k - 1
					If Not Dic.Exists(ProjectList(i).Name) Then Dic.Add(ProjectList(i).Name,0)
				Next i
			End If
		End If
	Else
		Temp = "_autodetect_all"
		On Error GoTo GetFromRegistry
	End If
	If getINIFile(DataList,Path,Temp,1) = False Then Exit Function
	For i = 0 To UBound(DataList)
		With DataList(i)
			Select Case .Title
			Case "Option" 		'ȡ Option ֵ
				If SelSet = "" Or SelSet = "Option" Then
					For j = 0 To UBound(.Item)
						Select Case .Item(j)
						Case "Version"
							CheckVersion = .Value(j)
						Case "UILanguageID"
							cSelected(0) = .Value(j)
						Case "AutoMacroSet"
							cSelected(1) = .Value(j)
						Case "CheckMacroSet"
							cSelected(2) = .Value(j)
						Case "AutoMacroCheck"
							cSelected(3) = .Value(j)
						Case "AutoSelection"
							cSelected(4) = .Value(j)
						Case "SelectedCheck"
							cSelected(5) = .Value(j)
						Case "CheckAllType"
							cSelected(6) = .Value(j)
						Case "CheckMenu"
							cSelected(7) = .Value(j)
						Case "CheckDialog"
							cSelected(8) = .Value(j)
						Case "CheckString"
							cSelected(9) = .Value(j)
						Case "CheckAcceleratorTable"
							cSelected(10) = .Value(j)
						Case "CheckVersion"
							cSelected(11) = .Value(j)
						Case "CheckOther"
							cSelected(12) = .Value(j)
						Case "CheckSeletedOnly"
							cSelected(13) = .Value(j)
						Case "CheckAllCont"
							cSelected(14) = .Value(j)
						Case "CheckAccKey"
							cSelected(15) = .Value(j)
						Case "CheckEndChar"
							cSelected(16) = .Value(j)
						Case "CheckAcceler"
							cSelected(17) = .Value(j)
						Case "IgnoreVerTag"
							cSelected(18) = .Value(j)
						Case "IgnoreSetTag"
							cSelected(19) = .Value(j)
						Case "IgnoreDateTag"
							cSelected(20) = .Value(j)
						Case "IgnoreStateTag"
							cSelected(21) = .Value(j)
						Case "TgnoreAllTag"
							cSelected(22) = .Value(j)
						Case "NoCheckTag"
							cSelected(23) = .Value(j)
						Case "NoChangeTrnState"
							cSelected(24) = .Value(j)
						Case "AutoRepString"
							cSelected(25) = .Value(j)
						Case "KeepSettings"
							cSelected(26) = .Value(j)
						End Select
					Next j
				End If
				If SelSet = "" Or SelSet = "Option" Then
					Select Case cSelected(1)
					Case "Default", "en2zh"
						cSelected(1) = DefaultCheckList(0)
					Case "zh2en"
						cSelected(1) = DefaultCheckList(1)
					End Select
					Select Case cSelected(2)
					Case "Default", "en2zh"
						cSelected(2) = DefaultCheckList(0)
					Case "zh2en"
						cSelected(2) = DefaultCheckList(1)
					End Select
					If SelSet = "Option" Then
						If CheckArray(cSelected) = True Then GetCheckSet = 1
						Exit For
					End If
				End If
			Case "Update" 		'ȡ Update ֵ
				If SelSet = "" Or SelSet = "Update" Then
					For j = 0 To UBound(.Item)
						Select Case .Item(j)
						Case "UpdateMode"
							UpdateSet(0) = .Value(j)
						Case "Path"
							UpdateSet(2) = .Value(j)
						Case "Argument"
							UpdateSet(3) = .Value(j)
						Case "UpdateCycle"
							UpdateSet(4) = .Value(j)
						Case "UpdateDate"
							UpdateSet(5) = .Value(j)
						Case Else
							If InStr(.Item(j),"Site_") And .Value(j) <> "" Then
								If UpdateSet(1) <> "" Then
									UpdateSet(1) = UpdateSet(1) & vbCrLf & .Value(j)
								Else
									UpdateSet(1) = .Value(j)
								End If
							End If
						End Select
					Next j
					If SelSet = "Update" Then
						If CheckArray(UpdateSet) = True Then GetCheckSet = 2
						Exit For
					End If
				End If
			Case "Projects" 		'ȡ Project ֵ
				If SelSet = "" Or SelSet = "Project" Then
					For j = 0 To UBound(.Item)
						Select Case .Item(j)
						Case "CheckOnly"
							.Item(j) = DefaultProjectList(0)
						Case "CheckAndCorrect"
							.Item(j) = DefaultProjectList(1)
						Case "DelAccessKey"
							.Item(j) = DefaultProjectList(2)
						Case "DelAccelerator"
							.Item(j) = DefaultProjectList(3)
						Case "DelAccessKeyAndAccelerator"
							.Item(j) = DefaultProjectList(4)
						End Select
						If .Item(j) <> "" Then
							If Not Dic.Exists(.Item(j)) Then
								Dic.Add(.Item(j),0)
							Else
								Dic.Item(.Item(j)) = Dic.Item(.Item(j)) + 1
								.Item(j) = .Item(j) & "_" & Dic.Item(.Item(j))
							End If
							ProjectList(k).Name = .Item(j)
							TempList = ReSplit(.Value(j),LngJoinStr)
							If UBound(TempList) < 21 Then ReDim Preserve TempList(21) As String
 							ProjectList(k).PreSpaceInSource = StrToLong(TempList(0))
							ProjectList(k).PreSpaceInTarget = StrToLong(TempList(1))
							ProjectList(k).PreSpaceInBoth = StrToLong(TempList(2))
							ProjectList(k).EndSpaceInSource = StrToLong(TempList(3))
							ProjectList(k).EndSpaceInTarget = StrToLong(TempList(4))
							ProjectList(k).EndSpaceInBoth = StrToLong(TempList(5))
							ProjectList(k).AcckeyInSource = StrToLong(TempList(6))
							ProjectList(k).AcckeyInTarget = StrToLong(TempList(7))
							ProjectList(k).AcckeyInBoth = StrToLong(TempList(8))
							ProjectList(k).EndStrInSource = StrToLong(TempList(9))
							ProjectList(k).EndStrInTarget = StrToLong(TempList(10))
							ProjectList(k).EndStrInBoth = StrToLong(TempList(11))
							ProjectList(k).ShortcutInSource = StrToLong(TempList(12))
							ProjectList(k).ShortcutInTarget = StrToLong(TempList(13))
							ProjectList(k).ShortcutInBoth = StrToLong(TempList(14))
							ProjectList(k).DelSpace = StrToLong(TempList(15))
							ProjectList(k).EnableStrSplit = StrToLong(TempList(16))
							ProjectList(k).TranEndStr = StrToLong(TempList(17))
							ProjectList(k).UseAcckeyInShortcut = StrToLong(TempList(18))
							ProjectList(k).ShowOriginalTran = StrToLong(TempList(19))
							ProjectList(k).ApplyCheckResult = StrToLong(TempList(20))
							ProjectList(k).SpaceForEnAndAsia = StrToLong(TempList(21))
							k = k + 1
							ReDim Preserve ProjectList(k) As CHECK_PROJECT_SET
						End If
					Next j
					If k > 0 Then k = k - 1
					ReDim Preserve ProjectList(k) As CHECK_PROJECT_SET
					If SelSet = "Project" Then
						If k > 0 Then GetCheckSet = 3
						Exit For
					End If
				End If
			Case Else
				If SelSet = "" Or SelSet = "Sets" Or SelSet = .Title Then 'ȡ Option ȫֵ
					Select Case .Title
					Case "en2zh"
						CheckList(x).Name = DefaultCheckList(0)
					Case "zh2en"
						CheckList(x).Name = DefaultCheckList(1)
					Case Else
						CheckList(x).Name = .Title
					End Select
					If Not Dic.Exists(CheckList(x).Name) Then
						Dic.Add(CheckList(x).Name,0)
					Else
						Dic.Item(CheckList(x).Name) = Dic.Item(CheckList(x).Name) + 1
						CheckList(x).Name = CheckList(x).Name & "_" & Dic.Item(CheckList(x).Name)
					End If
					For j = 0 To UBound(.Item)
						Select Case .Item(j)
						Case "ExcludeChar"
							CheckList(x).AccKeyExcludeChar = .Value(j)
						Case "LineSplitChar"
							CheckList(x).PreInsertSplitChar = .Value(j)
						Case "CheckBracket"
							CheckList(x).CheckBracket = .Value(j)
						Case "KeepCharPair"
							CheckList(x).KeepCharPair = .Value(j)
						Case "ShowAsiaKey"
							CheckList(x).ShowAsiaKey = StrToLong(.Value(j))
						Case "CheckEndChar"
							CheckList(x).CheckEndChar = .Value(j)
						Case "NoTrnEndChar"
							CheckList(x).NotTrnEndChar = .Value(j)
						Case "AutoTrnEndChar"
							CheckList(x).AutoTrnEndChar = .Value(j)
						Case "CheckShortChar"
							CheckList(x).CheckShortChar = .Value(j)
						Case "CheckShortKey"
							CheckList(x).CheckShortKey = .Value(j)
						Case "KeepShortKey"
							CheckList(x).KeepShortKey = .Value(j)
						Case "PreRepString"
							CheckList(x).PreRepStr = .Value(j)
						Case "AutoRepString"
							CheckList(x).AppRepStr = .Value(j)
						Case "AccessKeyChar"
							CheckList(x).AccKeyChar = .Value(j)
						Case "AddAccessKeyWithFirstChar"
							CheckList(x).AccKeyWithFirstChar = StrToLong(.Value(j))
						Case "LineSplitMode"
							CheckList(x).LineSplitMode = StrToLong(.Value(j))
						Case "AppInsertSplitChar"
							CheckList(x).AppInsertSplitChar = .Value(j)
						Case "ReplaceSplitChar"
							CheckList(x).ReplaceSplitChar = .Value(j)
						Case "ApplyLangList"
							If .Value(j) = "" Then
								CheckList(x).LangPairList = LangCodeList(.Title,1,-1)
							Else
								CheckList(x).LangPairList = MergeLngList(LangCodeList(.Title,1,-1),StringToLangSet(.Value(j),False))
							End If
						End Select
					Next j
					If CheckCheckSet(CheckList,x) = True Then
						'¾ɰĬֵ
						If Path = CheckFilePath Then
							If StrComp(ToUpdateCheckVersion,CheckVersion) = 1 Then Call CheckSetUpdate(CheckList(x))
						End If
						x = x + 1
						ReDim Preserve CheckList(x) As CHECK_SET
					End If
					n = n + 1
				End If
			End Select
		End With
	Next i
	Set Dic = Nothing
	If n > 0 And x = n Then
		GetCheckSet = 4
		ReDim Preserve CheckList(x - 1) As CHECK_SET
	ElseIf x > UBound(CheckList) Then
		GetCheckSet = 4
		ReDim Preserve CheckList(x - 1) As CHECK_SET
	ElseIf x > 0 Then
		ReDim Preserve CheckList(x - 1) As CHECK_SET
	Else
		ReDim CheckList(0) As CHECK_SET
	End If
	If Path = CheckFilePath Then
		If GetCheckSet = 0 Then GoTo GetFromRegistry
		'º͵ݵļ
		If GetCheckSet = 4 Then
			If CheckVersion <> "" Then
				If StrComp(ToUpdateCheckVersion,CheckVersion) = 1 Then
					CheckVersion = ToUpdateCheckVersion
					WriteCheckSet(CheckFilePath,"All")
				End If
			End If
		End If
		cWriteLoc = CheckFilePath
		GoTo GetFontSetFromRegistry
	End If
	Exit Function

	GetFromRegistry:
	cWriteLoc = CheckRegKey
	'ȡ Option ֵ
	CheckVersion = GetSetting("AccessKey","Option","Version","")
	If SelSet = "" Or SelSet = "Option" Then
		cSelected(0) = GetSetting("AccessKey","Option","UILanguageID",0)
		cSelected(1) = GetSetting("AccessKey","Option","AutoMacroSet","")
		cSelected(2) = GetSetting("AccessKey","Option","CheckMacroSet","")
		cSelected(3) = GetSetting("AccessKey","Option","AutoMacroCheck",1)
		cSelected(4) = GetSetting("AccessKey","Option","AutoSelection",1)
		cSelected(5) = GetSetting("AccessKey","Option","SelectedCheck",0)
		cSelected(6) = GetSetting("AccessKey","Option","CheckAllType",0)
		cSelected(7) = GetSetting("AccessKey","Option","CheckMenu",0)
		cSelected(8) = GetSetting("AccessKey","Option","CheckDialog",0)
		cSelected(9) = GetSetting("AccessKey","Option","CheckString",0)
		cSelected(10) = GetSetting("AccessKey","Option","CheckAcceleratorTable",0)
		cSelected(11) = GetSetting("AccessKey","Option","CheckVersion",0)
		cSelected(12) = GetSetting("AccessKey","Option","CheckOther",0)
		cSelected(13) = GetSetting("AccessKey","Option","CheckSeletedOnly",1)
		cSelected(14) = GetSetting("AccessKey","Option","CheckAllCont",0)
		cSelected(15) = GetSetting("AccessKey","Option","CheckAccKey",0)
		cSelected(16) = GetSetting("AccessKey","Option","CheckEndChar",0)
		cSelected(17) = GetSetting("AccessKey","Option","CheckAcceler",0)
		cSelected(18) = GetSetting("AccessKey","Option","IgnoreVerTag",0)
		cSelected(19) = GetSetting("AccessKey","Option","IgnoreSetTag",0)
		cSelected(20) = GetSetting("AccessKey","Option","IgnoreDateTag",0)
		cSelected(21) = GetSetting("AccessKey","Option","IgnoreStateTag",0)
		cSelected(22) = GetSetting("AccessKey","Option","TgnoreAllTag",1)
		cSelected(23) = GetSetting("AccessKey","Option","NoCheckTag",1)
		cSelected(24) = GetSetting("AccessKey","Option","NoChangeTrnState",0)
		cSelected(25) = GetSetting("AccessKey","Option","AutoRepString",0)
		cSelected(26) = GetSetting("AccessKey","Option","KeepSetting",1)
		Select Case cSelected(1)
		Case "Default", "en2zh"
			cSelected(1) = DefaultCheckList(0)
		Case "zh2en"
			cSelected(1) = DefaultCheckList(1)
		End Select
		Select Case cSelected(2)
		Case "Default", "en2zh"
			cSelected(2) = DefaultCheckList(0)
		Case "zh2en"
			cSelected(2) = DefaultCheckList(1)
		End Select
		If SelSet = "Option" Then
			If CheckArray(cSelected) = True Then GetCheckSet = 1
			Exit Function
		End If
	End If
	'ȡ Update ֵ
	If SelSet = "" Or SelSet = "Update" Then
		UpdateSet(0) = GetSetting("AccessKey","Update","UpdateMode",1)
		Temp = GetSetting("AccessKey","Update","Count","")
		If Temp <> "" Then
			For i = 0 To StrToLong(Temp)
				Temp = GetSetting("AccessKey","Update",CStr(i),"")
				If Temp <> "" Then
					If UpdateSet(1) <> "" Then
						UpdateSet(1) = UpdateSet(1) & vbCrLf & Temp
					Else
						UpdateSet(1) = Temp
					End If
				End If
			Next i
		End If
		UpdateSet(2) = GetSetting("AccessKey","Update","Path","")
		UpdateSet(3) = GetSetting("AccessKey","Update","Argument","")
		UpdateSet(4) = GetSetting("AccessKey","Update","UpdateCycle",7)
		UpdateSet(5) = GetSetting("AccessKey","Update","UpdateDate","")
		If SelSet = "Update" Then
			If CheckArray(UpdateSet) = True Then GetCheckSet = 2
			Exit Function
		End If
	End If
	'ȡ Project ֵ
	If SelSet = "" Or SelSet = "Project" Then
		On Error GoTo NextItem
		TempList = GetAllSettings("AccessKey","Projects")
		n = UBound(TempList): k = 0
		ReDim ProjectList(n) As CHECK_PROJECT_SET,TempArray(0) As String
		For i = 0 To n
			If TempList(i,0) <> "" And TempList(i,1) <> "" Then
				With ProjectList(k)
					Select Case TempList(i,0)
					Case "CheckOnly"
						TempList(i,0) = DefaultProjectList(0)
					Case "CheckAndCorrect"
						TempList(i,0) = DefaultProjectList(1)
					Case "DelAccessKey"
						TempList(i,0) = DefaultProjectList(2)
					Case "DelAccelerator"
						TempList(i,0) = DefaultProjectList(3)
					Case "DelAccessKeyAndAccelerator"
						TempList(i,0) = DefaultProjectList(4)
					End Select
					.Name = TempList(i,0)
					TempArray = ReSplit(TempList(i,1),LngJoinStr)
					If UBound(TempArray) < 21 Then ReDim Preserve TempArray(21) As String
					.PreSpaceInSource = StrToLong(TempArray(0))
					.PreSpaceInTarget = StrToLong(TempArray(1))
					.PreSpaceInBoth = StrToLong(TempArray(2))
					.EndSpaceInSource = StrToLong(TempArray(3))
					.EndSpaceInTarget = StrToLong(TempArray(4))
					.EndSpaceInBoth = StrToLong(TempArray(5))
					.AcckeyInSource = StrToLong(TempArray(6))
					.AcckeyInTarget = StrToLong(TempArray(7))
					.AcckeyInBoth = StrToLong(TempArray(8))
					.EndStrInSource = StrToLong(TempArray(9))
					.EndStrInTarget = StrToLong(TempArray(10))
					.EndStrInBoth = StrToLong(TempArray(11))
					.ShortcutInSource = StrToLong(TempArray(12))
					.ShortcutInTarget = StrToLong(TempArray(13))
					.ShortcutInBoth = StrToLong(TempArray(14))
					.DelSpace = StrToLong(TempArray(15))
					.EnableStrSplit = StrToLong(TempArray(16))
					.TranEndStr = StrToLong(TempArray(17))
					.UseAcckeyInShortcut = StrToLong(TempArray(18))
					.ShowOriginalTran = StrToLong(TempArray(19))
					.ApplyCheckResult = StrToLong(TempArray(20))
					.SpaceForEnAndAsia = StrToLong(TempArray(21))
				End With
				k = k + 1
			End If
		Next i
		On Error GoTo 0
		NextItem:
		If k > 0 Then
			ReDim Preserve ProjectList(k - 1) As CHECK_PROJECT_SET
		Else
			ReDim ProjectList(0) As CHECK_PROJECT_SET
		End If
		If SelSet = "Project" Then
			If k > 0 Then GetCheckSet = 3
			Exit Function
		End If
	End If
	'ȡ Option ֵ
	If SelSet = "" Or SelSet = "Sets" Then
		Temp = GetSetting("AccessKey","Option","Headers","")
		If Temp <> "" Then
			TempList = ReSplit(Temp,";",-1)
			n = UBound(TempList): x = 0
			ReDim CheckList(n) As CHECK_SET
			For i = 0 To n
				With CheckList(x)
					If TempList(i) <> "" Then
						'תɰÿֵ
						.Name = GetSetting("AccessKey",TempList(i),"Name","")
					End If
					If .Name = "" Then .Name = TempList(i)
					Select Case .Name
					Case "en2zh"
						.Name = DefaultCheckList(0)
						.ShowAsiaKey = StrToLong(GetSetting("AccessKey",TempList(i),"ShowAsiaKey","1"))
						.AccKeyWithFirstChar = StrToLong(GetSetting("AccessKey",TempList(i),"AddAccessKeyWithFirstChar","0"))
					Case "zh2en"
						.Name = DefaultCheckList(1)
						.ShowAsiaKey = StrToLong(GetSetting("AccessKey",TempList(i),"ShowAsiaKey","0"))
						.AccKeyWithFirstChar = StrToLong(GetSetting("AccessKey",TempList(i),"AddAccessKeyWithFirstChar","1"))
					Case Else
						.ShowAsiaKey = StrToLong(GetSetting("AccessKey",TempList(i),"ShowAsiaKey","0"))
						.AccKeyWithFirstChar = StrToLong(GetSetting("AccessKey",TempList(i),"AddAccessKeyWithFirstChar","1"))
					End Select
					.AccKeyExcludeChar = GetSetting("AccessKey",TempList(i),"ExcludeChar","")
					.PreInsertSplitChar = GetSetting("AccessKey",TempList(i),"LineSplitChar","")
					.CheckBracket = GetSetting("AccessKey",TempList(i),"CheckBracket","")
					.KeepCharPair = GetSetting("AccessKey",TempList(i),"KeepCharPair","")
					.CheckEndChar = GetSetting("AccessKey",TempList(i),"CheckEndChar","")
					.NotTrnEndChar = GetSetting("AccessKey",TempList(i),"NoTrnEndChar","")
					.AutoTrnEndChar = GetSetting("AccessKey",TempList(i),"AutoTrnEndChar","")
					.CheckShortChar = GetSetting("AccessKey",TempList(i),"CheckShortChar","")
					.CheckShortKey = GetSetting("AccessKey",TempList(i),"CheckShortKey","")
					.KeepShortKey = GetSetting("AccessKey",TempList(i),"KeepShortKey","")
					.PreRepStr = GetSetting("AccessKey",TempList(i),"PreRepString","")
					.AppRepStr = GetSetting("AccessKey",TempList(i),"AutoRepString","")
					.AccKeyChar = GetSetting("AccessKey",TempList(i),"AccessKeyChar","")
					.LineSplitMode = StrToLong(GetSetting("AccessKey",TempList(i),"LineSplitMode","1"))
					.AppInsertSplitChar = GetSetting("AccessKey",TempList(i),"AppInsertSplitChar","")
					.ReplaceSplitChar = GetSetting("AccessKey",TempList(i),"ReplaceSplitChar","")
					Temp = GetSetting("AccessKey",TempList(i),"ApplyLangList","")
					If Temp = "" Then
						.LangPairList = LangCodeList(.Name,1,-1)
					Else
						.LangPairList = MergeLngList(LangCodeList(.Name,1,-1),StringToLangSet(Temp,False))
					End If
					If CheckCheckSet(CheckList,x) = True Then
						'¾ɰĬֵ
						If StrComp(ToUpdateCheckVersion,CheckVersion) = 1 Then Call CheckSetUpdate(CheckList(x))
						x = x + 1
					End If
				End With
				'ɾɰֵ
				On Error Resume Next
				If CheckList(x).Name = TempList(i) Then DeleteSetting("AccessKey",CheckList(x).Name)
				On Error GoTo 0
			Next i
			If x = n + 1 Then
				GetCheckSet = 4
				ReDim Preserve CheckList(x - 1) As CHECK_SET
				'ºݵע
				If StrComp(ToUpdateCheckVersion,CheckVersion) = 1 Then
					CheckVersion = ToUpdateCheckVersion
					WriteCheckSet(CheckRegKey,"Sets")
				End If
			Else
				ReDim CheckList(0) As CHECK_SET
			End If
		End If
	End If

	'ȡԻ
	GetFontSetFromRegistry:
	If SelSet = "" Or InStr(";DlgFont;MainFont;SrcStrFont;TrnStrFont;",";" & SelSet & ";") Then
		On Error GoTo ExitFunction
		Temp = IIf(SelSet = "DlgFont","_",SelSet & "_")
		TempList = GetAllSettings(AppName,"DlgFonts")
		x = 0
		ReDim TempArray(0) As String,TempByte(0) As Byte
		For i = LBound(TempList) To UBound(TempList)
			If InStr(TempList(i,0),Temp) Then
				TempArray = ReSplit(TempList(i,0),"_",2)
				If UBound(TempArray) > 0 Then
					Select Case TempArray(0)
					Case "MainFont"
						j = 0
					Case "SrcStrFont"
						j = 1
					Case "TrnStrFont"
						j = 2
					End Select
					With LFList(j)
						Select Case TempArray(1)
						Case "lfCharSet"
							.lfCharSet = StrToLong(TempList(i,1))
						Case "lfClipPrecision"
							.lfClipPrecision = StrToLong(TempList(i,1))
						Case "lfEscapement"
							.lfEscapement = StrToLong(TempList(i,1))
						Case "lfFaceName"
							TempByte = StrConv(TempList(i,1),vbFromUnicode)
							ReDim Preserve TempByte(31) As Byte
							CopyMemory .lfFaceName(0),TempByte(0),UBound(.lfFaceName) + 1
						Case "lfHeight"
							.lfHeight = StrToLong(TempList(i,1))
						Case "lfItalic"
							.lfItalic = StrToLong(TempList(i,1))
						Case "lfOrientation"
							.lfOrientation = StrToLong(TempList(i,1))
						Case "lfOutPrecision"
							.lfOutPrecision = StrToLong(TempList(i,1))
						Case "lfPitchAndFamily"
							.lfPitchAndFamily = StrToLong(TempList(i,1))
						Case "lfQuality"
							.lfQuality = StrToLong(TempList(i,1))
						Case "lfStrikeOut"
							.lfStrikeOut = StrToLong(TempList(i,1))
						Case "lfUnderline"
							.lfUnderline = StrToLong(TempList(i,1))
						Case "lfWeight"
							.lfWeight = StrToLong(TempList(i,1))
						Case "lfWidth"
							.lfWidth = StrToLong(TempList(i,1))
						Case "lfColor"
							.lfColor = StrToLong(TempList(i,1))
						End Select
						x = x + 1
					End With
				End If
			End If
		Next i
		On Error GoTo 0
		ExitFunction:
		If SelSet <> "" Then
			If x > 0 Then GetCheckSet = 5
			Exit Function
		End If
	End If
End Function


'дִ
Public Function WriteCheckSet(ByVal Path As String,ByVal SelSet As String,Optional ByVal WriteType As Long) As Boolean
	Dim i As Long,j As Long,n As Long,Temp As String,KeepSet As Long
	Dim Selected() As String,TempArray() As String,LineArray() As String

	If WriteType = 0 Then
		KeepSet = StrToLong(cSelected(26))
		If KeepSet = 0 Then
			If SelSet = "Main" Or SelSet = "All" Then
				KeepSet = 1
			ElseIf Path = CheckFilePath Then
				KeepSet = 1
			End If
		End If
		Selected = cSelected
		Select Case Selected(1)
		Case DefaultCheckList(0)
			Selected(1) = "en2zh"
		Case DefaultCheckList(1)
			Selected(1) = "zh2en"
		End Select
		Select Case Selected(2)
		Case DefaultCheckList(0)
			Selected(2) = "en2zh"
		Case DefaultCheckList(1)
			Selected(2) = "zh2en"
		End Select
	End If

	'дļ
	If Path <> "" And Path <> CheckRegKey Then
   		On Error Resume Next
   		Temp = Left(Path,InStrRev(Path,"\"))
   		If Dir(Temp & "*.*") = "" Then MkDir Temp
		If Dir(Path) <> "" Then SetAttr Path,vbNormal
		On Error GoTo ExitFunction
		ReDim LineArray(3) As String
		LineArray(0) = ";------------------------------------------------------------"
		LineArray(1) = ";Settings for PSLCheckAccessKeys.bas and PslAutoAccessKey.bas"
		LineArray(2) = ";------------------------------------------------------------"
		If WriteType = 0 Then
			n = UBound(LineArray) + 1
			ReDim Preserve LineArray(n + 3) As String
			LineArray(n + 0) = "[Option]"
			LineArray(n + 1) = "AppName = PSLCheckAccessKeys"
			LineArray(n + 2) = "Version = " & Version
			LineArray(n + 3) = "UILanguageID = " & Selected(0)
			If KeepSet = 1 Then
				n = UBound(LineArray) + 1
				ReDim Preserve LineArray(n + 25) As String
				LineArray(n + 0) = "AutoMacroSet = " & Selected(1)
				LineArray(n + 1) = "CheckMacroSet = " & Selected(2)
				LineArray(n + 2) = "AutoMacroCheck = " & Selected(3)
				LineArray(n + 3) = "AutoSelection = " & Selected(4)
				LineArray(n + 4) = "SelectedCheck = " & Selected(5)
				LineArray(n + 5) = "CheckAllType = " & Selected(6)
				LineArray(n + 6) = "CheckMenu = " & Selected(7)
				LineArray(n + 7) = "CheckDialog = " & Selected(8)
				LineArray(n + 8) = "CheckString = " & Selected(9)
				LineArray(n + 9) = "CheckAcceleratorTable = " & Selected(10)
				LineArray(n + 10) = "CheckVersion = " & Selected(11)
				LineArray(n + 11) = "CheckOther = " & Selected(12)
				LineArray(n + 12) = "CheckSeletedOnly = " & Selected(13)
				LineArray(n + 13) = "CheckAllCont = " & Selected(14)
				LineArray(n + 14) = "CheckAccKey = " & Selected(15)
				LineArray(n + 15) = "CheckEndChar = " & Selected(16)
				LineArray(n + 16) = "CheckAcceler = " & Selected(17)
				LineArray(n + 17) = "IgnoreVerTag = " & Selected(18)
				LineArray(n + 18) = "IgnoreSetTag = " & Selected(19)
				LineArray(n + 19) = "IgnoreDateTag = " & Selected(20)
				LineArray(n + 20) = "IgnoreStateTag = " & Selected(21)
				LineArray(n + 21) = "TgnoreAllTag = " & Selected(22)
				LineArray(n + 22) = "NoCheckTag = " & Selected(23)
				LineArray(n + 23) = "NoChangeTrnState = " & Selected(24)
				LineArray(n + 24) = "AutoRepString = " & Selected(25)
				LineArray(n + 25) = "KeepSettings = " & Selected(26)
			End If
			n = UBound(LineArray) + 1
			ReDim Preserve LineArray(n + 0) As String
			If CheckArray(UpdateSet) = True Then
				n = UBound(LineArray) + 1
				ReDim Preserve LineArray(n + 1) As String
				LineArray(n + 0) = "[Update]"
				LineArray(n + 1) = "UpdateMode = " & UpdateSet(0)
				TempArray = ReSplit(UpdateSet(1),vbCrLf,-1)
				j = 0
				For i = 0 To UBound(TempArray)
					If Trim$(TempArray(i)) <> "" Then
						n = UBound(LineArray) + 1
						ReDim Preserve LineArray(n) As String
						LineArray(n) = "Site_" & j & " = " & TempArray(i)
						j = j + 1
					End If
				Next i
				n = UBound(LineArray) + 1
				ReDim Preserve LineArray(n + 4) As String
				LineArray(n + 0) = "Path = " & UpdateSet(2)
				LineArray(n + 1) = "Argument = " & UpdateSet(3)
				LineArray(n + 2) = "UpdateCycle = " & UpdateSet(4)
				LineArray(n + 3) = "UpdateDate = " & UpdateSet(5)
			End If
		End If
		If WriteType = 0 Or WriteType > 1 Then
			If CheckArray(getSetNameList(ProjectList)) = True Then
				n = UBound(LineArray) + 1
				ReDim Preserve LineArray(n) As String
				LineArray(n) = "[Projects]"
				For i = 0 To UBound(ProjectList)
					With ProjectList(i)
						Select Case .Name
						Case DefaultProjectList(0)
							Temp = "CheckOnly"
						Case DefaultProjectList(1)
							Temp = "CheckAndCorrect"
						Case DefaultProjectList(2)
							Temp = "DelAccessKey"
						Case DefaultProjectList(3)
							Temp = "DelAccelerator"
						Case DefaultProjectList(4)
							Temp = "DelAccessKeyAndAccelerator"
						Case Else
							Temp = ProjectList(i).Name
						End Select
						If Temp <> "" Then
							ReDim TempArray(21) As String
							TempArray(0) = CStr$(.PreSpaceInSource)
							TempArray(1) = CStr$(.PreSpaceInTarget)
							TempArray(2) = CStr$(.PreSpaceInBoth)
							TempArray(3) = CStr$(.EndSpaceInSource)
							TempArray(4) = CStr$(.EndSpaceInTarget)
							TempArray(5) = CStr$(.EndSpaceInBoth)
							TempArray(6) = CStr$(.AcckeyInSource)
							TempArray(7) = CStr$(.AcckeyInTarget)
							TempArray(8) = CStr$(.AcckeyInBoth)
							TempArray(9) = CStr$(.EndStrInSource)
							TempArray(10) = CStr$(.EndStrInTarget)
							TempArray(11) = CStr$(.EndStrInBoth)
							TempArray(12) = CStr$(.ShortcutInSource)
							TempArray(13) = CStr$(.ShortcutInTarget)
							TempArray(14) = CStr$(.ShortcutInBoth)
							TempArray(15) = CStr$(.DelSpace)
							TempArray(16) = CStr$(.EnableStrSplit)
							TempArray(17) = CStr$(.TranEndStr)
							TempArray(18) = CStr$(.UseAcckeyInShortcut)
							TempArray(19) = CStr$(.ShowOriginalTran)
							TempArray(20) = CStr$(.ApplyCheckResult)
							TempArray(21) = CStr$(.SpaceForEnAndAsia)
							n = UBound(LineArray) + 1
							ReDim Preserve LineArray(n) As String
							LineArray(n) = Temp & " = " & StrListJoin(TempArray,LngJoinStr)
						End If
					End With
				Next i
				n = UBound(LineArray) + 1
				ReDim Preserve LineArray(n) As String
			End If
		End If
		If WriteType = 0 Or WriteType = 1 Or WriteType = 3 Then
			For i = 0 To UBound(CheckList)
				With CheckList(i)
					n = UBound(LineArray) + 1
					ReDim Preserve LineArray(n + 19) As String
					Select Case .Name
					Case DefaultCheckList(0)
						LineArray(n + 0) = "[en2zh]"
					Case DefaultCheckList(1)
						LineArray(n + 0) = "[zh2en]"
					Case Else
						LineArray(n + 0) = "[" & .Name & "]"
					End Select
					LineArray(n + 1) = "ExcludeChar = " & .AccKeyExcludeChar
					LineArray(n + 2) = "LineSplitChar = " & .PreInsertSplitChar
					LineArray(n + 3) = "CheckBracket = " & .CheckBracket
					LineArray(n + 4) = "KeepCharPair = " & .KeepCharPair
					LineArray(n + 5) = "ShowAsiaKey = " & CStr(.ShowAsiaKey)
					LineArray(n + 6) = "CheckEndChar = " & .CheckEndChar
					LineArray(n + 7) = "NoTrnEndChar = " & .NotTrnEndChar
					LineArray(n + 8) = "AutoTrnEndChar = " & .AutoTrnEndChar
					LineArray(n + 9) = "CheckShortChar = " & .CheckShortChar
					LineArray(n + 10) = "CheckShortKey = " & .CheckShortKey
					LineArray(n + 11) = "KeepShortKey = " & .KeepShortKey
					LineArray(n + 12) = "PreRepString = " & .PreRepStr
					LineArray(n + 13) = "AutoRepString = " & .AppRepStr
					LineArray(n + 14) = "AccessKeyChar = " & .AccKeyChar
					LineArray(n + 15) = "AddAccessKeyWithFirstChar = " & CStr(.AccKeyWithFirstChar)
					LineArray(n + 16) = "LineSplitMode = " & CStr(.LineSplitMode)
					LineArray(n + 17) = "AppInsertSplitChar = " & .AppInsertSplitChar
					LineArray(n + 18) = "ReplaceSplitChar = " & .ReplaceSplitChar
					LineArray(n + 19) = "ApplyLangList = " & LangSetToString(.LangPairList,False)
					If i <> UBound(CheckList) Then
						n = UBound(LineArray) + 1
						ReDim Preserve LineArray(n) As String
					End If
				End With
			Next i
		End If
		WriteToFile(Path,Join(LineArray,vbCrLf),"unicodeFFFE")
		On Error GoTo 0
		WriteCheckSet = True
		If Path = CheckFilePath Then
			cWriteLoc = CheckFilePath
			GoTo RemoveRegKey
		End If
	'дע
	ElseIf Path = CheckRegKey Then
		On Error GoTo ExitFunction
		SaveSetting "AccessKey","Option","Version",Version
		If SelSet = "Main" Or SelSet = "Sets" Or SelSet = "All" Then
			If KeepSet = 1 Then
				SaveSetting "AccessKey","Option","AutoMacroSet",Selected(1)
				SaveSetting "AccessKey","Option","CheckMacroSet",Selected(2)
				SaveSetting "AccessKey","Option","AutoMacroCheck",Selected(3)
				SaveSetting "AccessKey","Option","AutoSelection",Selected(4)
				SaveSetting "AccessKey","Option","SelectedCheck",Selected(5)
				SaveSetting "AccessKey","Option","CheckAllType",Selected(6)
				SaveSetting "AccessKey","Option","CheckMenu",Selected(7)
				SaveSetting "AccessKey","Option","CheckDialog",Selected(8)
				SaveSetting "AccessKey","Option","CheckString",Selected(9)
				SaveSetting "AccessKey","Option","CheckAcceleratorTable",Selected(10)
				SaveSetting "AccessKey","Option","CheckVersion",Selected(11)
				SaveSetting "AccessKey","Option","CheckOther",Selected(12)
				SaveSetting "AccessKey","Option","CheckSeletedOnly",Selected(13)
				SaveSetting "AccessKey","Option","CheckAllCont",Selected(14)
				SaveSetting "AccessKey","Option","CheckAccKey",Selected(15)
				SaveSetting "AccessKey","Option","CheckEndChar",Selected(16)
				SaveSetting "AccessKey","Option","CheckAcceler",Selected(17)
				SaveSetting "AccessKey","Option","IgnoreVerTag",Selected(18)
				SaveSetting "AccessKey","Option","IgnoreSetTag",Selected(19)
				SaveSetting "AccessKey","Option","IgnoreDateTag",Selected(20)
				SaveSetting "AccessKey","Option","IgnoreStateTag",Selected(21)
				SaveSetting "AccessKey","Option","TgnoreAllTag",Selected(22)
				SaveSetting "AccessKey","Option","NoCheckTag",Selected(23)
				SaveSetting "AccessKey","Option","NoChangeTrnState",Selected(24)
				SaveSetting "AccessKey","Option","AutoRepString",Selected(25)
				SaveSetting "AccessKey","Option","KeepSetting",Selected(26)
			End If
		End If
		If SelSet = "Sets" Or SelSet = "All" Then
			'ɾԭ
			Temp = GetSetting("AccessKey","Option","Headers")
			If Temp <> "" Then
				TempArray = ReSplit(Temp,";",-1)
				On Error Resume Next
				For i = 0 To UBound(TempArray)
					DeleteSetting "AccessKey",TempArray(i)
				Next i
				On Error GoTo 0
			End If
			'д
			n = UBound(CheckList)
			ReDim TempArray(n) As String
			For i = 0 To n
				With CheckList(i)
					TempArray(i) = CStr(i)
					Select Case .Name
					Case DefaultCheckList(0)
						SaveSetting "AccessKey",TempArray(i),"Name","en2zh"
					Case DefaultCheckList(1)
						SaveSetting "AccessKey",TempArray(i),"Name","zh2en"
					Case Else
						SaveSetting "AccessKey",TempArray(i),"Name",.Name
					End Select
					SaveSetting "AccessKey",TempArray(i),"ExcludeChar",.AccKeyExcludeChar
					SaveSetting "AccessKey",TempArray(i),"LineSplitChar",.PreInsertSplitChar
					SaveSetting "AccessKey",TempArray(i),"CheckBracket",.CheckBracket
					SaveSetting "AccessKey",TempArray(i),"KeepCharPair",.KeepCharPair
					SaveSetting "AccessKey",TempArray(i),"ShowAsiaKey",CStr(.ShowAsiaKey)
					SaveSetting "AccessKey",TempArray(i),"CheckEndChar",.CheckEndChar
					SaveSetting "AccessKey",TempArray(i),"NoTrnEndChar",.NotTrnEndChar
					SaveSetting "AccessKey",TempArray(i),"AutoTrnEndChar",.AutoTrnEndChar
					SaveSetting "AccessKey",TempArray(i),"CheckShortChar",.CheckShortChar
					SaveSetting "AccessKey",TempArray(i),"CheckShortKey",.CheckShortKey
					SaveSetting "AccessKey",TempArray(i),"KeepShortKey",.KeepShortKey
					SaveSetting "AccessKey",TempArray(i),"PreRepString",.PreRepStr
					SaveSetting "AccessKey",TempArray(i),"AutoRepString",.AppRepStr
					SaveSetting "AccessKey",TempArray(i),"AccessKeyChar",.AccKeyChar
					SaveSetting "AccessKey",TempArray(i),"AddAccessKeyWithFirstChar",CStr(.AccKeyWithFirstChar)
					SaveSetting "AccessKey",TempArray(i),"LineSplitMode",CStr(.LineSplitMode)
					SaveSetting "AccessKey",TempArray(i),"AppInsertSplitChar",.AppInsertSplitChar
					SaveSetting "AccessKey",TempArray(i),"ReplaceSplitChar",.ReplaceSplitChar
					SaveSetting "AccessKey",TempArray(i),"ApplyLangList",LangSetToString(.LangPairList,False)
				End With
			Next i
			SaveSetting "AccessKey","Option","Headers",Join(TempArray,";")
			SaveSetting "AccessKey","Option","UILanguageID",Selected(0)
		End If
		If SelSet = "Update" Or SelSet = "Sets" Or SelSet = "All" Then
			If CheckArray(UpdateSet) = True Then
				On Error Resume Next
				DeleteSetting "AccessKey","Update"
				On Error GoTo 0
				TempArray = ReSplit(UpdateSet(1),vbCrLf,-1)
				SaveSetting "AccessKey","Update","UpdateMode",UpdateSet(0)
				n = 0
				For i = 0 To UBound(TempArray)
					If Trim$(TempArray(i)) <> "" Then
						SaveSetting "AccessKey","Update",CStr(n),TempArray(i)
						n = n + 1
					End If
				Next i
				If n > 0 Then SaveSetting("AccessKey","Update","Count",n - 1)
				SaveSetting "AccessKey","Update","Path",UpdateSet(2)
				SaveSetting "AccessKey","Update","Argument",UpdateSet(3)
				SaveSetting "AccessKey","Update","UpdateCycle",UpdateSet(4)
				SaveSetting "AccessKey","Update","UpdateDate",UpdateSet(5)
			End If
		End If
		If SelSet = "Project" Or SelSet = "Sets" Or SelSet = "All" Then
			If CheckArray(getSetNameList(ProjectList)) = True Then
				On Error Resume Next
				DeleteSetting "AccessKey","Projects"
				On Error GoTo 0
				For i = 0 To UBound(ProjectList)
					With ProjectList(i)
						Select Case .Name
						Case DefaultProjectList(0)
							Temp = "CheckOnly"
						Case DefaultProjectList(1)
							Temp = "CheckAndCorrect"
						Case DefaultProjectList(2)
							Temp = "DelAccessKey"
						Case DefaultProjectList(3)
							Temp = "DelAccelerator"
						Case DefaultProjectList(4)
							Temp = "DelAccessKeyAndAccelerator"
						Case Else
							Temp = ProjectList(i).Name
						End Select
						If Temp <> "" Then
							ReDim TempArray(21) As String
							TempArray(0) = CStr$(.PreSpaceInSource)
							TempArray(1) = CStr$(.PreSpaceInTarget)
							TempArray(2) = CStr$(.PreSpaceInBoth)
							TempArray(3) = CStr$(.EndSpaceInSource)
							TempArray(4) = CStr$(.EndSpaceInTarget)
							TempArray(5) = CStr$(.EndSpaceInBoth)
							TempArray(6) = CStr$(.AcckeyInSource)
							TempArray(7) = CStr$(.AcckeyInTarget)
							TempArray(8) = CStr$(.AcckeyInBoth)
							TempArray(9) = CStr$(.EndStrInSource)
							TempArray(10) = CStr$(.EndStrInTarget)
							TempArray(11) = CStr$(.EndStrInBoth)
							TempArray(12) = CStr$(.ShortcutInSource)
							TempArray(13) = CStr$(.ShortcutInTarget)
							TempArray(14) = CStr$(.ShortcutInBoth)
							TempArray(15) = CStr$(.DelSpace)
							TempArray(16) = CStr$(.EnableStrSplit)
							TempArray(17) = CStr$(.TranEndStr)
							TempArray(18) = CStr$(.UseAcckeyInShortcut)
							TempArray(19) = CStr$(.ShowOriginalTran)
							TempArray(20) = CStr$(.ApplyCheckResult)
							TempArray(21) = CStr$(.SpaceForEnAndAsia)
							SaveSetting "AccessKey","Projects",Temp,StrListJoin(TempArray,LngJoinStr)
						End If
					End With
				Next i
			End If
		End If
		WriteCheckSet = True
		cWriteLoc = CheckRegKey
		GoTo RemoveFilePath
	'ɾб
	ElseIf Path = "" Then
		'ɾļ
 		RemoveFilePath:
		On Error Resume Next
		If Dir(CheckFilePath) <> "" Then
			SetAttr CheckFilePath,vbNormal
			Kill CheckFilePath
		End If
		Temp = Left(CheckFilePath,InStrRev(CheckFilePath,"\"))
		If Dir(Temp & "*.*") = "" Then RmDir Temp
		On Error GoTo 0
		If Path = CheckRegKey Then GoTo ExitFunction
		'ɾע
		RemoveRegKey:
		If GetSetting("AccessKey","Option","Version") <> "" Then
			Temp = GetSetting("AccessKey","Option","Headers")
			On Error Resume Next
			If Temp <> "" Then
				TempArray = ReSplit(Temp,";",-1)
				For i = 0 To UBound(TempArray)
					DeleteSetting "AccessKey",TempArray(i)
				Next i
			End If
			DeleteSetting "AccessKey","Option"
			DeleteSetting "AccessKey","Update"
			DeleteSetting "AccessKey","Projects"
			Dim WshShell As Object
			Set WshShell = CreateObject("WScript.Shell")
			WshShell.RegDelete CheckRegKey
			Set WshShell = Nothing
			On Error GoTo 0
		End If
		If Path = CheckFilePath Then GoTo ExitFunction
		'дλΪ
		WriteCheckSet = True
		cWriteLoc = ""
	End If
	ExitFunction:
	'Ի
	If SelSet = "DlgFont" Or SelSet = "Sets" Then
		On Error Resume Next
		DeleteSetting(AppName,"DlgFonts")
		On Error GoTo 0
		For i = 0 To UBound(LFList)
			Select Case i
			Case 0
				Temp = "MainFont"
			Case 1
				Temp = "SrcStrFont"
			Case 2
				Temp = "TrnStrFont"
			End Select
			If CheckFont(LFList(i)) = True Then
				With LFList(i)
					SaveSetting(AppName,"DlgFonts",Temp & "_lfCharSet",CStr$(.lfCharSet))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfClipPrecision",CStr$(.lfClipPrecision))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfEscapement",CStr$(.lfEscapement))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfFaceName",ReSplit(StrConv$(.lfFaceName,vbUnicode),vbNullChar,2)(0))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfHeight",CStr$(.lfHeight))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfItalic",CStr$(.lfItalic))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfOrientation",CStr$(.lfOrientation))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfOutPrecision",CStr$(.lfOutPrecision))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfPitchAndFamily",CStr$(.lfPitchAndFamily))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfQuality",CStr$(.lfQuality))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfStrikeOut",CStr$(.lfStrikeOut))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfUnderline",CStr$(.lfUnderline))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfWeight",CStr$(.lfWeight))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfWidth",CStr$(.lfWidth))
					SaveSetting(AppName,"DlgFonts",Temp & "_lfColor",CStr$(.lfColor))
				End With
			Else
				ReDim tmpLFList(0) As LOG_FONT
				LFList(i) = tmpLFList(0)
			End If
		Next i
		WriteCheckSet = True
	End If
End Function


'¼ɰ汾ֵ
Private Sub CheckSetUpdate(CheckSet As CHECK_SET)
	Dim i As Long,Temp As CHECK_SET
	With CheckSet
		For i = 0 To UBound(DefaultCheckList)
			If DefaultCheckList(i) = .Name Then
				Temp = DefaultCheckSet(DefaultCheckList(i),False)
				.AccKeyExcludeChar = MergeString(.AccKeyExcludeChar,Temp.AccKeyExcludeChar,",")
				.PreInsertSplitChar = MergeString(.PreInsertSplitChar,Temp.PreInsertSplitChar,",")
				.CheckBracket = MergeString(.CheckBracket,Temp.CheckBracket,",")
				.KeepCharPair = MergeString(.KeepCharPair,Temp.KeepCharPair,",")
				.ShowAsiaKey = Temp.ShowAsiaKey
				.CheckEndChar = MergeString(.CheckEndChar,Temp.CheckEndChar," ")
				.NotTrnEndChar = MergeString(.NotTrnEndChar,Temp.NotTrnEndChar,",")
				.AutoTrnEndChar = MergeString(.AutoTrnEndChar,Temp.AutoTrnEndChar," ")
				.CheckShortChar = MergeString(.CheckShortChar,Temp.CheckShortChar,",")
				.CheckShortKey = MergeString(.CheckShortKey,Temp.CheckShortKey,",")
				.KeepShortKey = MergeString(.KeepShortKey,Temp.KeepShortKey,",")
				.PreRepStr = MergeString(.PreRepStr,Temp.PreRepStr,",")
				.AppRepStr = MergeString(.AppRepStr,Temp.AppRepStr,",")
				.AccKeyChar = MergeString(.AccKeyChar,Temp.AccKeyChar,",")
				.AccKeyWithFirstChar = Temp.AccKeyWithFirstChar
				.LineSplitMode = Temp.LineSplitMode
				.AppInsertSplitChar = MergeString(.AppInsertSplitChar,Temp.AppInsertSplitChar,",")
				.ReplaceSplitChar = MergeString(.ReplaceSplitChar,Temp.ReplaceSplitChar,",")
				.LangPairList = MergeLngList(LangCodeList(.Name,1,-1),.LangPairList)
				Exit For
			End If
		Next i
	End With
End Sub


'ϲ¾ֵ
Private Function MergeString(ByVal OldStr As String,ByVal NewStr As String,ByVal SkipChar As String) As String
	If OldStr = "" Then
		MergeString = NewStr
	Else
		MergeString = OldStr & SkipChar & NewStr
	End If
	MergeString = StrListJoin(ClearTextArray(ReSplit(MergeString,SkipChar,-1)),SkipChar)
End Function


'ִĬ
Public Function DefaultCheckSet(ByVal CheckName As String,ByVal CheckType As Boolean) As Variant
	Dim i As Long,j As Long,File As String
	Dim CheckSet As CHECK_SET,CheckPoject As CHECK_PROJECT_SET
	Dim TempList() As String,DataList() As INIFILE_DATA

	If CheckName = "" Then GoTo ExitFunction
	If CheckType = False Then
		Select Case CheckName
		Case DefaultCheckList(0)
			CheckName = "en2zh"
		Case DefaultCheckList(1)
			CheckName = "zh2en"
		Case Else
			CheckName = ""
		End Select
	Else
		Select Case CheckName
		Case DefaultProjectList(0)
			CheckName = "CheckOnly"
		Case DefaultProjectList(1)
			CheckName = "CheckAndCorrect"
		Case DefaultProjectList(2)
			CheckName = "DelAccessKey"
		Case DefaultProjectList(3)
			CheckName = "DelAccelerator"
		Case DefaultProjectList(4)
			CheckName = "DelAccessKeyAndAccelerator"
		Case Else
			CheckName = ""
		End Select
	End If
	If CheckName = "" Then GoTo ExitFunction

	File = MacroLoc & "\Data\PSLCheckAccessKeys.ini"
	If getINIFile(DataList,File,"unicodeFFFE",1) = False Then GoTo NotReadFile

	On Error GoTo ErrMassage
	For i = 0 To UBound(DataList)
		With DataList(i)
			If .Title = "Option" Then
				For j = 0 To UBound(.Item)
					If .Item(j) = "Version" Then
						If StrComp(ToUpdateCheckVersion,.Value(j)) = 1 Then
							CheckName = ""
							Err.Raise(1,"NotVersion",File & JoinStr & .Value(j) & JoinStr & ToUpdateCheckVersion)
							Exit For
						End If
					End If
				Next j
			ElseIf CheckType = False And .Title = CheckName Then
				For j = 0 To UBound(.Item)
					Select Case .Item(j)
					Case "ExcludeChar"
						CheckSet.AccKeyExcludeChar = .Value(j)
					Case "LineSplitChar"
						CheckSet.PreInsertSplitChar = .Value(j)
					Case "CheckBracket"
						CheckSet.CheckBracket = .Value(j)
					Case "KeepCharPair"
						CheckSet.KeepCharPair = .Value(j)
					Case "ShowAsiaKey"
						CheckSet.ShowAsiaKey = StrToLong(.Value(j))
					Case "CheckEndChar"
						CheckSet.CheckEndChar = .Value(j)
					Case "NoTrnEndChar"
						CheckSet.NotTrnEndChar = .Value(j)
					Case "AutoTrnEndChar"
						CheckSet.AutoTrnEndChar = .Value(j)
					Case "CheckShortChar"
						CheckSet.CheckShortChar = .Value(j)
					Case "CheckShortKey"
						CheckSet.CheckShortKey = .Value(j)
					Case "KeepShortKey"
						CheckSet.KeepShortKey = .Value(j)
					Case "PreRepString"
						CheckSet.PreRepStr = .Value(j)
					Case "AutoRepString"
						CheckSet.AppRepStr = .Value(j)
					Case "AccessKeyChar"
						CheckSet.AccKeyChar = .Value(j)
					Case "AddAccessKeyWithFirstChar"
						CheckSet.AccKeyWithFirstChar = StrToLong(.Value(j))
					Case "LineSplitMode"
						CheckSet.LineSplitMode = StrToLong(.Value(j))
					Case "AppInsertSplitChar"
						CheckSet.AppInsertSplitChar = .Value(j)
					Case "ReplaceSplitChar"
						CheckSet.ReplaceSplitChar = .Value(j)
					End Select
				Next j
				DefaultCheckSet = CheckName
			ElseIf CheckType = True And .Title = "Projects" Then
				For j = 0 To UBound(.Item)
					If .Item(j) = CheckName Then
						TempList = Split(.Value(j),LngJoinStr)
						If UBound(TempList) < 21 Then ReDim Preserve TempList(21) As String
						CheckPoject.PreSpaceInSource = StrToLong(TempList(0))
						CheckPoject.PreSpaceInTarget = StrToLong(TempList(1))
						CheckPoject.PreSpaceInBoth = StrToLong(TempList(2))
						CheckPoject.EndSpaceInSource = StrToLong(TempList(3))
						CheckPoject.EndSpaceInTarget = StrToLong(TempList(4))
						CheckPoject.EndSpaceInBoth = StrToLong(TempList(5))
						CheckPoject.AcckeyInSource = StrToLong(TempList(6))
						CheckPoject.AcckeyInTarget = StrToLong(TempList(7))
						CheckPoject.AcckeyInBoth = StrToLong(TempList(8))
						CheckPoject.EndStrInSource = StrToLong(TempList(9))
						CheckPoject.EndStrInTarget = StrToLong(TempList(10))
						CheckPoject.EndStrInBoth = StrToLong(TempList(11))
						CheckPoject.ShortcutInSource = StrToLong(TempList(12))
						CheckPoject.ShortcutInTarget = StrToLong(TempList(13))
						CheckPoject.ShortcutInBoth = StrToLong(TempList(14))
						CheckPoject.DelSpace = StrToLong(TempList(15))
						CheckPoject.EnableStrSplit = StrToLong(TempList(16))
						CheckPoject.TranEndStr = StrToLong(TempList(17))
						CheckPoject.UseAcckeyInShortcut = StrToLong(TempList(18))
						CheckPoject.ShowOriginalTran = StrToLong(TempList(19))
						CheckPoject.ApplyCheckResult = StrToLong(TempList(20))
						CheckPoject.SpaceForEnAndAsia = StrToLong(TempList(21))
						DefaultCheckSet = CheckName
						Exit For
					End If
				Next j
			End If
		End With
	Next i
	If DefaultCheckSet = "" Then
		If CheckType = 0 Then
			Err.Raise(1,"NotSection",File & JoinStr & CheckName)
		ElseIf CheckType = 1 Then
			Err.Raise(1,"NotValue",File & JoinStr & CheckName)
		End If
	End If
	GoTo ExitFunction

	NotReadFile:
	Err.Source = "NotReadFile"
	Err.Description = Err.Description & JoinStr & File

	ErrMassage:
	Call sysErrorMassage(Err,1)

	ExitFunction:
	If CheckType = False Then
		DefaultCheckSet = CheckSet
	Else
		DefaultCheckSet = CheckPoject
	End If
End Function


'ɾıĿ
Private Sub DelArray(List() As String,ByVal IDList As Variant,Optional ByVal Separator As String)
	Dim i As Long,n As Long
	If IsArray(IDList) Then
		If UBound(List) = UBound(IDList) Then
			ReDim List(0) As String
			Exit Sub
		End If
		ReDim Stemp(UBound(List)) As Long
		For i = LBound(IDList) To UBound(IDList)
			If IDList(i) > -1 Then Stemp(IDList(i)) = 1
		Next i
		n = IDList(LBound(IDList))
		For i = IDList(LBound(IDList)) To UBound(List)
			If Stemp(i) = 0 Then
				List(n) = List(i)
				n = n + 1
			End If
		Next i
	ElseIf IsNumeric(IDList) And Separator = "" Then
		n = IDList
		For i = IDList + 1 To UBound(List)
			List(n) = List(i)
			n = n + 1
		Next i
	ElseIf IDList <> "" Then
		For i = LBound(List) To UBound(List)
			If Separator <> "" Then
				If ReSplit(List(i),Separator)(0) <> IDList Then
					List(n) = List(i)
					n = n + 1
				End If
			ElseIf List(i) <> IDList Then
				List(n) = List(i)
				n = n + 1
			End If
		Next i
	Else
		Exit Sub
	End If
	If n > 0 Then
		ReDim Preserve List(n - 1) As String
	Else
		ReDim List(0) As String
	End If
End Sub


'ɾĿ
Public Sub DelCheckArray(DataList() As CHECK_SET,IDList As Variant)
	Dim i As Long,n As Long
	If IsArray(IDList) Then
		If UBound(DataList) = UBound(IDList) Then
			ReDim DataList(0) As CHECK_SET
			Exit Sub
		End If
		ReDim Stemp(UBound(DataList)) As Long
		For i = LBound(IDList) To UBound(IDList)
			If IDList(i) > -1 Then Stemp(IDList(i)) = 1
		Next i
		n = IDList(LBound(IDList))
		For i = IDList(LBound(IDList)) To UBound(DataList)
			If Stemp(i) = 0 Then
				DataList(n) = DataList(i)
				n = n + 1
			End If
		Next i
	ElseIf IsNumeric(IDList) Then
		n = IDList
		For i = IDList + 1 To UBound(DataList)
			DataList(n) = DataList(i)
			n = n + 1
		Next i
	Else
		Exit Sub
	End If
	If n > 0 Then
		ReDim Preserve DataList(n - 1) As CHECK_SET
	Else
		ReDim DataList(0) As CHECK_SET
	End If
End Sub


'ɾ鷽Ŀ
Public Sub DelProjectArray(DataList() As CHECK_PROJECT_SET,IDList As Variant)
	Dim i As Long,n As Long
	If IsArray(IDList) Then
		If UBound(DataList) = UBound(IDList) Then
			ReDim DataList(0) As CHECK_PROJECT_SET
			Exit Sub
		End If
		ReDim Stemp(UBound(DataList)) As Long
		For i = LBound(IDList) To UBound(IDList)
			If IDList(i) > -1 Then Stemp(IDList(i)) = 1
		Next i
		n = IDList(LBound(IDList))
		For i = IDList(LBound(IDList)) To UBound(DataList)
			If Stemp(i) = 0 Then
				DataList(n) = DataList(i)
				n = n + 1
			End If
		Next i
	ElseIf IsNumeric(IDList) Then
		n = IDList
		For i = IDList + 1 To UBound(DataList)
			DataList(n) = DataList(i)
			n = n + 1
		Next i
	Else
		Exit Sub
	End If
	If n > 0 Then
		ReDim Preserve DataList(n - 1) As CHECK_PROJECT_SET
	Else
		ReDim DataList(0) As CHECK_PROJECT_SET
	End If
End Sub


'ɾԶ
Public Sub DelLangPair(DataList() As LANG_SET,IDList As Variant)
	Dim i As Long,n As Long
	If IsArray(IDList) Then
		If UBound(DataList) = UBound(IDList) Then
			ReDim DataList(0) As LANG_SET
			Exit Sub
		End If
		ReDim Stemp(UBound(DataList)) As Long
		For i = LBound(IDList) To UBound(IDList)
			If IDList(i) > -1 Then Stemp(IDList(i)) = 1
		Next i
		n = IDList(LBound(IDList))
		For i = IDList(LBound(IDList)) To UBound(DataList)
			If Stemp(i) = 0 Then
				DataList(n) = DataList(i)
				n = n + 1
			End If
		Next i
	ElseIf IsNumeric(IDList) Then
		n = IDList
		For i = IDList + 1 To UBound(DataList)
			DataList(n) = DataList(i)
			n = n + 1
		Next i
	Else
		Exit Sub
	End If
	If n > 0 Then
		ReDim Preserve DataList(n - 1) As LANG_SET
	Else
		ReDim DataList(0) As LANG_SET
	End If
End Sub


'ȡĹб
Private Function GetToolNameList(DataList() As TOOLS_PROPERTIE,ByVal StartID As Long) As String()
	Dim i As Long
	i = UBound(DataList)
	If StartID > i Or StartID < 0 Then
		ReDim TempList(0) As String
	Else
		ReDim TempList(i - StartID) As String
		For i = StartID To UBound(DataList)
			TempList(i - StartID) = DataList(i).sName
		Next i
	End If
	GetToolNameList = TempList
End Function


'ɾԶ幤Ŀ
Private Sub DelToolsArray(DataList() As TOOLS_PROPERTIE,ByVal IDList As Variant)
	Dim i As Long,n As Long
	If IsArray(IDList) Then
		If UBound(DataList) = UBound(IDList) Then
			ReDim DataList(0) As TOOLS_PROPERTIE
			Exit Sub
		End If
		ReDim Stemp(UBound(DataList)) As Long
		For i = LBound(IDList) To UBound(IDList)
			If IDList(i) > -1 Then Stemp(IDList(i)) = 1
		Next i
		n = IDList(LBound(IDList))
		For i = IDList(LBound(IDList)) To UBound(DataList)
			If Stemp(i) = 0 Then
				DataList(n) = DataList(i)
				n = n + 1
			End If
		Next i
	ElseIf IsNumeric(IDList) Then
		n = IDList
		For i = IDList + 1 To UBound(DataList)
			DataList(n) = DataList(i)
			n = n + 1
		Next i
	ElseIf IDList <> "" Then
		For i = LBound(DataList) To UBound(DataList)
			If DataList(i).sName <> IDList Then
				DataList(n) = DataList(i)
				n = n + 1
			End If
		Next i
	Else
		Exit Sub
	End If
	If n > 0 Then
		ReDim Preserve DataList(n - 1) As TOOLS_PROPERTIE
	Else
		ReDim DataList(0) As TOOLS_PROPERTIE
	End If
End Sub


'ȡͷеб
Public Function GetLangSet(LangSetList() As LANG_SET,ByVal GetType As Integer) As String()
	Dim i As Long,n As Long
	i = UBound(LangSetList)
	ReDim TempList(i) As String
	Select Case GetType
	'ڷԶԵȫʾ
	Case 0
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				TempList(n) = LangSetList(i).Name
				n = n + 1
			End If
		Next i
	Case 1
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				TempList(n) = LangSetList(i).PslCode
				If TempList(n) = "" Then TempList(n) = NullValue
				n = n + 1
			End If
		Next i
	Case 2
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				TempList(n) = LangSetList(i).UseCode
				If TempList(n) = "" Then TempList(n) = NullValue
				n = n + 1
			End If
		Next i
	'ڷ UseCode ΪյĹʾ
	Case 3
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				If LangSetList(i).UseCode <> "" Then
					TempList(n) = LangSetList(i).Name
					n = n + 1
				End If
			End If
		Next i
	Case 4
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				If LangSetList(i).UseCode <> "" Then
					TempList(n) = LangSetList(i).PslCode
					If TempList(n) = "" Then TempList(n) = NullValue
					n = n + 1
				End If
			End If
		Next i
	Case 5
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				If LangSetList(i).UseCode <> "" Then
					TempList(n) = LangSetList(i).UseCode
					n = n + 1
				End If
			End If
		Next i
	'ڷ UseCode ΪյĹʾ
	Case 6
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				If LangSetList(i).UseCode = "" Then
					TempList(n) = LangSetList(i).Name
					n = n + 1
				End If
			End If
		Next i
	Case 7
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				If LangSetList(i).UseCode = "" Then
					TempList(n) = LangSetList(i).PslCode
					If TempList(n) = "" Then TempList(n) = NullValue
					n = n + 1
				End If
			End If
		Next i
	Case 8
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).Name <> "" Then
				If LangSetList(i).UseCode = "" Then
					TempList(n) = NullValue
					n = n + 1
				End If
			End If
		Next i
	'ڷѡ
	Case 9
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).UseCode = "" Then
				TempList(n) = LangSetList(i).Name
				n = n +1
			End If
		Next i
	Case 10
		For i = 0 To UBound(LangSetList)
			If LangSetList(i).UseCode <> "" Then
				TempList(n) = LangSetList(i).Name
				n = n + 1
			End If
		Next i
	End Select
	If n > 0 Then n = n - 1
	ReDim Preserve TempList(n) As String
	GetLangSet = TempList
End Function


'ִΪøʽ
'Mode = False ַԣַ
Private Function StringToLangSet(textStr As String,ByVal Mode As Boolean) As LANG_SET()
	Dim i As Long,j As Long,TempList() As String,TempArray() As String
	TempList = ReSplit(textStr,SubLngJoinStr)
	j = UBound(TempList)
	ReDim LangSetList(j) As LANG_SET
	If Mode = False Then
		For i = 0 To j
			TempArray = ReSplit(TempList(i),LngJoinStr)
			With LangSetList(i)
				.Name = TempArray(0)
				.PslCode = TempArray(1)
				.UseCode = TempArray(1)
			End With
		Next i
	Else
		For i = 0 To j
			TempArray = ReSplit(TempList(i),LngJoinStr)
			With LangSetList(i)
				.Name = TempArray(0)
				.PslCode = TempArray(1)
				.UseCode = TempArray(2)
			End With
		Next i
	End If
	StringToLangSet = LangSetList
End Function


'ϲ׼Զб
'Mode = False ϲԣϲ
Private Function MergeLngList(LangSetList() As LANG_SET,DataList() As LANG_SET) As LANG_SET()
	Dim i As Long,j As Long,n As Long,PslCode As String,Dic As Object
	Dim TempList() As LANG_SET
	Set Dic = CreateObject("Scripting.Dictionary")
	n = UBound(LangSetList)
	For i = 0 To n
		PslCode = LCase$(LangSetList(i).PslCode)
		If Not Dic.Exists(PslCode) Then Dic.Add(PslCode,i)
	Next i
	TempList = LangSetList
	ReDim Preserve TempList(n + UBound(DataList)) As LANG_SET
	For i = 0 To UBound(DataList)
		PslCode = LCase$(DataList(i).PslCode)
		If Dic.Exists(PslCode) Then
			j = Dic.Item(PslCode)
			TempList(j).Name = LangSetList(j).Name
			TempList(j).PslCode = LangSetList(j).PslCode
			TempList(j).UseCode = DataList(i).UseCode
		ElseIf DataList(i).Name <> "" Then
			n = n + 1
			TempList(n) = DataList(i)
		End If
	Next i
	Set Dic = Nothing
	ReDim Preserve TempList(n) As LANG_SET
	MergeLngList = TempList
End Function


'ȥбпԶ
'Mode = False ȥԵĿȥԵĿ
Private Function LangSetToString(LangSetList() As LANG_SET,ByVal Mode As Boolean) As String
	Dim i As Long,j As Long,n As Long
	Dim TempList() As String,PslCode As String,Dic As Object
	Set Dic = CreateObject("Scripting.Dictionary")
	For i = 0 To UBound(LangSetList)
		PslCode = LCase$(LangSetList(i).PslCode)
		If Not Dic.Exists(PslCode) Then Dic.Add(PslCode,i)
	Next i
	j = UBound(LangSetList)
	ReDim TempList(j) As String
	If Mode = False Then
		For i = 0 To j
			With LangSetList(i)
				If .UseCode <> "" Then
					PslCode = LCase$(LangSetList(i).PslCode)
					If Dic.Exists(PslCode) Then
						TempList(n) = LngJoinStr & .UseCode
					Else
						TempList(n) = .PslCode & LngJoinStr & .UseCode
					End If
					n = n + 1
				End If
			End With
		Next i
	Else
		For i = 0 To j
			With LangSetList(i)
				If .UseCode <> "" Then
					PslCode = LCase$(LangSetList(i).PslCode)
					If Dic.Exists(PslCode) Then
						TempList(n) = LngJoinStr & .PslCode & LngJoinStr & .UseCode
					Else
						TempList(n) = .Name & LngJoinStr & .PslCode & LngJoinStr & .UseCode
					End If
					n = n + 1
				End If
			End With
		Next i
	End If
	If n > 0 Then
		ReDim Preserve TempList(n - 1) As String
		LangSetToString = StrListJoin(TempList,SubLngJoinStr)
	End If
	Set Dic = Nothing
End Function


'Ŀ
'Mode = 0 ҳͬģҳͬĿ
Public Function ChangeList(AllList() As String,UseList() As String,Optional ByVal Mode As Long) As String()
	Dim i As Long,n As Long,Dic As Object
	If CheckArray(UseList) = False Then
		ChangeList = IIf(Mode = 0,AllList,UseList)
		Exit Function
	ElseIf CheckArray(AllList) = False Then
		ChangeList = IIf(Mode = 0,UseList,AllList)
		Exit Function
	End If
	ReDim TempList(UBound(AllList)) As String
	Set Dic = CreateObject("Scripting.Dictionary")
	For i = LBound(UseList) To UBound(UseList)
		If Not Dic.Exists(UseList(i)) Then
			Dic.Add(UseList(i),"")
		End If
	Next i
	If Mode = 0 Then
		For i = LBound(AllList) To UBound(AllList)
			If Not Dic.Exists(AllList(i)) Then
				TempList(n) = AllList(i)
				n = n + 1
			End If
		Next i
	Else
		For i = LBound(AllList) To UBound(AllList)
			If Dic.Exists(AllList(i)) Then
				TempList(n) = AllList(i)
				n = n + 1
			End If
		Next i
	End If
	Set Dic = Nothing
	If n > 0 Then n = n - 1
	ReDim Preserve TempList(n) As String
	ChangeList = TempList
End Function


'ֵָǷ
Public Function getCheckID(CheckSetList() As CHECK_SET,ByVal LngCode As String,ByVal OldLngCode As String) As Long
	Dim i As Long,j As Long,TempList() As String
	getCheckID = -1
	LngCode = LngJoinStr & LCase$(LngCode) & LngJoinStr
	For i = 0 To UBound(CheckSetList)
		For j = 0 To UBound(CheckSetList(i).LangPairList)
			With CheckSetList(i).LangPairList(j)
				If .UseCode <> "" Then
					If InStr(LngCode,LngJoinStr & LCase$(.UseCode) & LngJoinStr) Then
						getCheckID = i
						Exit Function
					End If
				End If
			End With
		Next j
	Next i
	If OldLngCode = "Asia" Then getCheckID = 0 Else getCheckID = 1
End Function


'ִַݹ鷨ִ
'Mode = False С򣬷ӴСl = ߽磬r = ұ߽.
Private Sub SortArrayByLength(ByRef MyArray As Variant, ByVal l As Long, ByVal r As Long, ByVal Mode As Boolean)
	Dim i As Long, j As Long, TmpX As Variant, TmpA As Variant
	i = l: j = r: TmpX = Len(MyArray((l + r) \ 2))
	While (i <= j)
		If Mode = False Then
			While (Len(MyArray(i)) < TmpX And i < r)
				i = i + 1
			Wend
			While (TmpX < Len(MyArray(j)) And j > l)
				j = j - 1
			Wend
		Else
			While (Len(MyArray(i)) > TmpX And i < r)
				i = i + 1
			Wend
			While (TmpX > Len(MyArray(j)) And j > l)
				j = j - 1
			Wend
		End If
		If (i <= j) Then
			TmpA = MyArray(i)
			MyArray(i) = MyArray(j)
			MyArray(j) = TmpA
			i = i + 1: j = j - 1
		End If
	Wend
	If (l < j) Then Call SortArrayByLength(MyArray, l, j, Mode)
	If (i < r) Then Call SortArrayByLength(MyArray, i, r, Mode)
End Sub


'ִظ
'Mode = False 
Public Function ClearTextArray(MyArray() As String,Optional ByVal Mode As Boolean) As String()
	Dim i As Long,n As Long,Dic As Object
	ClearTextArray = MyArray
	If CheckArrEmpty(MyArray) = False Then Exit Function
	i = UBound(MyArray)
	If i = 0 Then Exit Function
	ReDim TempArray(i) As String
	Set Dic = CreateObject("Scripting.Dictionary")
	If Mode = False Then
		For i = LBound(MyArray) To UBound(MyArray)
			If Not Dic.Exists(MyArray(i)) Then
				Dic.Add(MyArray(i),"")
				TempArray(n) = MyArray(i)
				n = n + 1
			End If
		Next i
	Else
		For i = LBound(MyArray) To UBound(MyArray)
			If MyArray(i) <> "" Then
				If Not Dic.Exists(MyArray(i)) Then
					Dic.Add(MyArray(i),"")
					TempArray(n) = MyArray(i)
					n = n + 1
				End If
			End If
		Next i
	End If
	If n = 0 Then Exit Function
	ReDim Preserve TempArray(n - 1) As String
	ClearTextArray = TempArray
End Function


'ִǷΪգǿշ True
Public Function CheckArray(DataList() As String) As Boolean
	Dim i As Long
	On Error GoTo errHandle
	For i = LBound(DataList) To UBound(DataList)
		If DataList(i) <> "" Then
			CheckArray = True
			Exit For
		End If
	Next i
	errHandle:
End Function


'ǷѾʼ
'ֵ:TRUE Ѿʼ, FALSE δʼ
Public Function CheckArrEmpty(ByRef MyArr As Variant) As Boolean
	On Error Resume Next
	If UBound(MyArr) >= 0 Then CheckArrEmpty = True
	Err.Clear
End Function


' INI ǷΪգǿշ True
Private Function CheckINIArray(DataList() As INIFILE_DATA) As Boolean
	Dim i As Long
	On Error GoTo errHandle
	For i = LBound(DataList) To UBound(DataList)
		If DataList(i).Title <> "" Then
			CheckINIArray = True
			Exit For
		End If
	Next i
	errHandle:
End Function


'Ƚ϶ִǷͬͬ True
Public Function ArrayComp(uArray() As String,oArray() As String,Optional ByVal Index As String) As Boolean
	Dim i As Long,j As Long,SkipArray() As String,TempArray() As String
	If UBound(uArray) <> UBound(oArray) Then
		ArrayComp = True
		Exit Function
	End If
	If Index = "" Then
		For i = LBound(uArray) To UBound(uArray)
			If oArray(i) <> uArray(i) Then
				ArrayComp = True
				Exit For
			End If
		Next i
	Else
		SkipArray = ReSplit(Index,",",-1)
		For i = 0 To UBound(SkipArray)
			TempArray = ReSplit(SkipArray(i),"-")
			For j = StrToLong(TempArray(0)) To StrToLong(TempArray(UBound(TempArray)))
				If oArray(j) <> uArray(j) Then
					ArrayComp = True
					Exit Function
				End If
			Next j
		Next i
	End If
End Function


'ݵ
'Mode = True ظλ Data ǰ
Private Function InsertArray(List() As String,ByVal Data As String,ByVal insPos As Long,Optional ByVal Mode As Boolean) As Boolean
	Dim i As Long,j As Long
	i = LBound(List)
	j = UBound(List)
	If j = i And List(i) = "" Then
		List(i) = Data
	Else
		If Mode = True Then
			If insPos = 0 Then
				If List(0) = Data Then Exit Function
			ElseIf InStr(vbNullChar & StrListJoin(List,vbNullChar) & vbNullChar,vbNullChar & Data & vbNullChar) Then
				Exit Function
			End If
		End If
		ReDim Preserve List(j + 1) As String
		If insPos <= j Then
			For i = j + 1 To insPos + 1 Step -1
				List(i) = List(i - 1)
			Next i
			List(insPos) = Data
		Else
			List(j + 1) = Data
		End If
		If Mode = True Then List = ClearTextArray(List,True)
	End If
	InsertArray = True
End Function


'ʽֵָ
Private Function CheckLike(ByVal textStr As String,ByVal LikeSet As String) As Boolean
	Dim i As Long
	If TextStr = "" Then Exit Function
	If LikeSet = "" Then Exit Function
	If UBound(ReSplit(LikeSet,"[")) <> UBound(ReSplit(LikeSet,"]")) Then
		i = InStr(LikeSet,"[")
		Select Case i
		Case 1
			LikeSet = Replace(LikeSet,"[","[[]")
		Case Is > 1
			If Left(LikeSet,i - 1) <> "\" Then
				LikeSet = Replace(LikeSet,"[","[[]")
			End If
		End Select
	End If
	CheckLike = (textStr Like LikeSet)
End Function


'
Public Function AddSet(DataArr() As String,Optional ByVal sName As String) As String
	Dim i As Long,MsgList() As String
	If getMsgList(UIDataList,MsgList,"AddSet",1) = False Then Exit Function
	Begin Dialog UserDialog 380,77,MsgList(0),.CommonDlgFunc ' %GRID:10,7,1,1
		Text 10,7,360,14,MsgList(1),.MainText
		TextBox 10,21,360,21,.TextBox
		OKButton 100,49,80,21,.OKButton
		CancelButton 200,49,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.TextBox = sName
	DataInPutDlg:
	If Dialog(dlg) = 0 Then
		AddSet = ""
		Exit Function
	End If
	AddSet = Trim(dlg.TextBox)
	If AddSet = "" Then
		MsgBox MsgList(3),vbOkOnly+vbInformation,MsgList(2)
		GoTo DataInPutDlg
	End If
	For i = LBound(DataArr) To UBound(DataArr)
		If LCase$(AddSet) = LCase$(DataArr(i)) Then
			MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(2)
			GoTo DataInPutDlg
		End If
	Next i
End Function


'༭
Public Function EditSet(DataArr() As String,ByVal HeaderID As Long) As String
	Dim i As Long,MsgList() As String
	On Error GoTo ExitFunction
	If getMsgList(UIDataList,MsgList,"EditSet",1) = False Then Exit Function
	Begin Dialog UserDialog 380,126,MsgList(0),.CommonDlgFunc ' %GRID:10,7,1,1
		GroupBox 10,17,360,28,"",.GroupBox1
		Text 10,7,350,14,MsgList(1),.Text1
		Text 20,28,340,14,Replace$(DataArr(HeaderID),"&","&&"),.oldNameText
		Text 10,56,360,14,MsgList(2),.newNameText
		TextBox 10,70,360,21,.TextBox
		OKButton 100,98,80,21,.OKButton
		CancelButton 200,98,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	DataInPutDlg:
	dlg.TextBox = DataArr(HeaderID)
	If Dialog(dlg) = 0 Then
		EditSet = ""
		Exit Function
	End If
	EditSet = Trim$(dlg.TextBox)
	If EditSet = "" Then
		MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(3)
		GoTo DataInPutDlg
	End If
	If EditSet = DataArr(HeaderID) Then Exit Function
	For i = LBound(DataArr) To UBound(DataArr)
		If LCase$(EditSet) = LCase$(DataArr(i)) Then
			MsgBox MsgList(5),vbOkOnly+vbInformation,MsgList(3)
			GoTo DataInPutDlg
		End If
	Next i
	ExitFunction:
End Function


'༭ƺƶԻ
Private Function CommonDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	End Select
End Function


'ıļ
Private Function OpenFile(ByVal File As String,FileDataList() As String,ByVal x As Long,RunStemp As Boolean) As Boolean
	Dim i As Long,ExePath As String,ExeName As String,Argument As String,ExtName As String
	Dim TempArray() As String,MsgList() As String,WshShell As Object

	OpenFile = False
	If getMsgList(UIDataList,MsgList,"OpenFile",1) = False Then Exit Function

	If x > 0 Then
		On Error Resume Next
		Set WshShell = CreateObject("WScript.Shell")
		If WshShell Is Nothing Then
			Err.Source = "WScript.Shell"
			Call sysErrorMassage(Err,2)
			Exit Function
		End If
		On Error GoTo 0
	End If

	Select Case x
	Case 0
		If EditFile(File,FileDataList,RunStemp) = True Then OpenFile = True
	Case 1
		ExePath = Environ("SystemRoot") & "\system32\notepad.exe"
		If Dir$(ExePath) = "" Then
			ExePath = Environ("SystemRoot") & "\notepad.exe"
		End If
		If Dir(ExePath) = "" Then
			MsgBox MsgList(1),vbOkOnly+vbInformation,MsgList(0)
		Else
			If WshShell.Run("""" & ExePath & """ " & """" & File & """",1,RunStemp) <> 0 Then
				MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
			Else
				OpenFile = True
			End If
		End If
	Case 2
		i = InStrRev(File,".")
		If i > 0 Then ExtName = Mid$(File,i)
		On Error Resume Next
		ExtName = WshShell.RegRead("HKCR\" & ExtName & "\")
		If ExtName <> "" Then
			ExePath = WshShell.RegRead("HKCR\" & ExtName & "\shell\edit\command\")
			If ExePath = "" Then
				ExePath = WshShell.RegRead("HKCR\" & ExtName & "\shell\open\command\")
			End If
			If ExePath = "" Then
				ExePath = WshShell.RegRead("HKCR\" & ExtName & "\shell\preview\command\")
			End If
		End If
		On Error GoTo 0
		If ExePath <> "" Then
			i = InStr(ExePath,".")
			If i > 0 Then Argument = Trim$(Mid$(ExePath,InStr(i,ExePath," ")))
			ExePath = Left$(ExePath,Len(ExePath) - Len(Argument))
			TempArray = ReSplit(ExePath,"%")
			If UBound(TempArray) >= 2 Then
				ExePath = Replace$(ExePath,"%" & TempArray(1) & "%",Environ(TempArray(1)),,1)
			End If
			ExePath = RemoveBackslash(ExePath,"""","""",1)
			ExeName = Mid$(ExePath,InStrRev(ExePath,"\") + 1)

			If ExePath <> "" Then
				If InStr(ExePath,"\") = 0 Then
					If Dir$(Environ("SystemRoot") & "\system32\" & ExePath) <> "" Then
						ExePath = Environ("SystemRoot") & "\system32\" & ExePath
					ElseIf Dir$(Environ("SystemRoot") & "\" & ExePath) <> "" Then
						ExePath = Environ("SystemRoot") & "\" & ExePath
					End If
				End If
			End If

			If Argument <> "" Then
				If InStr(Argument,"%1") Then
					File = Replace$(Argument,"%1",File)
				ElseIf InStr(Argument,"%L") Then
					File = Replace$(Argument,"%L",File)
				Else
					File = Argument & " " & """" & File & """"
				End If
			Else
				File = """" & File & """"
			End If
		End If
		If ExePath = "" Then
			MsgBox MsgList(2),vbOkOnly+vbInformation,MsgList(0)
		ElseIf Dir$(ExePath) <> "" Then
			If WshShell.Run("""" & ExePath & """ " & File,1,RunStemp) <> 0 Then
				MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
			Else
				ExeName = Mid$(ExePath,InStrRev(ExePath,"\") + 1)
				For i = 0 To UBound(Tools)
					If InStr(LCase$(Tools(i).FilePath),LCase$(ExeName)) Then
						File = ""
						Exit For
					End If
				Next i
				If File <> "" Then Call AddTools(Tools,ExeName,ExePath,Argument)
				OpenFile = True
			End If
		Else
			MsgBox Replace$(Replace$(Replace$(MsgList(6),"%s!1!",ExeName),"%s!2!",ExePath), _
					"%s!3!",Argument) & MsgList(3),vbOkOnly+vbInformation,MsgList(0)
		End If
  	Case 3
		If CommandInput(ExePath,Argument) = True Then
			TempArray = ReSplit(ExePath,"%")
			If UBound(TempArray) = 2 Then
				ExePath = Replace$(ExePath,"%" & TempArray(1) & "%",Environ(TempArray(1)))
			End If
			ExeName = Mid$(ExePath,InStrRev(ExePath,"\") + 1)

			If Argument <> "" Then
				If InStr(Argument,"%1") Then
					File = Replace$(Argument,"%1",File)
				ElseIf InStr(Argument,"%L") Then
					File = Replace$(Argument,"%L",File)
				Else
					File = Argument & " " & """" & File & """"
				End If
			Else
				File = """" & File & """"
			End If

			If Dir$(ExePath) <> "" Then
				If WshShell.Run("""" & ExePath & """ " & File,1,RunStemp) <> 0 Then
					MsgBox MsgList(5),vbOkOnly+vbInformation,MsgList(0)
				Else
					ExeName = Mid$(ExePath,InStrRev(ExePath,"\") + 1)
					For i = 0 To UBound(Tools)
						If InStr(LCase$(Tools(i).FilePath),LCase$(ExeName)) Then
							File = ""
							Exit For
						End If
					Next i
					If File <> "" Then Call AddTools(Tools,ExeName,ExePath,Argument)
					OpenFile = True
				End If
			Else
				MsgBox ExeName & MsgList(3),vbOkOnly+vbInformation,MsgList(0)
			End If
		End If
	Case Is > 3
		ExeName = Tools(x).sName
		ExePath = Tools(x).FilePath
		Argument = Tools(x).Argument
		If Argument <> "" Then
			If InStr(Argument,"%1") Then
				File = Replace$(Argument,"%1",File)
			ElseIf InStr(Argument,"%L") Then
				File = Replace$(Argument,"%L",File)
			Else
				File = Argument & " " & """" & File & """"
			End If
		Else
			File = """" & File & """"
		End If
		If ExePath <> "" Then
			If Dir$(ExePath) <> "" Then
				If WshShell.Run("""" & ExePath & """ " & File,1,RunStemp) <> 0 Then
					MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
				Else
					OpenFile = True
				End If
			Else
				MsgBox ExeName & MsgList(3),vbOkOnly+vbInformation,MsgList(0)
			End If
		End If
	End Select
	Set WshShell = Nothing
End Function


'༭ıļ
'Mode = True ༭ģʽļɹַ True
'Mode = False 鿴ȷַģʽļɹ [ȷ] ťַ True
Public Function EditFile(ByVal File As String,FileDataList() As String,ByVal Mode As Boolean) As Boolean
	Dim MsgList() As String,FileDataListBak() As String
	If getMsgList(UIDataList,MsgList,"EditFile",1) = False Then Exit Function
	'Dim objStream As Object
	'Set objStream = CreateObject("Adodb.Stream")
	'If objStream Is Nothing Then CodeList = getCodePageList(0,0)
	'If Not objStream Is Nothing Then CodeList = getCodePageList(0,49)
	'Set objStream = Nothing
	FileDataListBak = FileDataList
	Begin Dialog UserDialog 1020,595,IIf(Mode = True,MsgList(0),MsgList(1)) & " - " & File,.EditFileDlgFunc ' %GRID:10,7,1,1
		CheckBox 0,3,14,14,"",.OptionBox
		CheckBox 0,3,14,14,"",.WriteStateBox
		TextBox 0,0,0,21,.SuppValueBox
		Text 10,7,920,14,File,.FilePath,2
		Text 10,7,90,14,MsgList(2),.FindText
		DropListBox 110,3,270,21,MsgList(),.FindTextBox,1
		PushButton 420,3,90,21,MsgList(4),.FindButton
		PushButton 520,3,90,21,MsgList(5),.FilterButton
		PushButton 520,3,90,21,MsgList(6),.CloseFilterButton
		PushButton 380,3,30,21,MsgList(3),.RegExpTipButton
		Text 630,7,90,14,MsgList(7),.CodeText
		DropListBox 730,3,280,21,MsgList(),.CodeNameList
		TextBox 0,28,1020,532,.InTextBox,1
		PushButton 20,567,90,21,MsgList(8),.HelpButton
		PushButton 120,567,90,21,"",.ReadButton
		PushButton 220,567,90,21,MsgList(9),.PreviousButton
		PushButton 320,567,90,21,MsgList(10),.NextButton
		PushButton 790,567,100,21,MsgList(11),.SaveButton
		PushButton 900,567,90,21,MsgList(12),.ExitButton
		OKButton 790,567,100,21,.OKButton
		CancelButton 900,567,90,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	If Mode = False Then dlg.OptionBox = 1
	Select Case Dialog(dlg)
	Case 0
		FileDataList = FileDataListBak
	Case 10
		If dlg.WriteStateBox = 1 Then EditFile = True
	Case Else
		EditFile = True
	End Select
	Erase AllStrList,UseStrList
End Function


'༭Ի
Private Function EditFileDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long
	Dim MsgList() As String,Temp As String,Code As String
	Dim TempArray() As String,TempList() As String

	Select Case Action%
	Case 1
		If getMsgList(UIDataList,MsgList,"EditFileDlgFunc",1) = False Then Exit Function
		DlgText "SuppValueBox",CStr$(SuppValue)
		DlgVisible "SuppValueBox",False
		DlgVisible "FilePath",False
		DlgVisible "OptionBox",False
		DlgVisible "WriteStateBox",False
		If DlgValue("OptionBox") = 0 Then
			DlgVisible "OKButton",False
			DlgVisible "CancelButton",False
		Else
			DlgVisible "SaveButton",False
			DlgVisible "ExitButton",False
		End If
		DlgVisible "CloseFilterButton",False
		GetHistory(TempList,"FindStrings","EditFileDlg")
		DlgListBoxArray "FindTextBox",TempList()
		DlgText "FindTextBox",TempList(0)
		Temp = DlgText("FilePath")
		For i = LBound(FileDataList) To UBound(FileDataList)
			TempList = ReSplit(FileDataList(i),JoinStr,-1)
			If TempList(0) = Temp Then
				Code = TempList(1)
				If Code = "" Then
					Code = CheckCode(Temp)
					TempList(1) = Code
					FileDataList(i) = StrListJoin(TempList,JoinStr)
				End If
				j = i
				Exit For
			End If
		Next i
		ReDim TempList(UBound(CodeList)) As String
		For i = LBound(CodeList) To UBound(CodeList)
			TempList(i) = CodeList(i).sName
			If CodeList(i).CharSet = Code Then n = i
		Next i
		DlgListBoxArray "CodeNameList",TempList()
		DlgValue "CodeNameList",n
		'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
		SetTextBoxLength GetDlgItem(SuppValue,DlgControlId("InTextBox")),FileLen(Temp),False
		DlgText "InTextBox",ReadTextFile(Temp,Code)
		If DlgText("InTextBox") <> "" Then
			DlgText "ReadButton",MsgList(9)
    	Else
    		DlgText "ReadButton",MsgList(8)
    		DlgEnable "FindButton",False
    		DlgEnable "FilterButton",False
    		DlgEnable "CloseFilterButton",False
    		DlgEnable "SaveButton",False
    	End If
    	If UBound(FileDataList) = 0 Then
			DlgEnable "PreviousButton",False
			DlgEnable "NextButton",False
		ElseIf j = 0 Then
			DlgEnable "PreviousButton",False
			DlgEnable "NextButton",True
		ElseIf j = UBound(FileDataList) Then
			DlgEnable "PreviousButton",True
			DlgEnable "NextButton",False
    	End If
    	'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		EditFileDlgFunc = True 'ֹ°ťرնԻ򴰿
		If getMsgList(UIDataList,MsgList,"EditFileDlgFunc",1) = False Then Exit Function
		Select Case DlgItem$
		Case "HelpButton"
			Call Help("EditFileHelp")
			Exit Function
		Case "OKButton", "CancelButton"
			EditFileDlgFunc = False
			Exit Function
		Case "ExitButton"
			If DlgValue("WriteStateBox") = 1 Then
				EditFileDlgFunc = False
				Exit Function
			ElseIf DlgText("InTextBox") = ReadTextFile(DlgText("FilePath"),CodeList(DlgValue("CodeNameList")).CharSet) Then
				EditFileDlgFunc = False
				Exit Function
			End If
			Select Case MsgBox(MsgList(1),vbYesNoCancel+vbInformation,MsgList(0))
			Case vbYes
				Temp = DlgText("FilePath")
				If Dir$(Temp) <> "" Then SetAttr Temp,vbNormal
				If WriteToFile(Temp,DlgText("InTextBox"),CodeList(DlgValue("CodeNameList")).CharSet) = True Then
					MsgBox MsgList(5),vbOkOnly+vbInformation,MsgList(0)
					EditFileDlgFunc = False
					Exit Function
				Else
					MsgBox MsgList(6),vbOkOnly+vbInformation,MsgList(0)
				End If
			Case vbNo
				DlgFocus("CancelButton")  'ý㵽ȡť
				SendMessageLNG GetFocus(), BM_CLICK, 0, 0
				EditFileDlgFunc = False
				Exit Function
			End Select
		Case "SaveButton"
			If DlgText("InTextBox") = "" Then Exit Function
			Temp = DlgText("FilePath")
			If Dir$(Temp) <> "" Then SetAttr Temp,vbNormal
			If WriteToFile(Temp,DlgText("InTextBox"),CodeList(DlgValue("CodeNameList")).CharSet) = True Then
				DlgValue "WriteStateBox",1
				MsgBox MsgList(5),vbOkOnly+vbInformation,MsgList(0)
			Else
				If DlgValue("WriteStateBox") = 0 Then DlgValue "WriteStateBox",0
				MsgBox MsgList(6),vbOkOnly+vbInformation,MsgList(0)
			End If
			DlgVisible "FilterButton",True
			DlgVisible "CloseFilterButton",False
		Case "CodeNameList"
			Code = CodeList(DlgValue("CodeNameList")).CharSet
			If Code = "_autodetect_all" Or Code = "_autodetect" Or Code = "_autodetect_kr" Then
				Code = CheckCode(DlgText("FilePath"))
				For i = LBound(CodeList) To UBound(CodeList)
					If CodeList(i).CharSet = Code Then
 						DlgValue "CodeNameList",i
 						Exit For
 					End If
				Next i
			End If
			Temp = DlgText("FilePath")
			'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
			SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),FileLen(Temp),True
			DlgText "InTextBox",ReadTextFile(Temp,Code)
			If DlgText("InTextBox") <> "" Then
				For i = LBound(FileDataList) To UBound(FileDataList)
					TempList = ReSplit(FileDataList(i),JoinStr)
					If TempList(0) = Temp Then
 						TempList(1) = Code
						FileDataList(i) = StrListJoin(TempList,JoinStr)
 					End If
				Next i
			End If
			Erase AllStrList,UseStrList
			DlgVisible "FilterButton",True
			DlgVisible "CloseFilterButton",False
		Case "ReadButton"
			If DlgText("ReadButton") = MsgList(8) Then
				Code = CodeList(DlgValue("CodeNameList")).CharSet
				Temp = DlgText("FilePath")
				'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
				SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),FileLen(Temp),True
				DlgText "InTextBox",ReadTextFile(Temp,Code)
				If DlgText("InTextBox") <> "" Then DlgText "ReadButton",MsgList(9)
			Else
				DlgText "InTextBox",""
				DlgText "ReadButton",MsgList(8)
				'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
				SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),0,True
			End If
			Erase AllStrList,UseStrList
			DlgVisible "FilterButton",True
			DlgVisible "CloseFilterButton",False
		Case "FindButton"
			If DlgText("FindTextBox") = "" Then
				MsgBox MsgList(11),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			'Ӳ
			GetHistory(TempList,"FindStrings","EditFileDlg")
			If InsertArray(TempList,DlgText("FindTextBox"),0,True) = True Then
				WriteHistory(TempList,"FindStrings","EditFileDlg")
				DlgListBoxArray "FindTextBox",TempList()
				DlgText "FindTextBox",TempList(0)
			End If
			'DlgFocus("InTextBox")  'ý㵽ı2016 ˸ʹùλƵǰ
			n = GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox"))
			SendMessageLNG(n,WM_SETFOCUS,0,0)  'ý㵽ı
			Select Case FindCurPos(n,DlgText("FindTextBox"),False,Temp)
			Case 0
				MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
			Case -1
				MsgBox Replace$(MsgList(12),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
			Case -2
				MsgBox MsgList(13),vbOkOnly+vbInformation,MsgList(0)
			Case -3
				MsgBox MsgList(14),vbOkOnly+vbInformation,MsgList(0)
			End Select
			Exit Function
		Case "FilterButton"
			If DlgText("FindTextBox") = "" Then
				MsgBox MsgList(11),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			'Ӳ
			GetHistory(TempList,"FindStrings","EditFileDlg")
			If InsertArray(TempList,DlgText("FindTextBox"),0,True) = True Then
				WriteHistory(TempList,"FindStrings","EditFileDlg")
				DlgListBoxArray "FindTextBox",TempList()
				DlgText "FindTextBox",TempList(0)
			End If
			'ݵĲҷʽ
			Temp = DlgText("FindTextBox")
			j = GetFindMode(Temp)
			If j = 1 Then Temp = "*" & Temp & "*"
			AllStrList = ReSplit(DlgText("InTextBox"),vbCrLf,-1)
			ReDim UseStrList(UBound(AllStrList)) As String
			n = 0
			For i = 0 To UBound(AllStrList)
				Select Case FilterStr(AllStrList(i),Temp,j)
				Case -1
					MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				Case -2
					MsgBox MsgList(13),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				Case -3
					MsgBox MsgList(14),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				Case Is > 0
					UseStrList(n) = "" & CStr$(i + 1) & MsgList(10) & "" & AllStrList(i)
					n = n + 1
				End Select
			Next i
			If n > 0 Then
				ReDim Preserve UseStrList(n - 1) As String
				DlgText "InTextBox",StrListJoin(UseStrList,vbCrLf)
				DlgVisible "FilterButton",False
				DlgVisible "CloseFilterButton",True
			Else
				Erase AllStrList,UseStrList
				MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
		Case "CloseFilterButton"
			If DlgText("InTextBox") = "" Then
				MsgBox MsgList(3),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			If DlgText("InTextBox") <> StrListJoin(UseStrList,vbCrLf) Then
				If MsgBox(MsgList(2),vbYesNo+vbInformation,MsgList(0)) = vbYes Then
					TempArray = ReSplit(DlgText("InTextBox"),vbCrLf,-1)
					If UBound(UseStrList) = UBound(TempArray) Then
						Temp = "^[0-9]+" & MsgList(10) & ""
						For i = 0 To UBound(TempArray)
							If CheckStrRegExp(TempArray(i),Temp,0,2) = True Then
								TempList = ReSplit(TempArray(i),MsgList(10) & "",2)
								AllStrList(StrToLong(Mid$(TempList(0),2)) - 1) = TempList(1)
							End If
						Next i
					Else
						MsgBox MsgList(3),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					End If
				End If
			End If
			Temp = StrListJoin(AllStrList,vbCrLf)
			'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
			SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),LenB(Temp),True
			DlgText "InTextBox",Temp
			Erase AllStrList,UseStrList
			DlgVisible "FilterButton",True
			DlgVisible "CloseFilterButton",False
		Case "PreviousButton","NextButton"
			Temp = DlgText("FilePath")
			For i = LBound(FileDataList) To UBound(FileDataList)
				TempList = ReSplit(FileDataList(i),JoinStr)
				If TempList(0) = Temp Then
					j = i
					Exit For
				End If
			Next i
			If DlgItem$ = "PreviousButton" Then
				If j <> 0 Then j = j - 1
			Else
				If j < UBound(FileDataList) Then j = j + 1
			End If
			If i <> j Then
				TempList = ReSplit(FileDataList(j),JoinStr)
				DlgText "FilePath",TempList(0)
				DlgText -1,Left$(DlgText(-1),InStr(DlgText(-1),"-") + 1) & TempList(0)
				Code = TempList(1)
				If Code = "" Then Code = CheckCode(TempList(0))
				For i = LBound(CodeList) To UBound(CodeList)
					If CodeList(i).CharSet = Code Then
 						DlgValue "CodeNameList",i
 						Exit For
 					End If
				Next i
				'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
				SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),FileLen(TempList(0)),True
				DlgText "InTextBox",ReadTextFile(TempList(0),Code)
				Erase AllStrList,UseStrList
			End If
			If UBound(FileDataList) = 0 Then
				DlgEnable "PreviousButton",False
				DlgEnable "NextButton",False
			ElseIf j = 0 Then
				DlgEnable "PreviousButton",False
				DlgEnable "NextButton",True
			ElseIf j = UBound(FileDataList) Then
				DlgEnable "PreviousButton",True
				DlgEnable "NextButton",False
			Else
				DlgEnable "PreviousButton",True
				DlgEnable "NextButton",True
			End If
			DlgVisible "FilterButton",True
			DlgVisible "CloseFilterButton",False
		Case "RegExpTipButton"
			If getMsgList(UIDataList,MsgList,"RegExpRuleTip",1) = False Then Exit Function
			i = ShowPopupMenu(MsgList,vbPopupUseRightButton)
			If i < 0 Then Exit Function
			If i = UBound(MsgList) Then
				Call Help("RegExpRuleHelp")
				Exit Function
			End If
			If DlgText("FindTextBox") = "" Then
				DlgText "FindTextBox",Mid$(MsgList(i),InStrRev(MsgList(i),vbTab) + 1)
			Else
				DlgFocus("FindTextBox")  'ý㵽ı
				DlgText "FindTextBox",InsertStr(GetFocus(),DlgText("FindTextBox"), _
						Mid$(MsgList(i),InStrRev(MsgList(i),vbTab) + 1))
			End If
			Exit Function
		End Select

    	If DlgText("InTextBox") <> "" Then
   			DlgText "ReadButton",MsgList(9)
   			DlgEnable "FindButton",True
   			DlgEnable "FilterButton",True
			DlgEnable "CloseFilterButton",True
			If DlgVisible("FilterButton") = True Then
				DlgEnable "SaveButton",True
				DlgEnable "ExitButton",True
				DlgEnable "CancelButton",True
			ElseIf DlgValue("OptionBox") = 0 Then
				DlgEnable "SaveButton",False
				DlgEnable "ExitButton",False
				DlgEnable "CancelButton",False
			End If
		Else
			DlgText "ReadButton",MsgList(8)
			DlgEnable "FindButton",False
			DlgEnable "FilterButton",False
			DlgEnable "CloseFilterButton",False
			DlgEnable "SaveButton",False
			DlgEnable "ExitButton",True
			DlgEnable "CancelButton",True
		End If
	Case 3 ' ıϿı
		If getMsgList(UIDataList,MsgList,"EditFileDlgFunc",1) = False Then Exit Function
		Select Case DlgItem$
		Case "InTextBox"
			If DlgText("InTextBox") <> "" Then
				DlgText "ReadButton",MsgList(9)
				DlgEnable "FindButton",True
				DlgEnable "FilterButton",True
				DlgEnable "CloseFilterButton",True
				If DlgVisible("FilterButton") = True Then
					DlgEnable "SaveButton",True
					DlgEnable "ExitButton",True
					DlgEnable "CancelButton",True
				ElseIf DlgValue("OptionBox") = 0 Then
					DlgEnable "SaveButton",False
					DlgEnable "ExitButton",False
					DlgEnable "CancelButton",False
				End If
				'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
				SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),LenB(DlgText("InTextBox")),True
			Else
				DlgText "ReadButton",MsgList(8)
				DlgEnable "FindButton",False
				DlgEnable "FilterButton",False
				DlgEnable "CloseFilterButton",False
				DlgEnable "SaveButton",False
				DlgEnable "ExitButton",True
				DlgEnable "CancelButton",True
			End If
		End Select
	Case 4 ' 㱻
		Select Case DlgItem$
		Case "InTextBox"
			i = Len(Clipboard)
			If i < Len(DlgText("InTextBox")) * 2 Then Exit Function
			'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
			SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),LenB(DlgText("InTextBox")) + i,True
		End Select
	Case 6 ' ݼ
		If getMsgList(UIDataList,MsgList,"EditFileDlgFunc",1) = False Then Exit Function
		Select Case SuppValue
		Case 1
			Call Help("EditFileHelp")
		Case 2
			If getMsgList(UIDataList,MsgList,"RegExpRuleTip",1) = False Then Exit Function
			i = ShowPopupMenu(MsgList,vbPopupUseRightButton)
			If i < 0 Then Exit Function
			If i = UBound(MsgList) Then
				Call Help("RegExpRuleHelp")
				Exit Function
			End If
			If DlgText("FindTextBox") = "" Then
				DlgText "FindTextBox",Mid$(MsgList(i),InStrRev(MsgList(i),vbTab) + 1)
			Else
				DlgFocus("FindTextBox")  'ý㵽ı
				DlgText "FindTextBox",InsertStr(GetFocus(),DlgText("FindTextBox"), _
						Mid$(MsgList(i),InStrRev(MsgList(i),vbTab) + 1))
			End If
		Case 3
			If DlgText("FindTextBox") = "" Then
				MsgBox MsgList(11),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			'DlgFocus("InTextBox")  'ý㵽ı2016 ˸ʹùλƵǰ
			n = GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox"))
			SendMessageLNG(n,WM_SETFOCUS,0,0)  'ý㵽ı
			Select Case FindCurPos(n,DlgText("FindTextBox"),False,Temp)
			Case 0
				MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
			Case -1
				MsgBox Replace$(MsgList(12),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
			Case -2
				MsgBox MsgList(13),vbOkOnly+vbInformation,MsgList(0)
			Case -3
				MsgBox MsgList(14),vbOkOnly+vbInformation,MsgList(0)
			End Select
		Case 4
			If DlgVisible("FilterButton") = True Then
				If DlgText("FindTextBox") = "" Then
					MsgBox MsgList(11),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				End If
				'ݵĲҷʽ
				Temp = DlgText("FindTextBox")
				j = GetFindMode(Temp)
				If j = 1 Then Temp = "*" & Temp & "*"
				AllStrList = ReSplit(DlgText("InTextBox"),vbCrLf,-1)
				ReDim UseStrList(UBound(AllStrList)) As String
				n = 0
				For i = 0 To UBound(AllStrList)
					Select Case FilterStr(AllStrList(i),Temp,j)
					Case -1
						MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					Case -2
						MsgBox MsgList(13),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					Case -3
						MsgBox MsgList(14),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					Case Is > 0
						UseStrList(n) = "" & CStr$(i + 1) & MsgList(10) & "" & AllStrList(i)
						n = n + 1
					End Select
				Next i
				If n > 0 Then
					ReDim Preserve UseStrList(n - 1) As String
					DlgText "InTextBox",StrListJoin(UseStrList,vbCrLf)
					DlgVisible "FilterButton",False
					DlgVisible "CloseFilterButton",True
				Else
					Erase AllStrList,UseStrList
					MsgBox MsgList(4),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				End If
			Else
				If DlgText("InTextBox") = "" Then
					MsgBox MsgList(3),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				End If
				If DlgText("InTextBox") <> StrListJoin(UseStrList,vbCrLf) Then
					If MsgBox(MsgList(2),vbYesNo+vbInformation,MsgList(0)) = vbYes Then
						TempArray = ReSplit(DlgText("InTextBox"),vbCrLf,-1)
						If UBound(UseStrList) = UBound(TempArray) Then
							Temp = "^[0-9]+" & MsgList(10) & ""
							For i = 0 To UBound(TempArray)
								If CheckStrRegExp(TempArray(i),Temp,0,2) = True Then
									TempList = ReSplit(TempArray(i),MsgList(10) & "",2)
									AllStrList(StrToLong(Mid$(TempList(0),2)) - 1) = TempList(1)
								End If
							Next i
						Else
							MsgBox MsgList(3),vbOkOnly+vbInformation,MsgList(0)
							Exit Function
						End If
					End If
				End If
				Temp = StrListJoin(AllStrList,vbCrLf)
				'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
				SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),LenB(Temp),True
				DlgText "InTextBox",Temp
				Erase AllStrList,UseStrList
				DlgVisible "FilterButton",True
				DlgVisible "CloseFilterButton",False
			End If
			If DlgVisible("FilterButton") = True Then
				DlgEnable "SaveButton",True
				DlgEnable "ExitButton",True
				DlgEnable "CancelButton",True
			ElseIf DlgValue("OptionBox") = 0 Then
				DlgEnable "SaveButton",False
				DlgEnable "ExitButton",False
				DlgEnable "CancelButton",False
			End If
		Case 5, 6
			Temp = DlgText("FilePath")
			For i = LBound(FileDataList) To UBound(FileDataList)
				TempList = ReSplit(FileDataList(i),JoinStr)
				If TempList(0) = Temp Then
					j = i
					Exit For
				End If
			Next i
			If SuppValue = 5 Then
				If j <> 0 Then j = j - 1
			Else
				If j < UBound(FileDataList) Then j = j + 1
			End If
			If i <> j Then
				TempList = ReSplit(FileDataList(j),JoinStr)
				DlgText "FilePath",TempList(0)
				DlgText -1,Left$(DlgText(-1),InStr(DlgText(-1),"-") + 1) & TempList(0)
				Code = TempList(1)
				If Code = "" Then Code = CheckCode(TempList(0))
				For i = LBound(CodeList) To UBound(CodeList)
					If CodeList(i).CharSet = Code Then
 						DlgValue "CodeNameList",i
 						Exit For
 					End If
				Next i
				'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
				SetTextBoxLength GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("InTextBox")),FileLen(TempList(0)),True
				DlgText "InTextBox",ReadTextFile(TempList(0),Code)
				Erase AllStrList,UseStrList
			End If
			If UBound(FileDataList) = 0 Then
				DlgEnable "PreviousButton",False
				DlgEnable "NextButton",False
			ElseIf j = 0 Then
				DlgEnable "PreviousButton",False
				DlgEnable "NextButton",True
			ElseIf j = UBound(FileDataList) Then
				DlgEnable "PreviousButton",True
				DlgEnable "NextButton",False
			Else
				DlgEnable "PreviousButton",True
				DlgEnable "NextButton",True
			End If
			DlgVisible "FilterButton",True
			DlgVisible "CloseFilterButton",False
		End Select
	End Select
End Function


'ȥִǰָ PreStr  AppStr
'fType = -1 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 0 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 1 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
'fType > 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
Public Function RemoveBackslash(ByVal Path As String,ByVal PreStr As String,ByVal AppStr As String,ByVal fType As Long) As String
	Dim i As Long,a As Long,p As Long,Stemp As Boolean
	RemoveBackslash = Path
	If Path = "" Then Exit Function
	a = Len(AppStr)
	p = Len(PreStr)
	If fType > -1 Then RemoveBackslash = Trim(RemoveBackslash)
	Do
		Stemp = False
		If p <> 0 Then
			If Left$(RemoveBackslash,p) = PreStr Then
				RemoveBackslash = Mid$(RemoveBackslash,p + 1)
				Stemp = True
			End If
		End If
		If a <> 0 Then
			If Right$(RemoveBackslash,a) = AppStr Then
				RemoveBackslash = Left$(RemoveBackslash,Len(RemoveBackslash) - a)
				Stemp = True
			End If
		End If
		If fType = 1 Or fType > 2 Then RemoveBackslash = Trim$(RemoveBackslash)
		If Stemp = True Then
			If fType < 2 Then i = 0 Else i = 1
		Else
			i = 1
		End If
	Loop Until i = 1
End Function


'ӹ
Private Function AddTools(ToolsData() As TOOLS_PROPERTIE,ByVal CmdName As String,ByVal CmdPath As String,ByVal Argument As String) As Boolean
	Dim i As Long,FindName As String
	If CmdName = "" Or CmdPath = "" Then Exit Function
	FindName = LCase$(CmdName)
	For i = LBound(ToolsData) To UBound(ToolsData)
		If LCase$(ToolsData(i).sName) = FindName Then
			Exit Function
		End If
	Next i
	ReDim Preserve ToolsData(i) As TOOLS_PROPERTIE
	ToolsData(i).sName = CmdName
	ToolsData(i).FilePath = CmdPath
	ToolsData(i).Argument = Argument
	AddTools = True
End Function


'༭
Private Function CommandInput(CmdPath As String,Argument As String) As Boolean
	Dim MsgList() As String,TempList() As String
	If getMsgList(UIDataList,MsgList,"CommandInput",1) = False Then Exit Function
	ToolsBak = Tools
	Begin Dialog UserDialog 540,294,MsgList(0),.CommandInputDlgFunc ' %GRID:10,7,1,1
		Text 10,7,520,140,MsgList(1),.TipText
		Text 10,154,490,14,MsgList(2),.CmdPathText
		TextBox 10,175,490,21,.CmdPath
		PushButton 500,175,30,21,MsgList(3),.BrowseButton
		Text 10,210,490,14,MsgList(4),.ArgumentText
		TextBox 10,231,490,21,.Argument
		PushButton 500,231,30,21,MsgList(5),.FileArgButton

		Text 10,7,410,14,MsgList(6),.EditerListText
		ListBox 10,28,410,119,TempList(),.EditerList
		ListBox 10,28,410,119,TempList(),.EditerListBak
		PushButton 430,28,100,21,MsgList(7),.AddButton
		PushButton 430,49,100,21,MsgList(8),.ChangeButton
		PushButton 430,70,100,21,MsgList(9),.DelButton
		PushButton 430,98,100,21,MsgList(10),.UpButton
		PushButton 430,119,100,21,MsgList(11),.DownButton

		PushButton 20,266,100,21,MsgList(12),.ClearButton
		PushButton 130,266,120,21,MsgList(13),.EditerListButton
		PushButton 130,266,100,21,MsgList(14),.ResetButton
		PushButton 310,266,100,21,MsgList(15),.SaveButton
		OKButton 310,266,100,21,.OKButton
		CancelButton 420,266,100,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.CmdPath = CmdPath
	dlg.Argument = Argument
	If Dialog(dlg) = 0 Then Exit Function
	If dlg.CmdPath <> "" Then
		CmdPath = dlg.CmdPath
		Argument = dlg.Argument
		CommandInput = True
	End If
End Function


'ȡ༭Ի
Private Function CommandInputDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,x As Long,y As Long,Path As String
	Dim Temp As String,TempList() As String,TempArray() As String,MsgList() As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		DlgVisible "EditerListText",False
		DlgVisible "EditerList",False
		DlgVisible "EditerListBak",False
		DlgVisible "AddButton",False
		DlgVisible "ChangeButton",False
		DlgVisible "DelButton",False
		DlgVisible "UpButton",False
		DlgVisible "DownButton",False
		DlgVisible "ResetButton",False
		DlgVisible "SaveButton",False
		If UBound(Tools) < 4 Then
			DlgEnable "UpButton",False
			DlgEnable "DownButton",False
		End If
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			x = CreateFont(0,LFList(0))
			If x = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,x,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		CommandInputDlgFunc = True ' ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			If DlgVisible("DelButton") = False Then
				CommandInputDlgFunc = False
				Exit Function
			End If
			Tools = ToolsBak
			DlgVisible "TipText",True
			DlgVisible "OKButton",True
			DlgVisible "EditerListText",False
			DlgVisible "EditerList",False
			DlgVisible "AddButton",False
			DlgVisible "ChangeButton",False
			DlgVisible "DelButton",False
			DlgVisible "UpButton",False
			DlgVisible "DownButton",False
			DlgVisible "ResetButton",False
			DlgVisible "SaveButton",False
			DlgVisible "EditerListButton",True
			DlgEnable "ClearButton",True
			Exit Function
		Case "OKButton"
			If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
			Temp = Trim$(DlgText("CmdPath"))
			If Temp = "" Then
				MsgBox MsgList(6),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			Else
				TempList = ReSplit(Temp,"%")
				If UBound(TempList) = 2 Then
					Temp = Replace$(Temp,"%" & TempList(1) & "%",Environ(TempList(1)))
				End If
				If Dir$(Temp) = "" Then
					MsgBox MsgList(7),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				End If
			End If
			CommandInputDlgFunc = False
			Exit Function
		Case "SaveButton"
			If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
			ReDim TempList(UBound(Tools)) As String,TempArray(UBound(Tools)) As String
			For i = 4 To UBound(Tools)
				Temp = Trim$(Tools(i).FilePath)
				If Temp = "" Then
					TempList(x) = Tools(i).sName
					x = x + 1
				ElseIf Dir$(Temp) = "" Then
					TempArray(y) = Tools(i).FilePath
					y = y + 1
				End If
			Next i
			If x > 0 Then
				ReDim Preserve TempList(x - 1) As String
				MsgBox Replace$(MsgList(8),"%s",StrListJoin(TempList,vbCrLf)),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			ElseIf y > 0 Then
				ReDim Preserve TempArray(y - 1) As String
				MsgBox Replace$(MsgList(9),"%s",StrListJoin(TempArray,vbCrLf)),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			If WriteCheckSet(cWriteLoc,"Tools") = False Then
				MsgBox Replace(MsgList(12),"%s",cWriteLoc),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			MsgBox MsgList(13),vbOkOnly+vbInformation,MsgList(10)
			ToolsBak = Tools
			DlgVisible "TipText",True
			DlgVisible "OKButton",True
			DlgVisible "EditerListText",False
			DlgVisible "EditerList",False
			DlgVisible "AddButton",False
			DlgVisible "ChangeButton",False
			DlgVisible "DelButton",False
			DlgVisible "UpButton",False
			DlgVisible "DownButton",False
			DlgVisible "ResetButton",False
			DlgVisible "SaveButton",False
			DlgVisible "EditerListButton",True
			DlgEnable "ClearButton",True
			Exit Function
		Case "BrowseButton"
			If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
			If PSL.SelectFile(Path,True,MsgList(2),MsgList(1)) = False Then
				Exit Function
			End If
			DlgText "CmdPath",Path
			If DlgVisible("SaveButton") = True Then
				Temp = DlgText("EditerList")
				For i = 4 To UBound(Tools)
					If Tools(i).sName = Temp Then
						Tools(i).FilePath = Path
						Exit For
					End If
				Next i
			End If
			Exit Function
		Case "FileArgButton"
			If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
			ReDim TempList(0) As String
			TempList(0) = MsgList(3)
			If ShowPopupMenu(TempList,vbPopupUseRightButton) < 0 Then Exit Function
			DlgText "Argument",DlgText("Argument") & " " & """%1"""
			If DlgVisible("SaveButton") = True Then
				Temp = DlgText("EditerList")
				For i = 4 To UBound(Tools)
					If Tools(i).sName = Temp Then
						Tools(i).Argument = DlgText("Argument")
						Exit For
					End If
				Next i
			End If
			Exit Function
		Case "EditerListButton"
			Temp = Trim$(DlgText("CmdPath"))
			x = UBound(Tools) - 4
			If x > -1 Then
				ReDim TempList(x) As String
				For i = 0 To x
					TempList(i) = Tools(i + 4).sName
					If Tools(i + 4).FilePath = Temp Then y = i
				Next i
				DlgText "CmdPath",Tools(y + 4).FilePath
				DlgText "Argument",Tools(y + 4).Argument
			Else
				ReDim TempList(0) As String
				DlgText "CmdPath",""
				DlgText "Argument",""
			End If
			DlgListBoxArray "EditerList",TempList()
			DlgListBoxArray "EditerListBak",TempList()
			DlgValue "EditerList",y
			DlgValue "EditerListBak",y
			DlgVisible "TipText",False
			DlgVisible "OKButton",False
			DlgVisible "EditerListButton",False
			DlgVisible "EditerListText",True
			DlgVisible "EditerList",True
			DlgVisible "AddButton",True
			DlgVisible "ChangeButton",True
			DlgVisible "DelButton",True
			DlgVisible "UpButton",True
			DlgVisible "DownButton",True
			DlgVisible "ResetButton",True
			DlgVisible "SaveButton",True
		Case "AddButton"
			If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
			If PSL.SelectFile(Path,True,MsgList(2),MsgList(1)) = False Then
				Exit Function
			End If
			For i = 0 To UBound(Tools)
				If LCase$(Tools(i).FilePath) = LCase$(Path) Then
					MsgBox MsgList(11),vbOkOnly+vbInformation,MsgList(10)
					Exit Function
				End If
			Next i
			Temp = Mid$(Path,InStrRev(Path,"\") + 1)
			For i = 0 To UBound(Tools)
				If LCase$(Tools(i).sName) = LCase$(Temp) Then
					Temp = AddSet(GetToolNameList(Tools,0),Temp)
					If Temp = "" Then Exit Function
				End If
			Next i
			If AddTools(Tools,Temp,Path,"") = False Then Exit Function
			x = UBound(Tools) - 4
			TempList = GetToolNameList(Tools,4)
			DlgText "CmdPath",Path
			DlgText "Argument",""
			DlgListBoxArray "EditerList",TempList()
			DlgListBoxArray "EditerListBak",TempList()
			DlgValue "EditerList",x
			DlgValue "EditerListBak",x
		Case "ChangeButton"
			If DlgValue("EditerList") < 0 Then Exit Function
			TempList = GetToolNameList(Tools,4)
			x = DlgValue("EditerList")
			Temp = EditSet(TempList,x)
			If Temp = "" Then Exit Function
			TempList(x) = Temp
			Tools(x + 4).sName = Temp
			DlgListBoxArray "EditerList",TempList()
			DlgListBoxArray "EditerListBak",TempList()
			DlgValue "EditerList",x
			DlgValue "EditerListBak",x
			Exit Function
		Case "DelButton"
			If DlgValue("EditerList") < 0 Then Exit Function
			If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
			Temp = DlgText("EditerList")
			If MsgBox(Replace(MsgList(5),"%s",Temp),vbYesNo+vbInformation,MsgList(4)) = vbNo Then
				Exit Function
			End If
			y = DlgValue("EditerList") + 4
			Call DelToolsArray(Tools,y)
			x = UBound(Tools)
			If x > 3 Then
				If y = x + 1 Then y = x
				TempList = GetToolNameList(Tools,4)
				DlgListBoxArray "EditerList",TempList()
				DlgListBoxArray "EditerListBak",TempList()
				DlgValue "EditerList",y - 4
				DlgValue "EditerListBak",y - 4
				DlgText "CmdPath",Tools(y).FilePath
				DlgText "Argument",Tools(y).Argument
			Else
				ReDim TempList(0) As String
				DlgListBoxArray "EditerList",TempList()
				DlgListBoxArray "EditerListBak",TempList()
				DlgValue "EditerList",0
				DlgValue "EditerListBak",0
				DlgText "CmdPath",""
				DlgText "Argument",""
			End If
		Case "UpButton"
			i = DlgValue("EditerList")
			If i = 0 Then Exit Function
			ReDim TempTools(0) As TOOLS_PROPERTIE
			TempTools(0) = Tools(i + 4)
			Tools(i + 4) = Tools(i + 3)
			Tools(i + 3) = TempTools(0)
			TempList = GetToolNameList(Tools,4)
			DlgListBoxArray "EditerList",TempList()
			DlgValue "EditerList",i - 1
		Case "DownButton"
			i = DlgValue("EditerList")
			If i = UBound(Tools) Then Exit Function
			ReDim TempTools(0) As TOOLS_PROPERTIE
			TempTools(0) = Tools(i + 4)
			Tools(i + 4) = Tools(i + 5)
			Tools(i + 5) = TempTools(0)
			TempList = GetToolNameList(Tools,4)
			DlgListBoxArray "EditerList",TempList()
			DlgValue "EditerList",i + 1
		Case "ClearButton"
			If DlgVisible("EditerList") = False Then
				DlgText "CmdPath",""
 				DlgText "Argument",""
 				Exit Function
 			Else
 				If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
 				If MsgBox(MsgList(14),vbYesNo+vbInformation,MsgList(4)) = vbNo Then Exit Function
 				ReDim Preserve Tools(3) As TOOLS_PROPERTIE
 				ReDim TempList(0) As String
				DlgListBoxArray "EditerList",TempList()
				DlgListBoxArray "EditerListBak",TempList()
				DlgValue "EditerList",0
				DlgValue "EditerListBak",0
				DlgText "CmdPath",""
				DlgText "Argument",""
 			End If
 		Case "ResetButton"
			Tools = ToolsBak
			Temp = DlgText("EditerList")
			x = UBound(Tools) - 4
			If x > -1 Then
				ReDim TempList(x) As String
				For i = 0 To x
					TempList(i) = Tools(i + 4).sName
					If Tools(i + 4).FilePath = Temp Then y = i
				Next i
				DlgText "CmdPath",Tools(y + 4).FilePath
				DlgText "Argument",Tools(y + 4).Argument
			Else
				ReDim TempList(0) As String
				DlgText "CmdPath",""
				DlgText "Argument",""
			End If
			DlgListBoxArray "EditerList",TempList()
			DlgListBoxArray "EditerListBak",TempList()
			DlgValue "EditerList",y
			DlgValue "EditerListBak",y
		Case "EditerList"
			x = DlgValue("EditerList")
			If x < 0 Then Exit Function
			DlgValue "EditerList",x
			DlgValue "EditerListBak",x
			DlgText "CmdPath",Tools(x + 4).FilePath
			DlgText "Argument",Tools(x + 4).Argument
		End Select
		If DlgVisible("EditerList") = True Then
			If DlgValue("EditerList") < 0 Then
				DlgEnable "ChangeButton",False
				DlgEnable "DelButton",False
				DlgEnable "UpButton",False
				DlgEnable "DownButton",False
				DlgEnable "ResetButton",False
				DlgEnable "ClearButton",False
			Else
				DlgEnable "ChangeButton",True
				DlgEnable "DelButton",True
				DlgEnable "ResetButton",True
				DlgEnable "ClearButton",True
				If DlgListBoxArray("EditerList") < 2 Then
					DlgEnable "UpButton",False
					DlgEnable "DownButton",False
				Else
					Select Case DlgValue("EditerList")
					Case 0
						DlgEnable "UpButton",False
						DlgEnable "DownButton",True
					Case DlgListBoxArray("EditerList") - 1
						DlgEnable "UpButton",True
						DlgEnable "DownButton",False
					Case Else
						DlgEnable "UpButton",True
						DlgEnable "DownButton",True
					End Select
				End If
			End If
		End If
	Case 3 ' ıϿı
		If DlgItem$ = "CmdPath" Or DlgItem$ = "Argument" Then
			If DlgItem$ = "CmdPath" Then
				DlgText "CmdPath",Trim$(DlgText("CmdPath"))
				Temp = DlgText("CmdPath")
				If Temp = "" Then Exit Function
				TempList = ReSplit(Temp,"%")
				If UBound(TempList) = 2 Then
					Temp = Replace$(Temp,"%" & TempList(1) & "%",Environ(TempList(1)))
				End If
				If Dir$(Temp) = "" Then
					If getMsgList(UIDataList,MsgList,"CommandInputDlgFunc",1) = False Then Exit Function
					MsgBox MsgList(7),vbOkOnly+vbInformation,MsgList(0)
				End If
			Else
				DlgText "Argument",Trim$(DlgText("Argument"))
			End If
			If DlgVisible("DelButton") = True Then
				Temp = DlgText("EditerListBak")
				If Temp = "" Then Exit Function
				For i = 4 To UBound(Tools)
					If Tools(i).sName = Temp Then
						If DlgItem$ = "CmdPath" Then
							Tools(i).FilePath = DlgText("CmdPath")
						Else
							Tools(i).Argument = DlgText("Argument")
						End If
						Exit For
					End If
				Next i
			End If
		End If
	End Select
End Function


'ںͰ
Public Sub Help(ByVal HelpTip As String)
	Dim i As Long,MsgList() As String,HelpList(15) As String
	Dim Title As String,HelpTipTitle As String,HelpMsg As String

	For i = 0 To UBound(UIDataList)
		With UIDataList(i)
			Select Case .Title
			Case "Windows"
				MsgList = .Value
			Case "System"
				HelpList(0) = Replace$(Replace$(Join$(.Value,vbCrLf),"%s",Version),"%d",Build) & vbCrLf & vbCrLf
			Case "Description"
				HelpList(1) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "Precondition"
				HelpList(2) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "Setup"
				HelpList(3) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "CopyRight"
				HelpList(4) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "Thank"
				HelpList(5) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "Contact"
				HelpList(6) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "Logs"
				HelpList(7) = Join$(.Value,vbCrLf)
			Case "MainHelp"
				HelpList(8) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "ProjectHelp"
				HelpList(9) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "CheckSetHelp"
				HelpList(10) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "CheckTestHelp"
				HelpList(11) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "UpdateSetHelp"
				HelpList(12) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "UILangSetHelp"
				HelpList(13) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "EditFileHelp"
				HelpList(14) = Join$(.Value,vbCrLf) & vbCrLf & vbCrLf
			Case "RegExpRuleHelp"
				HelpList(15) = Join$(.Value,vbCrLf)
			End Select
		End With
	Next i

	Select Case HelpTip
	Case "About"
		HelpTipTitle =  MsgList(2)
		HelpMsg = HelpList(0) & HelpList(1) & HelpList(2) & HelpList(3) & HelpList(4) & _
					HelpList(5) & HelpList(6) & HelpList(7)
	Case "MainHelp"
		HelpTipTitle = MsgList(3)
		HelpMsg = HelpList(8) & HelpList(7)
	Case "ProjectHelp"
		HelpTipTitle = MsgList(4)
		HelpMsg = HelpList(9) & HelpList(7)
	Case "CheckSetHelp"
		HelpTipTitle = MsgList(5)
		HelpMsg = HelpList(10) & HelpList(7)
	Case "CheckTestHelp"
		HelpTipTitle = MsgList(6)
		HelpMsg = HelpList(11) & HelpList(7)
	Case "UpdateSetHelp"
		HelpTipTitle = MsgList(7)
		HelpMsg = HelpList(12) & HelpList(7)
	Case "UILangSetHelp"
		HelpTipTitle = MsgList(8)
		HelpMsg = HelpList(13) & HelpList(7)
	Case "EditFileHelp"
		HelpTipTitle = MsgList(9)
		HelpMsg = Replace$(HelpList(14) & HelpList(7),"{RegExpRule}",HelpList(15))
	Case "RegExpRuleHelp"
		HelpTipTitle = MsgList(10)
		HelpMsg = HelpList(15) & vbCrLf & vbCrLf & HelpList(7)
	End Select

	Begin Dialog UserDialog 830,553,MsgList(0) & " - " & MsgList(1),.CommonDlgFunc ' %GRID:10,7,1,1
		Text 0,7,830,14,HelpTipTitle,.Text,2
		TextBox 0,28,830,490,.TextBox,1
		OKButton 370,525,100,21
	End Dialog
	Dim dlg As UserDialog
	dlg.TextBox = HelpMsg
	Dialog dlg
End Sub


' ļ
' ----------------------------------------------------
' ANSI      ޸ʽ
' 2B2F 76[38|39|2B|2F] UTF-7
' EFBB BF   UTF-8
' FFFE      UTF-16LE/UCS-2, Little Endian with BOM
' FEFF      UTF-16BE/UCS-2, Big Endian with BOM
' XX00 XX00 UTF-16LE/UCS-2, Little Endian without BOM
' 00XX 00XX UTF-16BE/UCS-2, Big Endian without BOM
' FFFE 0000 UTF-32LE/UCS-4, Little Endian with BOM
' 0000 FEFF UTF-32BE/UCS-4, Big Endian with BOM
' XX00 0000 UTF-32LE/UCS-4, Little Endian without BOM
' 0000 00XX UTF-32BE/UCS-4, Big Endian without BOM
' е XX ʾʮַ
Private Function CheckCode(ByVal FilePath As String) As String
	Dim i As Long,j As Long,objStream As Object,Bytes() As Byte,Temp As String

	If Dir$(FilePath) = "" Then Exit Function
	i = FileLen(FilePath)
	If i = 0 Then
		CheckCode = "ANSI"
		Exit Function
	End If
	On Error Resume Next
	Set objStream = CreateObject("Adodb.Stream")
	On Error GoTo 0
	If objStream Is Nothing Then
		CheckCode = "ANSI"
		Exit Function
	End If
	If i > 1 Then
		With objStream
			.Type = 1
			.Mode = 3
			.Open
			.Position = 0
			.LoadFromFile FilePath
			Bytes = .read(IIf(i > 3,4,i))
			.Close
		End With
		If i > 2 Then
			If Bytes(0) = 239 And Bytes(1) = 187 And Bytes(2) = 191 Then
				CheckCode = "utf-8EFBB"
			ElseIf Bytes(0) = &HFF And Bytes(1) = &HFE Then
				CheckCode = "unicodeFFFE"
			ElseIf Bytes(0) = &HFE And Bytes(1) = &HFF Then
				CheckCode = "unicodeFEFF"
			End If
		Else
			If Bytes(0) = &HFF And Bytes(1) = &HFE Then
				CheckCode = "unicodeFFFE"
			ElseIf Bytes(0) = &HFE And Bytes(1) = &HFF Then
				CheckCode = "unicodeFEFF"
			End If
		End If
		If i > 3 Then
			If Bytes(0) <> &H00 And Bytes(1) = &H00 And Bytes(2) <> &H00 And Bytes(3) = &H00 Then
				CheckCode = "utf-16"
			ElseIf Bytes(0) = &H00 And Bytes(1) <> &H00 And Bytes(2) = &H00 And Bytes(3) <> &H00 Then
				CheckCode = "utf-16BE"
			ElseIf Bytes(0) = &HFF And Bytes(1) = &HFE And Bytes(2) = &H00 And Bytes(3) = &H00 Then
				CheckCode = "unicode-32FFFE"
			ElseIf Bytes(0) = &H00 And Bytes(1) = &H00 And Bytes(2) = &HFE And Bytes(3) = &HFF Then
				CheckCode = "unicode-32FEFF"
			ElseIf Bytes(0) = &H00 And Bytes(1) = &H00 And Bytes(2) = &H00 And Bytes(3) <> &H00 Then
				CheckCode = "utf-32"
			ElseIf Bytes(0) <> &H00 And Bytes(1) = &H00 And Bytes(2) = &H00 And Bytes(3) = &H00 Then
				CheckCode = "utf-32BE"
			End If
		End If
		If CheckCode <> "" Then
			Set objStream = Nothing
			Exit Function
		End If
	End If
	On Error GoTo ExitFunction
	With objStream
		.Type = 2
		.Mode = 3
		.Open
		.CharSet = "_autodetect_all"
		.Position = 0
		.LoadFromFile FilePath
		Temp = .ReadText(IIf(i > 10240,10240,i))
		'On Error GoTo NextNum
		For j = 38 To 2 Step -1
			If j <> 9 And j <> 13 Then
				.Position = 0
				.CharSet = CodeList(j).CharSet
				If Temp = .ReadText(IIf(i > 10240,10240,i)) Then
					CheckCode = .CharSet
					.Close
					Set objStream = Nothing
					Exit Function
				End If
			End If
			'NextNum:
		Next j
		'On Error GoTo NextPos
		For j = 41 To 39 Step -1
			If j <> 40 Then
				.Position = 0
				.CharSet = CodeList(j).CharSet
				If Temp = .ReadText(IIf(i > 10240,10240,i)) Then
					CheckCode = .CharSet
					.Close
					Set objStream = Nothing
					Exit Function
				End If
			End If
			'NextPos:
		Next j
		.Close
	End With
	ExitFunction:
	If CheckCode = "" Then CheckCode = "ANSI"
	Set objStream = Nothing
End Function


' ȡıļ
Private Function ReadTextFile(ByVal FilePath As String,CharSet As String) As String
	Dim i As Long,objStream As Object,Code As String,FN As Variant
	If Dir$(FilePath) = "" Then Exit Function
	i = FileLen(FilePath)
	If i = 0 Then Exit Function
	On Error Resume Next
	Set objStream = CreateObject("Adodb.Stream")
	On Error GoTo ErrorMsg
	Code = CharSet
	If Not objStream Is Nothing Then
		If Code = "" Then Code = CheckCode(FilePath)
		If Code = "" Then Code = "_autodetect_all"
		If Code <> "ANSI" Then
			With objStream
				.Type = 2
				.Mode = 3
				.CharSet = IIf(Code = "utf-8EFBB","utf-8",Code)
				.Open
				.LoadFromFile FilePath
				ReadTextFile = .ReadText
				.Close
			End With
		End If
	End If
	If objStream Is Nothing Or Code = "ANSI" Then
		ReDim Bytes(i - 1) As Byte
		FN = FreeFile
		Open FilePath For Binary Access Read Lock Write As #FN
		Get #FN,,Bytes
		Close #FN
		ReadTextFile = StrConv$(Bytes,vbUnicode)
	End If
	If CharSet = "" Then CharSet = Code
	Set objStream = Nothing
	Exit Function

	ErrorMsg:
	ReadTextFile = ""
	If objStream Is Nothing Or Code = "ANSI" Then Close #FN
	Set objStream = Nothing
	Err.Source = "NotReadFile"
	Err.Description = Err.Description & JoinStr & FilePath
	Call sysErrorMassage(Err,1)
End Function


' дıļ
Private Function WriteToFile(ByVal FilePath As String,ByVal textStr As String,CharSet As String) As Boolean
	Dim objStream As Object,Code As String,Bytes() As Byte,FN As Variant
	If FilePath = "" Then Exit Function
	On Error Resume Next
	Set objStream = CreateObject("Adodb.Stream")
	On Error GoTo ErrorMsg
	Code = CharSet
	If Not objStream Is Nothing Then
		If Code = "" Then Code = CheckCode(FilePath)
		If LCase$(Code) = "_autodetect_all" Then Code = "ANSI"
		If Code <> "ANSI" Then
			With objStream
				.Type = 2
				.Mode = 3
				.CharSet = IIf(Code = "utf-8EFBB","utf-8",Code)
				.Open
				.WriteText textStr
				'ȥ BOM ʽ BOM
				If Code = "utf-16LE" Or Code = "utf-8" Then
					.Position = 0
					.Type = 1
					.Position = IIf(Code = "utf-16LE",2,3)
					Bytes = .Read(.Size - IIf(Code = "utf-16LE",2,3))
					.Position = 0
					.SetEOS
					.Write Bytes
				End If
				.SaveToFile FilePath,2
				.Close
			End With
			WriteToFile = True
		End If
	End If
	If objStream Is Nothing Or Code = "ANSI" Then
		Bytes = StrConv(textStr,vbFromUnicode)
		FN = FreeFile
		Open FilePath For Binary Access Write Lock Write As #FN
		Put #FN,,Bytes
		Close #FN
		WriteToFile = True
	End If
	If CharSet = "" Then CharSet = Code
	Set objStream = Nothing
	Exit Function

	ErrorMsg:
	If objStream Is Nothing Or Code = "ANSI" Then Close #FN
	Set objStream = Nothing
	Err.Source = "NotWriteFile"
	Err.Description = Err.Description & JoinStr & FilePath
	Call sysErrorMassage(Err,1)
End Function


' Adodb.Stream ʹõĴҳ
Public Function getCodePageList(ByVal MinNum As Long,ByVal MaxNum As Long) As CODEPAGE_DATA()
	Dim i As Long,MsgList() As String,Code As String
	Dim CharSetList() As String,CodePage() As CODEPAGE_DATA

	If getMsgList(UIDataList,MsgList,"CodePageList",0) = False Then Exit Function
	Code = "ANSI|_autodetect_all|gb2312|hz-gb-2312|gb18030|big5|euc-jp|iso-2022-jp|shift_jis|" & _
			"_autodetect|ks_c_5601-1987|euc-kr|iso-2022-kr|_autodetect_kr|windows-874|" & _
			"windows-1258|iso-8859-4|windows-1257|ASMO-708|DOS-720|iso-8859-6|windows-1256|" & _
			"DOS-862|iso-8859-8-i|iso-8859-8|windows-1255|iso-8859-9|iso-8859-7|windows-1253|" & _
			"iso-8859-1|cp866|iso-8859-5|koi8-r|koi8-ru|windows-1251|ibm852|iso-8859-2|" & _
			"windows-1250|iso-8859-3|utf-7|utf-8EFBB|utf-8|unicodeFFFE|unicodeFEFF|utf-16|" & _
			"utf-16BE|unicode-32FFFE|unicode-32FEFF|utf-32|utf-32BE"
	CharSetList = ReSplit(Code,"|")

	i = UBound(MsgList)
	If MaxNum > i Then MaxNum = i
	ReDim CodePage(MaxNum - MinNum) As CODEPAGE_DATA
	For i = MinNum To MaxNum
		CodePage(i - MinNum).sName = MsgList(i)
		CodePage(i - MinNum).CharSet = CharSetList(i)
	Next i
	getCodePageList = CodePage
End Function


'ȡԶ
Public Function LangCodeList(ByVal SetName As String,ByVal MinNum As Long,ByVal MaxNum As Long) As LANG_SET()
	Dim i As Long,n As Long,TempList() As String
	If CheckLangSet(PslLangList,False) = False Then
		TempList = ReSplit("|af|sq|gsw|am|ar|hy|as|az|bn|ba|eu|be|bn-IN|bs|br|bg|my|ca|tzm|ku|chr|zh-CN|zh-TW|co|hr|cs|da|prs|nl|" & _
				"en|et|fo|fa|fil-PH|fi|fr|fy|ff|gl|ka|de|el|kl|gn|gu|ha|haw|he|hi|hu|is|ig|id|iu|ga|xh|zu|it|ja|" & _
				"jv|kn|KS|kk|km|qut|rw|kok|ko|kz|ky|lo|lv|lt|dsb|lb|mk|ms|ML|mt|mi|arn|mr|moh|mn|ne|no|nb|nn|oc|" & _
				"or|om|ps|pl|pt|pa|qu|ro|rm|ru|sah|smn|smj|se|sms|sma|sa|gd|sr-Cyrl|sr|nso|st|tn|SD|si|sk|sl|so|st|es|" & _
				"sw|sv|sy|tg|tzm|ta|tt|te|th|bo|ti|ts|tr|tk|ug|uk|hsb|ur|uz|ca|vi|cy|wo|ii|yo",LngJoinStr)
		n = UBound(TempList)
		ReDim PslLangList(n) As LANG_SET
		For i = 0 To UBound(TempList)
			With PslLangList(i)
				.PslCode = TempList(i)
				.Name = PSL.GetLangCode(PSL.GetLangID(.PslCode,pslCode639_1),pslCodeText)
				Select Case .Name
				Case "3FF3F",""
					.Name = PSL.GetLangCode(PSL.GetLangID(.PslCode,pslCodeLangRgn),pslCodeText)
				End Select
			End With
		Next i
	Else
		n = UBound(PslLangList)
	End If
	Select Case SetName
	Case DefaultCheckList(0)
		TempList = ReSplit("||||||||||||||||||||||zh-CN|zh-TW|||||||" & _
				"|||||||||||||||||||||||||||||ja|" & _
				"||||||||ko||||||||||||||||||||||" & _
				"||||||||||||||||||||||||||||||" & _
				"||||||||||||||||||||||||",LngJoinStr)
	Case DefaultCheckList(1)
		TempList = ReSplit("|af|sq|gsw|am|ar|hy|as|az|bn|ba|eu|be|bn-IN|bs|br|bg|my|ca|tzm|ku|chr|||co|hr|cs|da|prs|nl|" & _
				"en|et|fo|fa|fil-PH|fi|fr|fy|ff|gl|ka|de|el|kl|gn|gu|ha|haw|he|hi|hu|is|ig|id|iu|ga|xh|zu|it||" & _
				"jv|kn|KS|kk|km|qut|rw|kok||kz|ky|lo|lv|lt|dsb|lb|mk|ms|ML|mt|mi|arn|mr|moh|mn|ne|no|nb|nn|oc|" & _
				"or|om|ps|pl|pt|pa|qu|ro|rm|ru|sah|smn|smj|se|sms|sma|sa|gd|sr-Cyrl|sr|nso|st|tn|SD|si|sk|sl|so|st|es|" & _
				"sw|sv|sy|tg|tzm|ta|tt|te|th|bo|ti|ts|tr|tk|ug|uk|hsb|ur|uz|ca|vi|cy|wo|ii|yo",LngJoinStr)
	Case Else
		ReDim TempList(n) As String
	End Select
	If MaxNum < 0 Or MaxNum > n Then MaxNum = n
	ReDim LangPairs(MaxNum - MinNum) As LANG_SET
	n = 0
	For i = MinNum To MaxNum
		Select Case PslLangList(i).Name
		Case "3FF3F",""
		Case Else
			LangPairs(n) = PslLangList(i)
			LangPairs(n).UseCode = TempList(i)
			n = n + 1
		End Select
	Next i
	If n > 0 Then
		ReDim Preserve LangPairs(n - 1) As LANG_SET
	Else
		ReDim LangPairs(0) As LANG_SET
	End If
	LangCodeList = LangPairs
End Function


'ԴблȡָĿĿб
'Mode = 0 ֱ˳Mode = 1 Ƿ˳ʾ
Public Function getMsgList(SourceList() As INIFILE_DATA,TargetList() As String,Titles As String,ByVal Mode As Long) As Boolean
	Dim i As Long,j As Long,n As Long,m As Long,Temp As String
	Temp = "|" & Titles & "|"
	n = -1
	For i = 0 To UBound(SourceList)
		If InStr(Temp,"|" & SourceList(i).Title & "|") > 0 Then
			If n = -1 Then
				TargetList = SourceList(i).Value
				n = UBound(TargetList)
			Else
				m = UBound(SourceList(i).Value)
				ReDim Preserve TargetList(n + m + 1) As String
				For j = 0 To m
					TargetList(n + 1) = SourceList(i).Value(j)
				Next j
			End If
			Temp = Replace$(Temp,"|" & SourceList(i).Title & "|","")
			If Temp = "" Then Exit For
		End If
	Next i
	If n > -1 Then
		Titles = RemoveBackslash(Temp,"|","|",1)
		getMsgList = True
	Else
		If Mode = 0 Then
			Err.Raise(1,"NotSection",LangFile & JoinStr & Titles)
		ElseIf Mode < 3 Then
			On Error GoTo ErrorMassage
			Err.Raise(1,"NotSection",LangFile & JoinStr & Titles)
			ErrorMassage:
			Call sysErrorMassage(Err,Mode)
		End If
	End If
End Function


'ȡ INI ļ
'Mode = 0 ɾĿֵǰո˫ţתĿֵ
'Mode = 1 ɾĿֵǰո񣬲ת
'Mode = 2 ɾĿֵǰո񣬲ת
'Mode > 2 ɾĿֵǰո񣬲ת
Public Function getINIFile(DataList() As INIFILE_DATA,ByVal File As String,Code As String,ByVal Mode As Long) As Boolean
	Dim i As Long,j As Long,m As Long,n As Long,iMax As Long,vMax As Long,TempArray() As String
	If Trim$(File) <> "" Then
		TempArray = ReSplit(ReadTextFile(File,Code),vbCrLf)
	ElseIf File = "" And Code <> "" Then
		TempArray = ReSplit(Code,vbCrLf)
	Else
		Exit Function
	End If
	If CheckArray(TempArray) = False Then Exit Function
	ReDim DataList(iMax) As INIFILE_DATA
	m = -1
	For i = 0 To UBound(TempArray)
		TempArray(i) = Trim$(TempArray(i))
		If TempArray(i) Like "[[]*]" Then
			m = m + 1
			If m >= iMax Then
				iMax = m * 50
				ReDim Preserve DataList(iMax) As INIFILE_DATA
			End If
			DataList(m).Title = Trim$(Mid$(TempArray(i),2,Len(TempArray(i)) - 2))
			If m > 0 Then
				If n > 0 Then n = n - 1
				ReDim Preserve DataList(m - 1).Item(n) 'As String
				ReDim Preserve DataList(m - 1).Value(n) 'As String
			End If
			n = 0: vMax = 0
		ElseIf DataList(IIf(m = -1,0,m)).Title <> "" Then
			j = InStr(TempArray(i),"=")
			If j > 0 Then
				If Trim$(Left$(TempArray(i),j - 1)) <> "" Then
					If n >= vMax Then
						vMax = n * 100
						ReDim Preserve DataList(m).Item(vMax) 'As String
						ReDim Preserve DataList(m).Value(vMax) 'As String
					End If
					DataList(m).Item(n) = Trim$(Left$(TempArray(i),j - 1))
					Select Case Mode
					Case 0
						DataList(m).Value(n) = Convert(RemoveBackslash(Mid$(TempArray(i),j + 1),"""","""",2))
					Case 1
						DataList(m).Value(n) = LTrim$(Mid$(TempArray(i),j + 1))
					Case 2
						DataList(m).Value(n) = Trim$(Mid$(TempArray(i),j + 1))
					Case Else
						DataList(m).Value(n) = Mid$(TempArray(i),j + 1)
					End Select
					n = n + 1
				End If
			End If
		End If
	Next i
	If m < 0 Then m = 0
	If n > 0 Then
		n = n - 1
		getINIFile = True
	End If
	ReDim Preserve DataList(m).Item(n) 'As String
	ReDim Preserve DataList(m).Value(n) 'As String
	ReDim Preserve DataList(m) As INIFILE_DATA
End Function


'ȡļб
Public Function GetUIList(ByVal UIDir As String,UIList() As UI_FILE) As Boolean
	Dim i As Long,j As Long,m As Long,n As Long
	Dim File As String,Header As String,TempArray() As String
	Dim tmpUIFile As UI_FILE,FN As Variant,readByte() As Byte
	ReDim UIList(0) As UI_FILE
	On Error Resume Next
	With tmpUIFile
		File = Dir$(UIDir & AppName & "_*.lng")
		Do While File <> ""
			If LCase$(Mid$(File,InStrRev(File,".") + 1)) = "lng" Then
				.FilePath = UIDir & File
				i = FileLen(.FilePath)
				ReDim readByte(i) As Byte
				FN = FreeFile
				Open .FilePath For Binary Access Read Lock Write As #FN
				Get #FN,,readByte
				Close #FN
				TempArray = ReSplit(readByte,vbCrLf)
				j = 0: Header$ = ""
				For i = 0 To UBound(TempArray)
					TempArray(i) = Trim(TempArray(i))
					If TempArray(i) Like "[[]*]" Then
						Header$ = Trim$(Mid$(TempArray(i),2,Len(TempArray(i)) - 2))
						If j > 0 Then
							If Header$ <> "Option" Then Exit For
							j = 0
						End If
					ElseIf Header$ = "Option" Then
						j = InStr(TempArray(i),"=")
						If j > 0 Then
							Select Case Trim$(Left$(TempArray(i),j - 1))
							Case "AppName"
								.AppName = RemoveBackslash(Mid$(TempArray(i),j + 1),"""","""",1)
							Case "Version"
								.Version = RemoveBackslash(Mid$(TempArray(i),j + 1),"""","""",1)
							Case "LanguageName"
								.LangName = RemoveBackslash(Mid$(TempArray(i),j + 1),"""","""",1)
							Case "LanguageID"
								.LangID = RemoveBackslash(Mid$(TempArray(i),j + 1),"""","""",1)
							Case "Encoding"
								.Encoding = RemoveBackslash(Mid$(TempArray(i),j + 1),"""","""",1)
							End Select
						End If
						j = 1
					End If
				Next i
				If LCase$(.AppName) = LCase$(AppName) Then
					If .Version = Version And .LangName <> "" Then
						If n > m Then
							m = n * 10
							ReDim Preserve UIList(m) As UI_FILE
						End If
						UIList(n) = tmpUIFile
						n = n + 1
					End If
					.AppName = "": .Version = "": .LangName = "": .LangID = "": .Encoding = ""
				End If
			End If
			File = Dir$()
		Loop
	End With
	If n > 0 Then
		GetUIList = True
		n = n - 1
	End If
	ReDim Preserve UIList(n) As UI_FILE
End Function


'ȡִ
Public Function GetUI(ByVal UIDir As String,ByVal UISet As String,ByVal OSLng As String,UIData() As INIFILE_DATA,UIFiles() As UI_FILE,LngFile As String) As Boolean
	Dim i As Long,j As Long,n As Long
	Dim TempList() As String,TempArray() As String
	If GetUIList(UIDir,UIFiles) = True Then
		If UISet = "" Or UISet = "0" Then
			UISet = OSLng
		ElseIf UISet = "1" Then
			UISet = Right$("0" & Hex$(PSL.Option(pslOptionSystemLanguage)),4)
		End If
		UISet = LCase$(UISet)
		TempList = ReSplit(UISet,";")
		For i = 0 To UBound(UIFiles)
			If LCase$(UIFiles(i).LangID) = UISet Then
				LngFile = UIFiles(i).FilePath
				Exit For
			End If
			TempArray = ReSplit(LCase$(UIFiles(i).LangID),";")
			For j = 0 To UBound(TempList)
				For n = 0 To UBound(TempArray)
					If TempList(j) = TempArray(n) Then
						LngFile = UIFiles(i).FilePath
						Exit For
					End If
				Next n
				If LngFile <> "" Then Exit For
			Next j
			If LngFile <> "" Then Exit For
		Next i
	End If
	If LngFile = "" Then LngFile = UIDir & AppName & "_" & OSLng & ".lng"
	If Dir$(LngFile) = "" Then
		LngFile = UIDir & AppName & "_" & OSLng & ".lng"
		If Dir$(LngFile) = "" Then
			For i = 0 To 2
				If i = 0 Then
					LngFile = UIDir & AppName & "_0804.lng"
				ElseIf i = 1 Then
					LngFile = UIDir & AppName & "_0404.lng"
				Else
					LngFile = UIFiles(0).FilePath
				End If
				If Dir$(LngFile) <> "" Then Exit For
				LngFile = ""
			Next i
			If LngFile = "" Then Err.Raise(1,"NotExitFile",UIDir & AppName & "_*.lng")
		End If
	End If
	GetUI = getINIFile(UIData,LngFile,"unicodeFFFE",0)
End Function


'ùλãʼкʼΪ0
'LineNo = к(ıͷʼ)ʼ = 0
'ColNo = к(ǰ׿ʼ)ʼ = 0
'Length = ѡ
'strText = "" ColNo  Length Ϊַ Win7 °汾
'strText <> ""ColNo  Length Ϊֽ Win10 ϰ汾
'strText Ϊıеı GetTextBoxString(hwnd) ȡ
Private Sub SetCurPos(ByVal hwnd As Long,ByVal LineNo As Long,ByVal ColNo As Long,ByVal Length As Long,Optional ByVal strText As String)
	'ȡָеַıеַƫ
	LineNo = SendMessageLNG(hwnd, EM_LINEINDEX, LineNo, 0&)
	'Win10  EM_SETSEL Ҫֽص LineNo ΪַҪתΪֽƫ
	If strText <> "" Then
		'LineNo = StrHexLength(Left$(strText,LineNo),GetACP,0) '׵ֽ
		ReDim tmpByte(0) As Byte
		tmpByte = StrConv(Left$(strText,LineNo),vbFromUnicode)
		LineNo = UBound(tmpByte) + 1
	End If
	'ѡָıΧ (Win10 µĲΪֽƫ)
	SendMessageLNG hwnd, EM_SETSEL, LineNo + ColNo, LineNo + ColNo + Length
	'ѡݷŵӷΧ֮
	SendMessageLNG hwnd, EM_SCROLLCARET, 0&, 0&
End Sub


'ȡλãкźкţкʼоΪ0
'Mode = FalseGetCurPos.y ΪкţGetCurPos.x Ϊյк(׿ʼַ)
'Mode = True GetCurPos.y ΪкţGetCurPos.x Ϊʼк(׿ʼַ)
'strText = ""ת GetCurPos.x Ϊַ Win7 °汾
'strText <> "" ת GetCurPos.x Ϊַ Win10 ϰ汾
'strText Ϊıеı GetTextBoxString(hwnd) ȡ
Private Function GetCurPos(ByVal hwnd As Long,ByVal Mode As Boolean,Optional ByVal strText As String) As POINTAPI
	If Mode = False Then
		'ȡλıеֽƫ
		SendMessage hwnd, EM_GETSEL, 0&, GetCurPos
	Else
		'ȡλıеֽƫ(16λ = ʼ,16λ = յ)
		GetCurPos.x = SendMessageLNG(hwnd, EM_GETSEL, 0&, 0&)	'λλ󷵻ֵΪ65535򷵻 -1
		If GetCurPos.x > -1 Then
			'Int hi = DWORD / 0x10000; Int low = DWORD And 0xffff;
			If Mode = False Then
				GetCurPos.x = GetCurPos.x / &H10000	'λյ
			Else
				GetCurPos.x = GetCurPos.x And 65535	'λʼ
			End If
		Else
			SendMessage hwnd, EM_GETSEL, 0&, GetCurPos
		End If
	End If
	If strText <> "" Then
		'ת GetCurPos.x ΪַΪWin10  EM_LINEFROMCHAR ַƫƻȡк
		ReDim tmpByte(0) As Byte
		'tmpByte = StringToByte(strText,GetACP)
		tmpByte = StrConv(strText,vbFromUnicode)
		ReDim Preserve tmpByte(GetCurPos.x + 1) As Byte
		'GetCurPos.x = Len(ByteToString(tmpByte,,GetACP))
		GetCurPos.x = Len(StrConv$(tmpByte,vbUnicode))
	End If
	'ùек
	GetCurPos.y = SendMessageLNG(hwnd, EM_LINEFROMCHAR, GetCurPos.x, 0&)
	'عеַ
	GetCurPos.x = GetCurPos.x - SendMessageLNG(hwnd, EM_LINEINDEX, GetCurPos.y, 0&) + 1
End Function


'ȡеı
Private Function GetCurPosLine(ByVal hwnd As Long,ByVal LineNo As Long) As String
	Dim Length As Long
	'ȡеַıеַƫ
	Length = SendMessageLNG(hwnd, EM_LINEINDEX, LineNo, 0&)
	'ȡеı(ַ)
	Length = SendMessageLNG(hwnd, EM_LINELENGTH, Length, 0&)
	If Length < 1 Then Exit Function
	'ԤɽıݵֽԤȸո
	ReDim byteBuffer(Length * 2 + 1) As Byte
	' 1024 ַ
	byteBuffer(1) = 4
	'ȡеıֽ
	SendMessage hwnd, EM_GETLINE, LineNo, byteBuffer(0)
	'תΪıַ
	GetCurPosLine = Replace$(StrConv$(byteBuffer,vbUnicode),vbNullChar,"")
End Function


'ȡִĲҷʽ
'GetFindMode = 0 棬= 1 ͨ, = 2 ʽ
Private Function GetFindMode(FindStr As String) As Long
	'ͨʽרַʱ
	If (FindStr Like "*[$()+.^{|*?#[\]*") = False Then
		Exit Function
	End If
	'ʽרַʱ
	If (FindStr Like "*[$()+.^{|\]*") = False Then
		If (FindStr Like "*\[*?#[]*") = False Then
			GetFindMode = 1
		End If
		Exit Function
	End If
	GetFindMode = 2
End Function


'ִƶλ
'Mode = False ͷββͷ
'FindCurPos > 0 ҵ= 0 δҵ, = -1 ͬλ(ֻҵһ), = -2 ͨ﷨, = -3 ʽ﷨
Private Function FindCurPos(ByVal hwnd As Long,ByVal FindStr As String,ByVal Mode As Boolean,Optional strText As String) As Long
	Dim i As Long,n As Long,Lines As Long,Stemp As Integer
	Dim ptPos As POINTAPI,bkPos As POINTAPI,nowPos As POINTAPI,Matches As Object
	On Error GoTo errHandle
	'ȡλüıִ
	Lines = SendMessageLNG(hwnd, EM_GETLINECOUNT, 0&, 0&) - 1 'Lines  1 Ϊ
	If Lines = -1 Then Exit Function
	'ݵĲҷʽ
	ReDim TempList(0) As String
	Stemp = GetFindMode(FindStr)
	Select Case Stemp
	Case 0
		If (FindStr Like "*\[*?#[]*") = True Then
			TempList = ReSplit("*,?,#,[",",",-1)
			For i = 0 To UBound(TempList)
				FindStr = Replace$(FindStr,"\" & TempList(i),TempList(i))
			Next i
		End If
	Case 1
		'תͨΪʽģ
		TempList = ReSplit("\*,\#,\?,\[",",",-1)
		For i = 0 To UBound(TempList)
			FindStr = Replace$(FindStr,TempList(i),CStr$(i) & vbNullChar & CStr$(i) & vbNullChar & CStr$(i))
		Next i
		FindStr = Replace$(FindStr,"?",".")
		FindStr = Replace$(FindStr,"*",".*")
		FindStr = Replace$(FindStr,"#","\d")
		FindStr = Replace$(FindStr,"[!","[^")
		For i = 0 To UBound(TempList)
			FindStr = Replace(FindStr,CStr$(i) & vbNullChar & CStr$(i) & vbNullChar & CStr$(i),TempList(i))
		Next i
		FindStr = Replace$(FindStr,"\#","#")
	Case 2
		If CheckStrRegExp(FindStr,"(\\\(.+\\\))|(\\\(.+\))|(\(\?.+\))|(\(.+\).*\\[1-9]\d?)",0,2) = False Then
			If (FindStr Like "*(.*)*") = True Then Stemp = 3
		End If
	End Select
	'ʼʽ
	With RegExp
		.Global = Mode
		.IgnoreCase = False
		.Pattern = FindStr
	End With
	'ȡλ  .y Ϊк ( = 0).x Ϊеַƫ( = 0)
	ptPos = GetCurPos(hwnd,True)
	'ʼ㣬жҵλǷǹλ
	bkPos = ptPos
	'ִ
	With ptPos
		Do
			strText = GetCurPosLine(hwnd,ptPos.y)
			If strText = "" Then GoTo NextLine
			If Stemp = 0 Then
				If Mode = False Then
   		 			.x = InStr(.x + 1,strText,FindStr)
   	 			Else
    				.x = InStrRev(strText,FindStr,.x - 1)
    			End If
    			i = Len(FindStr)
   		 	Else
    			If Mode = False Then
    				strText = Mid$(strText,.x + 1)
    			ElseIf .x > 0 Then
					strText = Left$(strText,.x - 1)
				End If
				If strText = "" Then GoTo NextLine
   				Set Matches = RegExp.Execute(strText)
				If Matches.Count = 0 Then GoTo NextLine
				If Mode = False Then
					If Stemp = 3 Then
						.x = .x + InStr(1,strText,Matches(0).SubMatches(0))
						i = Len(Matches(0).SubMatches(0))
					Else
						.x = .x + Matches(0).FirstIndex + 1
						i = Matches(0).Length
					End If
				Else
					i = Matches.Count - 1
					If Stemp = 3 Then
						.x = InStrRev(strText,Matches(i).SubMatches(0),-1)
						i = Len(Matches(i).SubMatches(0))
					Else
						.x = Matches(i).FirstIndex + 1
						i = Matches(i).Length
					End If
				End If
			End If
   		 	If .x > 0 Then
   		 		.x = .x - 1
				Call SetCurPos(hwnd,.y,.x,i)
				nowPos = GetCurPos(hwnd,True)
				If nowPos.y = bkPos.y And nowPos.x = bkPos.x Then
					FindCurPos = -1
					strText = Mid$(GetCurPosLine(hwnd,.y),.x + 1,i)
				Else
					FindCurPos = .y + 1
				End If
				Exit Function
			End If
			NextLine:
			.x = 0
			If Mode = False Then
				.y = .y + 1
				If .y > Lines Then .y = 0
			Else
				.y = .y - 1
				If .y < 0 Then .y = Lines
			End If
			n = n + 1
		Loop Until n > Lines + 1
	End With
	Exit Function
	errHandle:
	If Stemp > 0 Then FindCurPos = IIf(Stemp < 2,-2,-3)
End Function


'ִ
'Mode = 0 棬= 1 ͨ, = 2 ʽ
'FilterStr = 1 ҵ= 0 δҵ, = -1 , = -2 ͨ﷨ = -3 ʽ﷨
Private Function FilterStr(ByVal txtStr As String,ByVal FindStr As String,ByVal Mode As Long,Optional ByVal IgnoreCase As Boolean) As Long
	Dim i As Long,TempList() As String
	On Error GoTo errHandle
	Select Case Mode
	Case 0
		If (FindStr Like "*\[*?#[]*") = True Then
			TempList = ReSplit("*,?,#,[",",",-1)
			For i = 0 To UBound(TempList)
				FindStr = Replace$(FindStr,"\" & TempList(i),TempList(i))
			Next i
		End If
		If IgnoreCase = True Then
			txtStr = LCase(txtStr)
			FindStr = LCase(FindStr)
		End If
		If InStr(txtStr,FindStr) Then FilterStr = 1
	Case 1
		If IgnoreCase = True Then
			txtStr = LCase(txtStr)
			FindStr = LCase(FindStr)
		End If
		If (txtStr Like FindStr) = True Then FilterStr = 1
	Case 2
		If CheckStrRegExp(txtStr,FindStr,0,2,IgnoreCase) = True Then FilterStr = 1
	End Select
	Exit Function
	errHandle:
	FilterStr = -(Mode + 1)
End Function


'ııڿʼ lpPoint 
Private Function InsertStr(ByVal hwnd As Long,ByVal strText As String,ByVal InsertText As String) As String
	Dim lpPoint As POINTAPI
	With lpPoint
		lpPoint = GetCurPos(hwnd,False)
		'SendMessage(hwnd, CB_GETEDITSEL, .x, .y)
		InsertStr = Left$(strText,.x) & InsertText & Mid$(strText,.x + 1)
		.x = .x + Len(InsertText)
	End With
	Call SetCurPos(hwnd,lpPoint.y,lpPoint.x,0)
End Function


'ǷΪգǿշ True
Public Function CheckFont(LF As LOG_FONT) As Boolean
	If ReSplit(StrConv$(LF.lfFaceName,vbUnicode),vbNullChar,2)(0) <> "" Then CheckFont = True
End Function


'ȡƺֺ
Public Function GetFontText(ByVal hwnd As Long,LF As LOG_FONT) As String
	Dim LF2 As LOG_FONT
	LF2 = LF
	If CheckFont(LF2) = False Then
		If hwnd = 0 Then Exit Function
		GetObjectAPI(SendMessageLNG(hwnd,WM_GETFONT,0,0),Len(LF2),VarPtr(LF2))
	End If
	'GetFontText = ReSplit(StrConv$(LF2.lfFaceName,vbUnicode),vbNullChar,2)(0) & " " & CStr$(-LF2.lfHeight)
	GetFontText = ReSplit(MultiByteToUTF16(LF2.lfFaceName,GetACP),vbNullChar,2)(0) & " " & CStr$(-LF2.lfHeight)
End Function


'Ƚ϶Ƿͬͬ True
Private Function FontComps(LF() As LOG_FONT,LF2() As LOG_FONT) As Boolean
	Dim i As Long
	If UBound(LF) <> UBound(LF2) Then
		FontComps = True
		Exit Function
	End If
	For i = LBound(LF) To UBound(LF)
		If FontComp(LF(i),LF2(i)) = True Then
			FontComps = True
			Exit For
		End If
	Next i
End Function


'Ƚ϶Ƿͬͬ True
Public Function FontComp(LF As LOG_FONT,LF2 As LOG_FONT) As Boolean
	FontComp = True
	With LF
		If .lfCharSet <> LF2.lfCharSet Then Exit Function
		If .lfClipPrecision <> LF2.lfClipPrecision Then Exit Function
		If .lfEscapement <> LF2.lfEscapement Then Exit Function
		If .lfFaceName <> LF2.lfFaceName Then Exit Function
		If .lfHeight <> LF2.lfHeight Then Exit Function
		If .lfItalic <> LF2.lfItalic Then Exit Function
		If .lfOrientation <> LF2.lfOrientation Then Exit Function
		If .lfOutPrecision <> LF2.lfOutPrecision Then Exit Function
		If .lfPitchAndFamily <> LF2.lfPitchAndFamily Then Exit Function
		If .lfQuality <> LF2.lfQuality Then Exit Function
		If .lfStrikeOut <> LF2.lfStrikeOut Then Exit Function
		If .lfUnderline <> LF2.lfUnderline Then Exit Function
		If .lfWeight <> LF2.lfWeight Then Exit Function
		If .lfWidth <> LF2.lfWidth Then Exit Function
		If .lfColor <> LF2.lfColor Then Exit Function
	End With
	FontComp = False
End Function


'ϵͳԻѡ壬ȷʱط
Public Function SelectFont(ByVal hwnd As Long,LF As LOG_FONT) As Long
	Dim CF As CHOOSE_FONT,LF2 As LOG_FONT
	LF2 = LF
	If CheckFont(LF2) = False Then
		If hwnd <> 0 Then
			GetObjectAPI(SendMessageLNG(hwnd,WM_GETFONT,0,0),Len(LF2),VarPtr(LF2))
		End If
	End If
	With CF
		.lStructSize = Len(CF)			'size of structure
		.hwndOwner = hwnd				'window Form1 is opening this dialog box
		'.hDC = GetDC(hWnd)				'device context of default printer (using VB's mechanism)
		.lpLogFont = VarPtr(LF2)		'LogFontṹַ
		'.iPointSize = LF.lfHeight		'10 * size in points of selected font
		.flags = CF_BOTH Or CF_EFFECTS Or CF_FORCEFONTEXIST Or CF_INITTOLOGFONTSTRUCT Or CF_LIMITSIZE Or CF_INACTIVEFONTS
		.rgbColors = LF2.lfColor		'RGB(0,0,0)		'black
		'.lCustData = 0					' data passed to hook fn
		'.lpfnHook = 0					' ptr. to hook function
		'.lpTemplateName = ""			' custom template name
		'.hInstance = 0					' instance handle of.EXE that contains cust. dlg. template
		'.lpszStyle = LF2.lfFaceName	' return the style field here must be LF_FACESIZE or bigger
		.nFontType = LF2.lfWeight		'REGULAR_FONTTYPE	'regular font type i.e. not bold or anything
		.nSizeMin = 8 					'minimum point size
		.nSizeMax = 16 					'maximum point size
	End With
	SelectFont = ChooseFont(CF)
	If SelectFont = 0 Then Exit Function
	LF = LF2
	LF.lfColor = CF.rgbColors
End Function


'壬
Public Function CreateFont(ByVal hwnd As Long,LF As LOG_FONT) As Long
	Dim LF2 As LOG_FONT
	LF2 = LF
	If CheckFont(LF2) = False Then
		If hwnd = 0 Then Exit Function
		GetObjectAPI(SendMessageLNG(hwnd,WM_GETFONT,0,0),Len(LF2),VarPtr(LF2))
	End If
	CreateFont = CreateFontIndirect(LF2)
End Function


'ػԻ
Public Function DrawWindow(ByVal hwnd As Long,ByVal hFont As Long) As Long
	'Dim New_hFont As Long,hDC As Long
	'hDC = GetDC(hwnd)
	'New_hFont = SelectObject(hDC, hFont)
	'SendMessageLNG(hWnd,WM_SETREDRAW,True,0)
	SendMessageLNG(hwnd,WM_SETFONT,hFont,0)
	'SendMessageLNG(hWnd,WM_PAINT,0,0)
	DrawWindow = RedrawWindow(hwnd,0,0,RDW_ERASE Or RDW_INVALIDATE Or RDW_ALLCHILDREN Or RDW_UPDATENOW)
	'SelectObject hDC, New_hFont
	'DeleteObject(hFont)
	'ReleaseDC(hwnd, hDC)
End Function


'ñ༭ؼеıȣԭ󳤶Ϊ30000ַ˫ַֽ1
Private Function SetTextBoxLength(ByVal hwnd As Long,ByVal NewLength As Long,ByVal Mode As Boolean) As Long
	SetTextBoxLength = SendMessageLNG(hwnd,EM_GETLIMITTEXT,0&,0&)
	If NewLength < SetTextBoxLength Then
		If Mode = False Then Exit Function
		If NewLength < 30001 Then Exit Function
		If NewLength > (SetTextBoxLength \ 3) Then Exit Function
	End If
	SetTextBoxLength = NewLength * 2
	SendMessageLNG hwnd,EM_LIMITTEXT,SetTextBoxLength,0&
End Function


'ضԻĳؼеִ
Private Function GetTextBoxString(ByVal hwnd As Long) As String
	Dim i As Long
	On Error GoTo errHandle
	'ԷĴںͿؼ
	'i = SendMessageLNG(hwnd,WM_GETTEXTLENGTH,0&,0&)
	'ֻܷĴںͿؼ
	i = GetWindowTextLength(hwnd)
	If i > 0 Then
		GetTextBoxString = String$(i + 1,0)
		'ԷĴںͿؼٶȺ
		'SendMessageLNG hwnd, WM_GETTEXT, i + 1, StrPtr(GetTextBoxString)
		'GetTextBoxString = Replace$(StrConv$(GetTextBoxString,vbUnicode),vbNullChar,"")
		'ֻܷĴںͿؼٶȿü
		GetWindowText hwnd, GetTextBoxString, i + 1
		GetTextBoxString = Replace$(GetTextBoxString,vbNullChar,"")
	End If
	Exit Function
	errHandle:
	GetTextBoxString = ""
End Function


'öԻĳؼеִ
'Mode = False 滻ʾ׷ʾ
Public Function SetTextBoxString(ByVal hwnd As Long,ByVal strText As String,Optional ByVal Mode As Boolean) As Boolean
	On Error GoTo errHandle
	If Mode = False Then
		'ԷĴںͿؼ
		'SetTextBoxString = SendMessageLNG(hwnd,WM_SETTEXT,0&,StrPtr(StrConv$(StrText,vbFromUnicode)))
		'ֻܷĴںͿؼᱣȷʾǰһַ
		SetTextBoxString = SetWindowText(hwnd,strText)
	Else
		strText = GetTextBoxString(hwnd) & vbCrLf & strText
		'ı
		SetTextBoxLength hwnd, Len(strText), True
		'ԷĴںͿؼᶪʧǰһַ
		'SetTextBoxString = SendMessageLNG(hwnd,WM_SETTEXT,0&,StrPtr(StrConv$(StrText,vbFromUnicode)))
		'ֻܷĴںͿؼᱣȷʾǰһַ
		SetTextBoxString = SetWindowText(hwnd,strText)
		'ùıײ
		SendMessageLNG hwnd, WM_VSCROLL, SB_BOTTOM, 0&
	End If
	errHandle:
End Function


' PSL 2015 ϰ汾 Split ַֿʱδʼĴ
Public Function ReSplit(ByVal textStr As String,Optional ByVal Sep As String = " ",Optional ByVal Max As Integer = -1) As String()
	If textStr = "" Then
		ReDim TempList(0) As String
		ReSplit = TempList
	Else
		ReSplit = Split(textStr,Sep,Max)
	End If
End Function


'ȡõб
Public Function getSetNameList(DataList As Variant) As String()
	Dim i As Integer,n As Integer
	n = UBound(DataList)
	ReDim TempList(n) As String
	For i = 0 To n
		TempList(i) = DataList(i).Name
	Next i
	getSetNameList = TempList
End Function


'ȥո
Public Function RemoveSpaces(ByVal textStr As String,Optional ByVal SplitChar As String,Optional ByVal Mode As Integer) As String
	Dim i As Integer,TempList() As String
	TempList = ReSplit(textStr,SplitChar)
	Select Case Mode
	Case 0
		For i = 0 To UBound(TempList)
			TempList(i) = Trim(TempList(i))
		Next i
	Case 1
		For i = 0 To UBound(TempList)
			TempList(i) = LTrim(TempList(i))
		Next i
	Case 2
		For i = 0 To UBound(TempList)
			TempList(i) = RTrim(TempList(i))
		Next i
	End Select
	RemoveSpaces = Join(TempList,SplitChar)
End Function


'ıֵ
Private Function SortStringByLength(ByVal CheckSet As String,Optional ByVal SplitChar As String,Optional ByVal Mode As Boolean) As String
	Dim i As Integer,TempList() As String
	TempList = ReSplit(CheckSet,SplitChar)
	Call SortArrayByLength(TempList,0,UBound(TempList),Mode)
	SortStringByLength = StrListJoin(TempList,SplitChar)
End Function


'תΪʽģ
'Mode = 0 תΪ [] ʽΪ [] ʽ
Private Function CheckSet2RegPattern(ByVal CheckSet As String,Optional ByVal SplitChar As String,Optional ByVal Mode As Long) As String
	Dim i As Integer,TempList() As String
	TempList = ReSplit(CheckSet,SplitChar)
	For i = 0 To UBound(TempList)
		TempList(i) = Str2RegExpPattern(TempList(i),1)
	Next i
	If Mode = 0 Then
		CheckSet2RegPattern = Join(TempList,SplitChar)
	Else
		CheckSet2RegPattern = "[" & Join(TempList,SplitChar) & "]"
	End If
End Function


'ַתʽʹõ Unicode תģ
'Mode = 0 תΪ [] ʽΪ [] ʽ
Private Function Str2RegExpPattern(ByVal textStr As String,Optional ByVal Mode As Long) As String
	Dim i As Long,j As Long,n As Long,Bytes() As Byte
	If textStr = "" Then Exit Function
	Bytes = textStr
	j = UBound(Bytes)
	If Mode = 0 Then
		Str2RegExpPattern = "[" & Space$((j + 1) * 3) & "]"
		n = 2
	Else
		Str2RegExpPattern = Space$((j + 1) * 3)
		n = 1
	End If
	For i = 0 To j - 1 Step 2
		Mid$(Str2RegExpPattern,n,6) = "\u" & Right$("0" & Hex$(Bytes(i + 1)),2) & Right$("0" & Hex$(Bytes(i)),2)
		n = n + 6
	Next i
End Function


'תͨΪʽģ
Private Function WildcardChar2RegExpPattern(ByVal textStr As String,Optional ByVal SplitChar As String) As String
	Dim i As Long,TempList() As String
	If textStr = "" Then Exit Function
	TempList = ReSplit("\*,\#,\?,\[",",",-1)
	For i = 0 To UBound(TempList)
		textStr = Replace$(textStr,TempList(i),CStr$(i) & vbNullChar & CStr$(i) & vbNullChar & CStr$(i))
	Next i
	textStr = Replace$(textStr,"?",".")
	textStr = Replace$(textStr,"*",".*")
	textStr = Replace$(textStr,"#","\d")
	textStr = Replace$(textStr,"[!","[^")
	For i = 0 To UBound(TempList)
		textStr = Replace(textStr,CStr$(i) & vbNullChar & CStr$(i) & vbNullChar & CStr$(i),TempList(i))
	Next i
	WildcardChar2RegExpPattern = Replace$(textStr,"\#","#")
End Function


'
Public Function LineCount(ByVal textStr As String) As Long
	Dim Matches As Object
	With RegExp
		.Global = True
		.IgnoreCase = True
		.Pattern = "[\r\n]"
		Set Matches = .Execute(textStr)
		LineCount = Matches.Count + 1
	End With
End Function


'תеת
Public Function ConvertAndSortCheckSet(CheckSet As CHECK_SET) As CHECK_SET
	ConvertAndSortCheckSet = CheckSet
	With ConvertAndSortCheckSet
		'תתַӶൽ
		.AccKeyExcludeChar = Convert(.AccKeyExcludeChar)
		.PreInsertSplitChar = SortStringByLength(Convert(.PreInsertSplitChar),",",True)
		.CheckBracket = Convert(.CheckBracket)
		.KeepCharPair = Convert(.KeepCharPair)
		'.ShowAsiaKey = Convert(.ShowAsiaKey)
		.CheckEndChar = SortStringByLength(Convert(WildcardChar2RegExpPattern(.CheckEndChar))," ",True)
		.NotTrnEndChar = SortStringByLength(Convert(.NotTrnEndChar),",",True)
		.AutoTrnEndChar = Convert(.AutoTrnEndChar)
		.CheckShortChar = SortStringByLength(Convert(.CheckShortChar),",",True)
		.CheckShortKey = SortStringByLength(Convert(.CheckShortKey),",",True)
		.KeepShortKey = SortStringByLength(Convert(.KeepShortKey),",",True)
		.PreRepStr = SortStringByLength(Convert(.PreRepStr),",",True)
		.AppRepStr = SortStringByLength(Convert(.AppRepStr),",",True)
		.AccKeyChar = SortStringByLength(Convert(.AccKeyChar),",",True)
		'.AccKeyWithFirstChar = Convert(.AccKeyWithFirstChar)
		'.LineSplitMode = Convert(.LineSplitMode)
		.AppInsertSplitChar = SortStringByLength(Convert(.AppInsertSplitChar),",",True)
		.ReplaceSplitChar = SortStringByLength(Convert(.ReplaceSplitChar),",",True)

		'תΪ Unicode ֽڱʾʽģ
		.CheckBracket = CheckSet2RegPattern(.CheckBracket,",")
		.CheckEndChar = CheckSet2RegPattern(.CheckEndChar," ")
		'.CheckShortChar = CheckSet2RegPattern(.CheckShortChar,",")
		.AccKeyChar = CheckSet2RegPattern(.AccKeyChar,",")
	End With
End Function


'鷭÷ǿɿĿǷΪ
Public Function CheckCheckSet(SetList() As CHECK_SET,Optional ByVal SetID As Long = -1) As Boolean
	Dim i As Long,Max As Long
	On Error GoTo ExitFunction
	If SetID = -1 Then
		SetID = 0: Max = UBound(SetList)
	Else
		Max = SetID
	End If
	For i = SetID To Max
		With SetList(i)
			If .Name = "" Then Exit Function					'
			If .AccKeyExcludeChar = "" Then Exit Function		'Ҫųķǿݼַ
			If .CheckBracket = "" Then Exit Function			'ҪĿݼǰҺ
			'If .KeepCharPair = "" Then Exit Function			'ҪĿݼǰ
			'If .ShowAsiaKey = 0 Then Exit Function				'ʾԷʽĿݼ
			If .CheckEndChar = "" Then Exit Function			'ҪĽ
			'If .NoTrnEndChar = "" Then Exit Function			'ҪĽ
			'If .AutoTrnEndChar = "" Then Exit Function			'ҪԶĽ
			If .CheckShortChar = "" Then Exit Function			'Ҫļַ
			'If .CheckShortKey = "" Then Exit Function			'Ҫļ־
			'If .KeepShortKey = "" Then Exit Function			'Ҫļַ
			'If .PreRepStr = "" Then Exit Function				'ǰҪ滻ַ
			'If .AutoRepStr = "" Then Exit Function				'Ҫ滻ַ
			If .AccKeyChar = "" Then Exit Function				'ҪĿݼ־
			'If .AccKeyWithFirstChar = 0 Then Exit Function		'Ƿִ׸ǿհַΪݼַ
			'If .LineSplitMode = = 0 Then Exit Function			'ִģʽ
			'If .PreInsertSplitChar = "" Then Exit Function		'ǰʽַ
			'If .AppInsertSplitChar = "" Then Exit Function		'ʽַ
			'If .ReplaceSplitChar = "" Then Exit Function		'滻ʽַ
			If CheckLangSet(.LangPairList,True) = False Then Exit Function	'
		End With
	Next i
	CheckCheckSet = True
	ExitFunction:
End Function


'鷭÷ǿɿĿǷΪ
Private Function CheckLangSet(SetList() As LANG_SET,ByVal Mode As Boolean) As Boolean
	On Error GoTo ExitFunction
	Dim i As Long
	If Mode = False Then
		For i = 0 To UBound(SetList)
			With SetList(i)
				If .Name <> "" And .PslCode <> "" Then
					CheckLangSet = True
					Exit For
				End If
			End With
		Next i
	Else
		For i = 0 To UBound(SetList)
			With SetList(i)
				If .UseCode <> "" Then
					CheckLangSet = True
					Exit For
				End If
			End With
		Next i
	End If
	ExitFunction:
End Function


'ȡִеִ(ʽ)
'Patrn  Ϊʽģ
Private Function GetSubStrInfoRegExp(SubStrInfo As STRING_INFO_SUB,ByVal textStr As String,ByVal Patrn As String, _
				Optional ByVal MatchID As Long,Optional ByVal SubMatchID As Long = -1, _
				Optional ByVal bGlobal As Boolean,Optional ByVal IgnoreCase As Boolean) As Boolean
	Dim Matches As Object
	On Error GoTo ExitFunction
	If Patrn = "" Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	With RegExp
		.Global = bGlobal
		.IgnoreCase = IgnoreCase
		.Pattern = Patrn
		Set Matches = .Execute(textStr)
	End With
	If Matches.Count = 0 Then Exit Function
	If MatchID < 0 Then MatchID = Matches.Count - 1
	With SubStrInfo
		If SubMatchID < 0 Then
			.sString = Matches(MatchID).Value
			.Length = Matches(MatchID).Length
			.Loction = Matches(MatchID).FirstIndex + 1
		Else
			.sString = Matches(MatchID).SubMatches(SubMatchID)
			.Length = Len(.sString)
			.Loction = InStr(Matches(MatchID).FirstIndex + 1,textStr,.sString)
		End If
	End With
	GetSubStrInfoRegExp = True
	ExitFunction:
End Function


'ȡִеַ(ʽ)
'Patrn Ϊʽģ
Private Function GetSubStringRegExp(ByVal textStr As String,ByVal Patrn As String,Optional ByVal MatchID As Long, _
		Optional ByVal SubMatchID As Long = -1,Optional ByVal bGlobal As Boolean,Optional ByVal IgnoreCase As Boolean) As String
	Dim Matches As Object
	On Error GoTo ExitFunction
	If Patrn = "" Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	With RegExp
		.Global = bGlobal
		.IgnoreCase = IgnoreCase
		.Pattern = Patrn
		Set Matches = .Execute(textStr)
	End With
	If Matches.Count = 0 Then Exit Function
	If MatchID < 0 Then MatchID = Matches.Count - 1
	If SubMatchID < 0 Then
		GetSubStringRegExp = Matches(MatchID).Value
	Else
		GetSubStringRegExp = Matches(MatchID).SubMatches(SubMatchID)
	End If
	ExitFunction:
End Function


'ִΪִΪ Join Ч̫
'Mode = False  Join ʽӣ治ӷӷ
Public Function StrListJoin(StrArray() As String,Optional ByVal Sep As String = " ",Optional ByVal Mode As Boolean) As String
	Dim i As Long,j As Long,sb As Object
	On Error GoTo ExitFunction
	Set sb = CreateObject("System.Text.StringBuilder")
	j = UBound(StrArray)
	If Mode = False Then
		For i = 0 To j
			If i < j Then
				sb.AppendFormat("{0}",StrArray(i) & Sep)
			Else
				sb.AppendFormat("{0}",StrArray(i))
			End If
		Next i
	Else
		For i = 0 To j
			sb.AppendFormat("{0}",StrArray(i) & Sep)
		Next i
	End If
	StrListJoin = sb.ToString()
	Set sb = Nothing
	Exit Function
	ExitFunction:
	Set sb = Nothing
	On Error GoTo errHandle
	StrListJoin = Join$(StrArray,Sep)
	errHandle:
End Function


' wTimes ȴʱѯ״̬
'tValue ΪĿֵ wTimes = 0 ʱΪĬϵȴʱ
Public Function OnReadyStateChange(xmlHttp As Object,ByVal tValue As Long,wTimes As Long) As Long
	Dim StartTime As Long
	StartTime = Timer
	If wTimes = 0 Then wTimes = DefaultWaitTimes
	OnReadyStateChange = xmlHttp.readyState
	Do While OnReadyStateChange < tValue
		OnReadyStateChange = xmlHttp.readyState
		If (Timer - StartTime) > wTimes Then Exit Do
	Loop
End Function


'תΪָʽַ
Public Function BytesToBstr(strBody As Variant,ByVal outCode As String) As String
	Dim objStream As Object
	If LenB(strBody) = 0 Or outCode = "" Then Exit Function
	On Error GoTo ErrorMsg
	Set objStream = CreateObject("Adodb.Stream")
	If Not objStream Is Nothing Then
		With objStream
			.Type = 1
			.Mode = 3
			.Open
			.Write strBody
			.Position = 0
			.Type = 2
			.Charset = outCode
			BytesToBstr = .ReadText
			.Close
		End With
		Set objStream = Nothing
	End If
	Exit Function
	ErrorMsg:
	Err.Source = "Adodb.Stream"
	Call sysErrorMassage(Err,1)
End Function


'дݵļ
Public Function BytesToFile(strBody As Variant,ByVal File As String) As Boolean
	Dim objStream As Object
	BytesToFile = False
	If LenB(strBody) = 0 Or File = "" Then Exit Function
	On Error GoTo ErrorMsg
	Set objStream = CreateObject("Adodb.Stream")
	If Not objStream Is Nothing Then
		With objStream
			.Type = 1
			.Mode = 3
			.Open
			.Write(strBody)
			.Position = 0
			.SaveToFile File,2
			.Flush
			.Close
		End With
		Set objStream = Nothing
		BytesToFile = True
	End If
	Exit Function
	ErrorMsg:
	Err.Source = "Adodb.Stream"
	Call sysErrorMassage(Err,1)
End Function


'ȡȷ
Public Function StopProcess(ByVal KeyHwnd As Long) As Boolean
	If GetAsyncKeyState(KeyHwnd) < 0 Then
		'SendMessageLNG(ButtonHwnd,BM_SETSTATE,True,0)
		If MsgBox(StopMsg,vbYesNo+vbInformation,StopTitle) = vbNo Then Exit Function
	Else
		Exit Function
	End If
	' Esc ԻӦ˳
	EnableWindow KeyHwnd, False
	StopProcess = True
End Function


'ȥͱո
'Mode = 0 ȥֹݼеĶո񣬲ո
'Mode = 1 ȥеĶո񣬱һûпոʱ
'Mode = 2 ȥַַ֮Ķո񣬲ո
'Mode = 3 ȥӢĺַ֮Ķǰո񣬱һûпոʱ
'Mode = 4 ȥӢĺַ֮Ķո񣬱һûпոʱ
Public Function RemoveSpace(SpaceLength As Integer,ByVal textStr As String,ByVal Mode As Integer) As String
	RemoveSpace = textStr
	textStr = Trim$(textStr)
	If textStr = "" Then Exit Function
	Dim i As Long,Matches As Object
	On Error Resume Next
	With RegExp
		.Global = True
		.IgnoreCase = False
		Select Case Mode
		Case 0
			.Pattern = "([^\x20])(\x20+)([^\x20])"
			Set Matches = .Execute(RemoveSpace)
			If Matches.Count = 0 Then Exit Function
			For i = 0 To Matches.Count - 1
				If Len(Matches(i).SubMatches(1)) > 0 Then
					SpaceLength = SpaceLength - 1
					textStr = Matches(i).SubMatches(0) & Matches(i).SubMatches(2)
					RemoveSpace = Replace(RemoveSpace,Matches(i).Value,textStr,,1)
				End If
			Next i
		Case 1
			.Pattern = "([^\x20])(\x20{2,})([^\x20])"
			Set Matches = .Execute(RemoveSpace)
			If Matches.Count = 0 Then Exit Function
			For i = 0 To Matches.Count - 1
				If Len(Matches(i).SubMatches(1)) > 1 Then
					SpaceLength = SpaceLength - 1
					textStr = Matches(i).SubMatches(0) & " " & Matches(i).SubMatches(2)
					RemoveSpace = Replace(RemoveSpace,Matches(i).Value,textStr,,1)
				End If
			Next i
		Case 2
			.Pattern = "([\x21-\x40\x5B-\x60\x7B-\xBF])(\x20+)([\x21-\xFF])"
			Set Matches = .Execute(RemoveSpace)
			If Matches.Count > 0 Then
				SpaceLength = -1
				For i = 0 To Matches.Count - 1
					If Len(Matches(i).SubMatches(1)) > 0 Then
						SpaceLength = SpaceLength - 1
						textStr = Matches(i).SubMatches(0) & Matches(i).SubMatches(2)
						RemoveSpace = Replace(RemoveSpace,Matches(i).Value,textStr,,1)
					End If
				Next i
			End If
		Case 3
			.Pattern = "([\u0100-\u05FE\u0600-\uFFFF]+)(\x20*)([a-zA-Z0-9]{3,})"
			Set Matches = .Execute(RemoveSpace)
			If Matches.Count > 0 Then
				For i = 0 To Matches.Count - 1
					Select Case Len(Matches(i).SubMatches(1))
					Case Is > 1
						SpaceLength = SpaceLength - 1
						textStr = Matches(i).SubMatches(0) & " " & Matches(i).SubMatches(2)
						RemoveSpace = Replace(RemoveSpace,Matches(i).Value,textStr,,1)
					Case Is < 1
						SpaceLength = SpaceLength + 1
						textStr = Matches(i).SubMatches(0) & " " & Matches(i).SubMatches(2)
						RemoveSpace = Replace(RemoveSpace,Matches(i).Value,textStr,,1)
					End Select
				Next i
			End If
		Case 4
			.Pattern = "([a-zA-Z0-9]{3,})(\x20*)([\u0100-\u05FE\u0600-\uFFFF]+)"
			Set Matches = .Execute(RemoveSpace)
			If Matches.Count > 0 Then
				For i = 0 To Matches.Count - 1
					Select Case Len(Matches(i).SubMatches(1))
					Case Is > 1
						SpaceLength = SpaceLength - 1
						textStr = Matches(i).SubMatches(0) & " " & Matches(i).SubMatches(2)
						RemoveSpace = Replace(RemoveSpace,Matches(i).Value,textStr,,1)
					Case Is < 1
						SpaceLength = SpaceLength + 1
						textStr = Matches(i).SubMatches(0) & " " & Matches(i).SubMatches(2)
						RemoveSpace = Replace(RemoveSpace,Matches(i).Value,textStr,,1)
					End Select
				Next i
			End If
		End Select
	End With
End Function
